=== modified file 'DRIZZLE.FAQ'
--- DRIZZLE.FAQ	2008-07-20 05:41:52 +0000
+++ DRIZZLE.FAQ	2008-07-20 08:25:29 +0000
@@ -5,19 +5,26 @@
 I've been wondering for a long time now about all of the changes post 4.1.
 I believe there is a large market of users who never wanted them, and never
 cared for them. I also wanted to question the foundations of what we built.
-Do uses want wrong data? How often is the query cache really valuable? If
+Do users want wrong data? How often is the query cache really valuable? If
 everyone just has a root user with all privs, why carry the baggage of the
 ACL code. Etc.
 
 * What is the goal?
 
 A micro-kernel that we then extend to add what we need (all additions come
-through interfaces that can be compiled/loaded in as needed). 
-
-* So the differences?
-
-No modes, views, triggers, stored procedures, query cache, data conversion inserts,
-ACL. Less engines, less code. Assume the primary engine is transactional. 
+through interfaces that can be compiled/loaded in as needed).  The target
+for the project is web infrastructure backend and cloud components. 
+
+* Is this a product of Sun/MySQL?
+
+No, though several of the authors do work for Sun/MySQL. The development model is
+one based around open collaboration.  Drizzle's license is the GPL v2.
+
+* So what are the differences between is and MySQL?
+
+No modes, views, triggers, prepared statements, stored procedures, query cache, 
+data conversion inserts, ACL. Fewer data types.  Less engines, less code. 
+Assume the primary engine is transactional.
 
 * Why now?
 
@@ -61,15 +68,16 @@
 
 * Can I get involved?
 
-Most certainly. There is plenty to do from refactoring code, design of intereface, 
-to documentation, etc... The best way to get involved it to join the mailing
-list at:
+Most certainly. There is plenty to do from refactoring code, design of interfaces, 
+documentation and blueprints, etc... The best way to get involved it to join the 
+mailing list at:
+
 https://launchpad.net/~drizzle-discuss/
 
 If you wish to suggest a refactoring project or an interface please email
 the mailing list and keep an open mind. Do not expect anyone will work on
 your idea though, you may influence someone to do that, but more then likely
-you will need to rollup your sleaves and write some code. For very simple
+you will need to rollup your sleeves and write some code. For very simple
 bits you are welcome to ask others on #drizzle on Freenode, but please be
 aware that you may be asked to email the mailing list. 
 
@@ -82,9 +90,9 @@
 requirements to review your code. This system is based entirely on trust,
 and individuals who have shown that they can provide three good patches gain
 credibility. Starting small is fine, patches that are just comments or are
-event two or three line cleanups are welcome and encouraged. I would really
-recommend anyone who wants to work on something start with something of this
-size. Patches like these are valuable and they teach you how to work with
+even two or three line cleanups are welcome and encouraged. I would really
+recommend that anyone who wants to work on something first start with something 
+of this size. Patches like these are valuable and teach you how to work with
 the system.
 
 The general rule is no new code in the core of the server, and any changes
@@ -98,10 +106,11 @@
 * What is the coding style?
 
 Please look here:
+
 https://blueprints.launchpad.net/drizzle/+spec/style-cleanup
 
 If you have a question on this, please email the mailing list so that we can
-clarifying the document. And when you get the answer? Please update the code
+clarify the document. And when you get the answer? Please update the code
 style document :)
 
 * Should I email the mailing list with patches?
@@ -116,7 +125,9 @@
 Deliver a microkernel that we can use to build a database that meets the
 needs of a web/cloud infrastructure. To this end we are exploring http
 interfaces, sharding enhancements, etc... do not expect an Oracle, MySQL,
-Postgres, or DB2. There is no GA date at the moment.
+Postgres, or DB2. 
+
+There is no GA date at the moment.
 
 We are focusing on multi-core architecture. This is not designed to run on a
 wrist watch (hint, go use SQLite). We support both 32bit and 64bit but the
@@ -125,19 +136,13 @@
 
 * Can I run a website with this?
 
-No. We are stil making incompatible changes, and I certainly do not believe
+No. We are still making incompatible changes, and I certainly do not believe
 the code is production quality. Right now we are defaulting many configure
 operations to generate debugging code for us so our binaries are not
-optimum, so do not got out and benchmark this and expect it to be one way or
+optimal.  Therefore, do not go out and benchmark this and expect it to be one way or
 the other. We are currently only doing benchmarks where it makes sense for
 us to determine where bottlenecks are.
 
-* And what is the license?
-
-Drizzle inherits its license from MySQL's GPL. Any libraries not connected
-to this are licensed under their own distribution license. All source files
-are clearly idenified.
-
 * Why drizzle?
 
 I am from Seattle. Drizzle is our normal form of "rain" but it is not "rain",

=== modified file 'client/Makefile.am'
--- client/Makefile.am	2008-07-15 20:24:05 +0000
+++ client/Makefile.am	2008-07-22 05:29:20 +0000
@@ -35,7 +35,7 @@
 				mysqlslap 
 
 drizzle_SOURCES =		drizzle.c readline.c completion_hash.c
-drizzle_LDADD =			-lreadline @TERMCAP_LIB@ $(GLIB_LIBS) \
+drizzle_LDADD =			$(READLINE_LIBS) $(TERMCAP_LIBS) $(GLIB_LIBS) \
 				$(LDADD) $(CXXLDFLAGS)
 drizzle_CPPFLAGS = 		$(AM_CPPFLAGS) $(GLIB_CFLAGS)
 drizzleadmin_SOURCES =		drizzleadmin.cc
@@ -56,8 +56,8 @@
 mysqlslap_CFLAGS=		-DTHREAD -UUNDEF_THREADS_HACK
 
 drizzletest_SOURCES=		drizzletest.cc 
-drizzletest_LDADD =		${LDADD} @PCRE_LIBS@
-drizzletest_CFLAGS = 		${AM_CPPFLAGS} @PCRE_CFLAGS@
+drizzletest_LDADD =		${LDADD} $(PCRE_LIBS)
+drizzletest_CFLAGS = 		${AM_CPPFLAGS} $(PCRE_CFLAGS)
 
 # Fix for mit-threads
 DEFS =			-DUNDEF_THREADS_HACK \

=== modified file 'configure.ac'
--- configure.ac	2008-07-19 21:15:52 +0000
+++ configure.ac	2008-07-22 05:48:51 +0000
@@ -290,7 +290,12 @@
 then
   AC_MSG_ERROR([Couldn't find event.h. Try installing libevent development packages])
 fi
+my_save_LIBS="$LIBS"
+LIBS=""
 AC_CHECK_LIB(event, event_loop, [], [AC_MSG_ERROR(could not find libevent)])
+LIBEVENT_LIBS="${LIBS}"
+LIBS="${my_save_LIBS}"
+AC_SUBST(LIBEVENT_LIBS)
 
 #--------------------------------------------------------------------
 # Check for libpthread
@@ -322,12 +327,18 @@
 # Check for libz
 #--------------------------------------------------------------------
 
+my_save_LIBS="$LIBS"
+LIBS=""
 AC_CHECK_HEADERS(zlib.h)
 if test "x$ac_cv_header_zlib_h" != "xyes"
 then
   AC_MSG_ERROR([Couldn't find zlib.h. Try installing zlib development packages])
 fi
 AC_CHECK_LIB(z, crc32, [], [AC_MSG_ERROR(could not find libz)])
+ZLIB_LIBS="$LIBS"
+LIBS="$my_save_LIBS"
+AC_SUBST(ZLIB_LIBS)
+
 
 
 AC_CHECK_HEADERS([readline/readline.h])
@@ -335,6 +346,12 @@
 then
   AC_MSG_ERROR([Couldn't find readline/readline.h. Try installing readline development packages.])
 fi
+my_save_LIBS="$LIBS"
+LIBS=""
+AC_CHECK_LIB(readline, rl_completion_matches, [], [AC_MSG_ERROR(Couldn't find libreadline.)])
+READLINE_LIBS="$LIBS"
+LIBS="$my_save_LIBS"
+AC_SUBST(READLINE_LIBS)
 
 #--------------------------------------------------------------------
 # Check for libpcre
@@ -668,9 +685,9 @@
 then
   AC_MSG_ERROR([Drizzle requires dlopen])
 fi
-LIBDL=$LIBS
+LIBDL_LIBS="$LIBS"
 LIBS="$my_save_LIBS"
-AC_SUBST(LIBDL)
+AC_SUBST(LIBDL_LIBS)
 
 AC_CHECK_FUNCS(strtok_r)
 
@@ -713,6 +730,23 @@
 CFLAGS="${SYMBOLS_CFLAGS} ${CFLAGS}"
 CXXFLAGS="${SYMBOLS_CXXFLAGS} ${CXXFLAGS}"
 
+AC_ARG_WITH([debug],
+    [AS_HELP_STRING([--with-debug],
+       [Add debug code/turns off optimizations (yes|no) @<:@default=no@:>@])],
+    [with_debug=$withval],
+    [with_debug=no])
+if test "$with_debug" = "yes"
+then
+  # Medium debug.
+  CFLAGS="$DEBUG_OPTIMIZE_CC $CFLAGS"
+  CXXFLAGS="$DEBUG_OPTIMIZE_CXX $CXXFLAGS"
+else
+  # Optimized version. No debug
+  CFLAGS="$OPTIMIZE_CFLAGS $CFLAGS"
+  CXXFLAGS="$OPTIMIZE_CXXFLAGS $CXXFLAGS"
+fi
+
+
 AC_ARG_WITH([fast-mutexes],
     [AS_HELP_STRING([--with-fast-mutexes],
 	    [Compile with fast mutexes  @<:@default=off@:>@])],
@@ -878,9 +912,9 @@
 then
   MYSQL_CHECK_LIB_TERMCAP
 else
-  TERMCAP_LIB="$with_named_curses"
+  TERMCAP_LIBS="$with_named_curses"
 fi
-AC_SUBST(TERMCAP_LIB)
+AC_SUBST(TERMCAP_LIBS)
 
 # Check if the termcap function 'tgoto' is already declared in
 # system header files or if it need to be declared locally

=== modified file 'server/Makefile.am'
--- server/Makefile.am	2008-07-19 06:41:41 +0000
+++ server/Makefile.am	2008-07-20 08:25:29 +0000
@@ -27,9 +27,7 @@
 
 AM_CPPFLAGS =-I$(top_builddir)/include \
 	     -I$(top_srcdir)/include \
-	     -I$(srcdir) $(openssl_includes) \
-	     $(libevent_includes) \
-	     -ggdb
+	     -I$(srcdir) $(openssl_includes) 
 
 SUBDIRS =. share
 
@@ -55,12 +53,11 @@
 
 noinst_LTLIBRARIES = libhandler.la
 
-SUPPORTING_LIBS = $(top_builddir)/vio/libviolt.la \
-		  $(top_builddir)/libdrizzle/libsqlcommon.la \
-		  $(top_builddir)/mysys/libmysyslt.la \
-		  $(top_builddir)/strings/libmystringslt.la 
-
-LDADD = $(SUPPORTING_LIBS) -lz -levent
+LDADD = $(top_builddir)/vio/libviolt.la \
+	$(top_builddir)/libdrizzle/libsqlcommon.la \
+	$(top_builddir)/mysys/libmysyslt.la \
+	$(top_builddir)/strings/libmystringslt.la \
+	$(ZLIB_LIBS)
 
 drizzled_LDADD = libhandler.la \
 		 $(top_builddir)/libdrizzle/libdrizzle.la \
@@ -68,7 +65,7 @@
 		 @mysql_plugin_libs@ \
 		 $(LDADD) \
 		 $(CXXLDFLAGS) \
-		 @LIBDL@
+		 $(LIBDL_LIBS) $(LIBEVENT_LIBS)
 
 noinst_HEADERS = item.h \
 		 item_func.h \
@@ -89,6 +86,21 @@
 		 unireg.h \
 		 sql_error.h \
 		 field.h \
+		 field/blob.h \
+		 field/null.h \
+		 field/datetime.h \
+		 field/timetype.h \
+		 field/timestamp.h \
+     field/date.h \
+     field/year.h \
+		 field/short.h \
+		 field/long.h \
+		 field/int64_t.h \
+		 field/decimal.h \
+		 field/double.h \
+		 field/string.h \
+		 field/varstring.h \
+		 field/set.h \
 		 handler.h \
 		 mysqld_suffix.h \
 		 rpl_constants.h \
@@ -139,6 +151,21 @@
 		   item_subselect.cc \
 		   item_row.cc \
 		   field.cc \
+			 field/blob.cc \
+			 field/null.cc \
+			 field/datetime.cc \
+			 field/timetype.cc \
+			 field/timestamp.cc \
+       field/date.cc \
+       field/year.cc \
+			 field/short.cc \
+			 field/long.cc \
+			 field/int64_t.cc \
+			 field/decimal.cc \
+			 field/double.cc \
+			 field/string.cc \
+			 field/varstring.cc \
+			 field/set.cc \
 		   strfunc.cc \
 		   key.cc \
 		   sql_class.cc \

=== added directory 'server/field'
=== modified file 'server/field.cc'
--- server/field.cc	2008-07-16 18:48:24 +0000
+++ server/field.cc	2008-07-22 05:25:22 +0000
@@ -42,14 +42,6 @@
 template class List_iterator<Create_field>;
 #endif
 
-uchar Field_null::null[1]={1};
-const char field_separator=',';
-
-#define DOUBLE_TO_STRING_CONVERSION_BUFFER_SIZE FLOATING_POINT_BUFFER
-#define LONGLONG_TO_STRING_CONVERSION_BUFFER_SIZE 128
-#define DECIMAL_TO_STRING_CONVERSION_BUFFER_SIZE 128
-#define BLOB_PACK_LENGTH_TO_MAX_LENGH(arg) \
-((ulong) ((1LL << min(arg, 4) * 8) - 1LL))
 
 /*
   Rules for merging different types of fields in UNION
@@ -1504,436 +1496,6 @@
 
 
 /****************************************************************************
-  Field_null, a field that always return NULL
-****************************************************************************/
-
-void Field_null::sql_type(String &res) const
-{
-  res.set_ascii(STRING_WITH_LEN("null"));
-}
-
-
-/****************************************************************************
-** Field_new_decimal
-****************************************************************************/
-
-Field_new_decimal::Field_new_decimal(uchar *ptr_arg,
-                                     uint32 len_arg, uchar *null_ptr_arg,
-                                     uchar null_bit_arg,
-                                     enum utype unireg_check_arg,
-                                     const char *field_name_arg,
-                                     uint8 dec_arg,bool zero_arg,
-                                     bool unsigned_arg)
-  :Field_num(ptr_arg, len_arg, null_ptr_arg, null_bit_arg,
-             unireg_check_arg, field_name_arg, dec_arg, zero_arg, unsigned_arg)
-{
-  precision= my_decimal_length_to_precision(len_arg, dec_arg, unsigned_arg);
-  set_if_smaller(precision, DECIMAL_MAX_PRECISION);
-  assert((precision <= DECIMAL_MAX_PRECISION) &&
-              (dec <= DECIMAL_MAX_SCALE));
-  bin_size= my_decimal_get_binary_size(precision, dec);
-}
-
-
-Field_new_decimal::Field_new_decimal(uint32 len_arg,
-                                     bool maybe_null_arg,
-                                     const char *name,
-                                     uint8 dec_arg,
-                                     bool unsigned_arg)
-  :Field_num((uchar*) 0, len_arg,
-             maybe_null_arg ? (uchar*) "": 0, 0,
-             NONE, name, dec_arg, 0, unsigned_arg)
-{
-  precision= my_decimal_length_to_precision(len_arg, dec_arg, unsigned_arg);
-  set_if_smaller(precision, DECIMAL_MAX_PRECISION);
-  assert((precision <= DECIMAL_MAX_PRECISION) &&
-              (dec <= DECIMAL_MAX_SCALE));
-  bin_size= my_decimal_get_binary_size(precision, dec);
-}
-
-
-int Field_new_decimal::reset(void)
-{
-  store_value(&decimal_zero);
-  return 0;
-}
-
-
-/**
-  Generate max/min decimal value in case of overflow.
-
-  @param decimal_value     buffer for value
-  @param sign              sign of value which caused overflow
-*/
-
-void Field_new_decimal::set_value_on_overflow(my_decimal *decimal_value,
-                                              bool sign)
-{
-  max_my_decimal(decimal_value, precision, decimals());
-  if (sign)
-  {
-    if (unsigned_flag)
-      my_decimal_set_zero(decimal_value);
-    else
-      decimal_value->sign(true);
-  }
-  return;
-}
-
-
-/**
-  Store decimal value in the binary buffer.
-
-  Checks if decimal_value fits into field size.
-  If it does, stores the decimal in the buffer using binary format.
-  Otherwise sets maximal number that can be stored in the field.
-
-  @param decimal_value   my_decimal
-
-  @retval
-    0 ok
-  @retval
-    1 error
-*/
-
-bool Field_new_decimal::store_value(const my_decimal *decimal_value)
-{
-  int error= 0;
-
-  /* check that we do not try to write negative value in unsigned field */
-  if (unsigned_flag && decimal_value->sign())
-  {
-    set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
-    error= 1;
-    decimal_value= &decimal_zero;
-  }
-
-  if (warn_if_overflow(my_decimal2binary(E_DEC_FATAL_ERROR & ~E_DEC_OVERFLOW,
-                                         decimal_value, ptr, precision, dec)))
-  {
-    my_decimal buff;
-    set_value_on_overflow(&buff, decimal_value->sign());
-    my_decimal2binary(E_DEC_FATAL_ERROR, &buff, ptr, precision, dec);
-    error= 1;
-  }
-  return(error);
-}
-
-
-int Field_new_decimal::store(const char *from, uint length,
-                             CHARSET_INFO *charset_arg)
-{
-  int err;
-  my_decimal decimal_value;
-
-  if ((err= str2my_decimal(E_DEC_FATAL_ERROR &
-                           ~(E_DEC_OVERFLOW | E_DEC_BAD_NUM),
-                           from, length, charset_arg,
-                           &decimal_value)) &&
-      table->in_use->abort_on_warning)
-  {
-    /* Because "from" is not NUL-terminated and we use %s in the ER() */
-    String from_as_str;
-    from_as_str.copy(from, length, &my_charset_bin);
-
-    push_warning_printf(table->in_use, MYSQL_ERROR::WARN_LEVEL_ERROR,
-                        ER_TRUNCATED_WRONG_VALUE_FOR_FIELD,
-                        ER(ER_TRUNCATED_WRONG_VALUE_FOR_FIELD),
-                        "decimal", from_as_str.c_ptr(), field_name,
-                        (ulong) table->in_use->row_count);
-
-    return(err);
-  }
-
-  switch (err) {
-  case E_DEC_TRUNCATED:
-    set_warning(MYSQL_ERROR::WARN_LEVEL_NOTE, WARN_DATA_TRUNCATED, 1);
-    break;
-  case E_DEC_OVERFLOW:
-    set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
-    set_value_on_overflow(&decimal_value, decimal_value.sign());
-    break;
-  case E_DEC_BAD_NUM:
-    {
-      /* Because "from" is not NUL-terminated and we use %s in the ER() */
-      String from_as_str;
-      from_as_str.copy(from, length, &my_charset_bin);
-
-    push_warning_printf(table->in_use, MYSQL_ERROR::WARN_LEVEL_WARN,
-                        ER_TRUNCATED_WRONG_VALUE_FOR_FIELD,
-                        ER(ER_TRUNCATED_WRONG_VALUE_FOR_FIELD),
-                          "decimal", from_as_str.c_ptr(), field_name,
-                        (ulong) table->in_use->row_count);
-    my_decimal_set_zero(&decimal_value);
-
-    break;
-    }
-  }
-
-  store_value(&decimal_value);
-  return(err);
-}
-
-
-/**
-  @todo
-  Fix following when double2my_decimal when double2decimal
-  will return E_DEC_TRUNCATED always correctly
-*/
-
-int Field_new_decimal::store(double nr)
-{
-  my_decimal decimal_value;
-  int err;
-
-  err= double2my_decimal(E_DEC_FATAL_ERROR & ~E_DEC_OVERFLOW, nr,
-                         &decimal_value);
-  if (err)
-  {
-    if (check_overflow(err))
-      set_value_on_overflow(&decimal_value, decimal_value.sign());
-    /* Only issue a warning if store_value doesn't issue an warning */
-    table->in_use->got_warning= 0;
-  }
-  if (store_value(&decimal_value))
-    err= 1;
-  else if (err && !table->in_use->got_warning)
-    err= warn_if_overflow(err);
-  return(err);
-}
-
-
-int Field_new_decimal::store(int64_t nr, bool unsigned_val)
-{
-  my_decimal decimal_value;
-  int err;
-
-  if ((err= int2my_decimal(E_DEC_FATAL_ERROR & ~E_DEC_OVERFLOW,
-                           nr, unsigned_val, &decimal_value)))
-  {
-    if (check_overflow(err))
-      set_value_on_overflow(&decimal_value, decimal_value.sign());
-    /* Only issue a warning if store_value doesn't issue an warning */
-    table->in_use->got_warning= 0;
-  }
-  if (store_value(&decimal_value))
-    err= 1;
-  else if (err && !table->in_use->got_warning)
-    err= warn_if_overflow(err);
-  return err;
-}
-
-
-int Field_new_decimal::store_decimal(const my_decimal *decimal_value)
-{
-  return store_value(decimal_value);
-}
-
-
-int Field_new_decimal::store_time(MYSQL_TIME *ltime,
-                                  timestamp_type t_type __attribute__((__unused__)))
-{
-    my_decimal decimal_value;
-    return store_value(date2my_decimal(ltime, &decimal_value));
-}
-
-
-double Field_new_decimal::val_real(void)
-{
-  double dbl;
-  my_decimal decimal_value;
-  my_decimal2double(E_DEC_FATAL_ERROR, val_decimal(&decimal_value), &dbl);
-  return dbl;
-}
-
-
-int64_t Field_new_decimal::val_int(void)
-{
-  int64_t i;
-  my_decimal decimal_value;
-  my_decimal2int(E_DEC_FATAL_ERROR, val_decimal(&decimal_value),
-                 unsigned_flag, &i);
-  return i;
-}
-
-
-my_decimal* Field_new_decimal::val_decimal(my_decimal *decimal_value)
-{
-  binary2my_decimal(E_DEC_FATAL_ERROR, ptr, decimal_value,
-                    precision, dec);
-  return(decimal_value);
-}
-
-
-String *Field_new_decimal::val_str(String *val_buffer,
-                                   String *val_ptr __attribute__((unused)))
-{
-  my_decimal decimal_value;
-  uint fixed_precision= zerofill ? precision : 0;
-  my_decimal2string(E_DEC_FATAL_ERROR, val_decimal(&decimal_value),
-                    fixed_precision, dec, '0', val_buffer);
-  return val_buffer;
-}
-
-
-int Field_new_decimal::cmp(const uchar *a,const uchar*b)
-{
-  return memcmp(a, b, bin_size);
-}
-
-
-void Field_new_decimal::sort_string(uchar *buff,
-                                    uint length __attribute__((unused)))
-{
-  memcpy(buff, ptr, bin_size);
-}
-
-
-void Field_new_decimal::sql_type(String &str) const
-{
-  CHARSET_INFO *cs= str.charset();
-  str.length(cs->cset->snprintf(cs, (char*) str.ptr(), str.alloced_length(),
-                                "decimal(%d,%d)", precision, (int)dec));
-  add_zerofill_and_unsigned(str);
-}
-
-
-/**
-   Save the field metadata for new decimal fields.
-
-   Saves the precision in the first byte and decimals() in the second
-   byte of the field metadata array at index of *metadata_ptr and 
-   *(metadata_ptr + 1).
-
-   @param   metadata_ptr   First byte of field metadata
-
-   @returns number of bytes written to metadata_ptr
-*/
-int Field_new_decimal::do_save_field_metadata(uchar *metadata_ptr)
-{
-  *metadata_ptr= precision;
-  *(metadata_ptr + 1)= decimals();
-  return 2;
-}
-
-
-/**
-   Returns the number of bytes field uses in row-based replication 
-   row packed size.
-
-   This method is used in row-based replication to determine the number
-   of bytes that the field consumes in the row record format. This is
-   used to skip fields in the master that do not exist on the slave.
-
-   @param   field_metadata   Encoded size in field metadata
-
-   @returns The size of the field based on the field metadata.
-*/
-uint Field_new_decimal::pack_length_from_metadata(uint field_metadata)
-{
-  uint const source_precision= (field_metadata >> 8U) & 0x00ff;
-  uint const source_decimal= field_metadata & 0x00ff; 
-  uint const source_size= my_decimal_get_binary_size(source_precision, 
-                                                     source_decimal);
-  return (source_size);
-}
-
-
-/**
-   Check to see if field size is compatible with destination.
-
-   This method is used in row-based replication to verify that the slave's
-   field size is less than or equal to the master's field size. The 
-   encoded field metadata (from the master or source) is decoded and compared
-   to the size of this field (the slave or destination). 
-
-   @param   field_metadata   Encoded size in field metadata
-
-   @retval 0 if this field's size is < the source field's size
-   @retval 1 if this field's size is >= the source field's size
-*/
-int Field_new_decimal::compatible_field_size(uint field_metadata)
-{
-  int compatible= 0;
-  uint const source_precision= (field_metadata >> 8U) & 0x00ff;
-  uint const source_decimal= field_metadata & 0x00ff; 
-  uint const source_size= my_decimal_get_binary_size(source_precision, 
-                                                     source_decimal);
-  uint const destination_size= row_pack_length();
-  compatible= (source_size <= destination_size);
-  if (compatible)
-    compatible= (source_precision <= precision) &&
-                (source_decimal <= decimals());
-  return (compatible);
-}
-
-
-uint Field_new_decimal::is_equal(Create_field *new_field)
-{
-  return ((new_field->sql_type == real_type()) &&
-          ((new_field->flags & UNSIGNED_FLAG) == 
-           (uint) (flags & UNSIGNED_FLAG)) &&
-          ((new_field->flags & AUTO_INCREMENT_FLAG) ==
-           (uint) (flags & AUTO_INCREMENT_FLAG)) &&
-          (new_field->length == max_display_length()) &&
-          (new_field->decimals == dec));
-}
-
-
-/**
-   Unpack a decimal field from row data.
-
-   This method is used to unpack a decimal or numeric field from a master
-   whose size of the field is less than that of the slave.
-  
-   @param   to         Destination of the data
-   @param   from       Source of the data
-   @param   param_data Precision (upper) and decimal (lower) values
-
-   @return  New pointer into memory based on from + length of the data
-*/
-const uchar *
-Field_new_decimal::unpack(uchar* to,
-                          const uchar *from,
-                          uint param_data,
-                          bool low_byte_first)
-{
-  if (param_data == 0)
-    return Field::unpack(to, from, param_data, low_byte_first);
-
-  uint from_precision= (param_data & 0xff00) >> 8U;
-  uint from_decimal= param_data & 0x00ff;
-  uint length=pack_length();
-  uint from_pack_len= my_decimal_get_binary_size(from_precision, from_decimal);
-  uint len= (param_data && (from_pack_len < length)) ?
-            from_pack_len : length;
-  if ((from_pack_len && (from_pack_len < length)) ||
-      (from_precision < precision) ||
-      (from_decimal < decimals()))
-  {
-    /*
-      If the master's data is smaller than the slave, we need to convert
-      the binary to decimal then resize the decimal converting it back to
-      a decimal and write that to the raw data buffer.
-    */
-    decimal_digit_t dec_buf[DECIMAL_MAX_PRECISION];
-    decimal_t dec;
-    dec.len= from_precision;
-    dec.buf= dec_buf;
-    /*
-      Note: bin2decimal does not change the length of the field. So it is
-      just the first step the resizing operation. The second step does the
-      resizing using the precision and decimals from the slave.
-    */
-    bin2decimal((uchar *)from, &dec, from_precision, from_decimal);
-    decimal2bin(&dec, to, precision, decimals());
-  }
-  else
-    memcpy(to, from, len); // Sizes are the same, just copy the data.
-  return from+len;
-}
-
-/****************************************************************************
 ** tiny int
 ****************************************************************************/
 
@@ -2102,2382 +1664,6 @@
   add_zerofill_and_unsigned(res);
 }
 
-/****************************************************************************
- Field type short int (2 byte)
-****************************************************************************/
-
-int Field_short::store(const char *from,uint len,CHARSET_INFO *cs)
-{
-  int store_tmp;
-  int error;
-  int64_t rnd;
-  
-  error= get_int(cs, from, len, &rnd, UINT16_MAX, INT16_MIN, INT16_MAX);
-  store_tmp= unsigned_flag ? (int) (uint64_t) rnd : (int) rnd;
-#ifdef WORDS_BIGENDIAN
-  if (table->s->db_low_byte_first)
-  {
-    int2store(ptr, store_tmp);
-  }
-  else
-#endif
-    shortstore(ptr, (short) store_tmp);
-  return error;
-}
-
-
-int Field_short::store(double nr)
-{
-  int error= 0;
-  int16 res;
-  nr=rint(nr);
-  if (unsigned_flag)
-  {
-    if (nr < 0)
-    {
-      res=0;
-      set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
-      error= 1;
-    }
-    else if (nr > (double) UINT16_MAX)
-    {
-      res=(int16) UINT16_MAX;
-      set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
-      error= 1;
-    }
-    else
-      res=(int16) (uint16) nr;
-  }
-  else
-  {
-    if (nr < (double) INT16_MIN)
-    {
-      res=INT16_MIN;
-      set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
-      error= 1;
-    }
-    else if (nr > (double) INT16_MAX)
-    {
-      res=INT16_MAX;
-      set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
-      error= 1;
-    }
-    else
-      res=(int16) (int) nr;
-  }
-#ifdef WORDS_BIGENDIAN
-  if (table->s->db_low_byte_first)
-  {
-    int2store(ptr,res);
-  }
-  else
-#endif
-    shortstore(ptr,res);
-  return error;
-}
-
-
-int Field_short::store(int64_t nr, bool unsigned_val)
-{
-  int error= 0;
-  int16 res;
-
-  if (unsigned_flag)
-  {
-    if (nr < 0L && !unsigned_val)
-    {
-      res=0;
-      set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
-      error= 1;
-    }
-    else if ((uint64_t) nr > (uint64_t) UINT16_MAX)
-    {
-      res=(int16) UINT16_MAX;
-      set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
-      error= 1;
-    }
-    else
-      res=(int16) (uint16) nr;
-  }
-  else
-  {
-    if (nr < 0 && unsigned_val)
-      nr= UINT16_MAX+1;                         // Generate overflow
-
-    if (nr < INT16_MIN)
-    {
-      res=INT16_MIN;
-      set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
-      error= 1;
-    }
-    else if (nr > (int64_t) INT16_MAX)
-    {
-      res=INT16_MAX;
-      set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
-      error= 1;
-    }
-    else
-      res=(int16) nr;
-  }
-#ifdef WORDS_BIGENDIAN
-  if (table->s->db_low_byte_first)
-  {
-    int2store(ptr,res);
-  }
-  else
-#endif
-    shortstore(ptr,res);
-  return error;
-}
-
-
-double Field_short::val_real(void)
-{
-  short j;
-#ifdef WORDS_BIGENDIAN
-  if (table->s->db_low_byte_first)
-    j=sint2korr(ptr);
-  else
-#endif
-    shortget(j,ptr);
-  return unsigned_flag ? (double) (unsigned short) j : (double) j;
-}
-
-int64_t Field_short::val_int(void)
-{
-  short j;
-#ifdef WORDS_BIGENDIAN
-  if (table->s->db_low_byte_first)
-    j=sint2korr(ptr);
-  else
-#endif
-    shortget(j,ptr);
-  return unsigned_flag ? (int64_t) (unsigned short) j : (int64_t) j;
-}
-
-
-String *Field_short::val_str(String *val_buffer,
-			     String *val_ptr __attribute__((unused)))
-{
-  CHARSET_INFO *cs= &my_charset_bin;
-  uint length;
-  uint mlength=max(field_length+1,7*cs->mbmaxlen);
-  val_buffer->alloc(mlength);
-  char *to=(char*) val_buffer->ptr();
-  short j;
-#ifdef WORDS_BIGENDIAN
-  if (table->s->db_low_byte_first)
-    j=sint2korr(ptr);
-  else
-#endif
-    shortget(j,ptr);
-
-  if (unsigned_flag)
-    length=(uint) cs->cset->long10_to_str(cs, to, mlength, 10, 
-					  (long) (uint16) j);
-  else
-    length=(uint) cs->cset->long10_to_str(cs, to, mlength,-10, (long) j);
-  val_buffer->length(length);
-  if (zerofill)
-    prepend_zeros(val_buffer);
-  return val_buffer;
-}
-
-
-bool Field_short::send_binary(Protocol *protocol)
-{
-  return protocol->store_short(Field_short::val_int());
-}
-
-
-int Field_short::cmp(const uchar *a_ptr, const uchar *b_ptr)
-{
-  short a,b;
-#ifdef WORDS_BIGENDIAN
-  if (table->s->db_low_byte_first)
-  {
-    a=sint2korr(a_ptr);
-    b=sint2korr(b_ptr);
-  }
-  else
-#endif
-  {
-    shortget(a,a_ptr);
-    shortget(b,b_ptr);
-  }
-
-  if (unsigned_flag)
-    return ((unsigned short) a < (unsigned short) b) ? -1 :
-    ((unsigned short) a > (unsigned short) b) ? 1 : 0;
-  return (a < b) ? -1 : (a > b) ? 1 : 0;
-}
-
-void Field_short::sort_string(uchar *to,uint length __attribute__((unused)))
-{
-#ifdef WORDS_BIGENDIAN
-  if (!table->s->db_low_byte_first)
-  {
-    if (unsigned_flag)
-      to[0] = ptr[0];
-    else
-      to[0] = (char) (ptr[0] ^ 128);		/* Revers signbit */
-    to[1]   = ptr[1];
-  }
-  else
-#endif
-  {
-    if (unsigned_flag)
-      to[0] = ptr[1];
-    else
-      to[0] = (char) (ptr[1] ^ 128);		/* Revers signbit */
-    to[1]   = ptr[0];
-  }
-}
-
-void Field_short::sql_type(String &res) const
-{
-  CHARSET_INFO *cs=res.charset();
-  res.length(cs->cset->snprintf(cs,(char*) res.ptr(),res.alloced_length(),
-			  "smallint(%d)",(int) field_length));
-  add_zerofill_and_unsigned(res);
-}
-
-
-/****************************************************************************
-** long int
-****************************************************************************/
-
-int Field_long::store(const char *from,uint len,CHARSET_INFO *cs)
-{
-  long store_tmp;
-  int error;
-  int64_t rnd;
-  
-  error= get_int(cs, from, len, &rnd, UINT32_MAX, INT32_MIN, INT32_MAX);
-  store_tmp= unsigned_flag ? (long) (uint64_t) rnd : (long) rnd;
-#ifdef WORDS_BIGENDIAN
-  if (table->s->db_low_byte_first)
-  {
-    int4store(ptr, store_tmp);
-  }
-  else
-#endif
-    longstore(ptr, store_tmp);
-  return error;
-}
-
-
-int Field_long::store(double nr)
-{
-  int error= 0;
-  int32 res;
-  nr=rint(nr);
-  if (unsigned_flag)
-  {
-    if (nr < 0)
-    {
-      res=0;
-      error= 1;
-    }
-    else if (nr > (double) UINT32_MAX)
-    {
-      res= INT32_MAX;
-      set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
-      error= 1;
-    }
-    else
-      res=(int32) (ulong) nr;
-  }
-  else
-  {
-    if (nr < (double) INT32_MIN)
-    {
-      res=(int32) INT32_MIN;
-      error= 1;
-    }
-    else if (nr > (double) INT32_MAX)
-    {
-      res=(int32) INT32_MAX;
-      error= 1;
-    }
-    else
-      res=(int32) (int64_t) nr;
-  }
-  if (error)
-    set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
-
-#ifdef WORDS_BIGENDIAN
-  if (table->s->db_low_byte_first)
-  {
-    int4store(ptr,res);
-  }
-  else
-#endif
-    longstore(ptr,res);
-  return error;
-}
-
-
-int Field_long::store(int64_t nr, bool unsigned_val)
-{
-  int error= 0;
-  int32 res;
-
-  if (unsigned_flag)
-  {
-    if (nr < 0 && !unsigned_val)
-    {
-      res=0;
-      error= 1;
-    }
-    else if ((uint64_t) nr >= (1LL << 32))
-    {
-      res=(int32) (uint32) ~0L;
-      error= 1;
-    }
-    else
-      res=(int32) (uint32) nr;
-  }
-  else
-  {
-    if (nr < 0 && unsigned_val)
-      nr= ((int64_t) INT32_MAX) + 1;           // Generate overflow
-    if (nr < (int64_t) INT32_MIN) 
-    {
-      res=(int32) INT32_MIN;
-      error= 1;
-    }
-    else if (nr > (int64_t) INT32_MAX)
-    {
-      res=(int32) INT32_MAX;
-      error= 1;
-    }
-    else
-      res=(int32) nr;
-  }
-  if (error)
-    set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
-
-#ifdef WORDS_BIGENDIAN
-  if (table->s->db_low_byte_first)
-  {
-    int4store(ptr,res);
-  }
-  else
-#endif
-    longstore(ptr,res);
-  return error;
-}
-
-
-double Field_long::val_real(void)
-{
-  int32 j;
-#ifdef WORDS_BIGENDIAN
-  if (table->s->db_low_byte_first)
-    j=sint4korr(ptr);
-  else
-#endif
-    longget(j,ptr);
-  return unsigned_flag ? (double) (uint32) j : (double) j;
-}
-
-int64_t Field_long::val_int(void)
-{
-  int32 j;
-  /* See the comment in Field_long::store(long long) */
-  assert(table->in_use == current_thd);
-#ifdef WORDS_BIGENDIAN
-  if (table->s->db_low_byte_first)
-    j=sint4korr(ptr);
-  else
-#endif
-    longget(j,ptr);
-  return unsigned_flag ? (int64_t) (uint32) j : (int64_t) j;
-}
-
-String *Field_long::val_str(String *val_buffer,
-			    String *val_ptr __attribute__((unused)))
-{
-  CHARSET_INFO *cs= &my_charset_bin;
-  uint length;
-  uint mlength=max(field_length+1,12*cs->mbmaxlen);
-  val_buffer->alloc(mlength);
-  char *to=(char*) val_buffer->ptr();
-  int32 j;
-#ifdef WORDS_BIGENDIAN
-  if (table->s->db_low_byte_first)
-    j=sint4korr(ptr);
-  else
-#endif
-    longget(j,ptr);
-
-  if (unsigned_flag)
-    length=cs->cset->long10_to_str(cs,to,mlength, 10,(long) (uint32)j);
-  else
-    length=cs->cset->long10_to_str(cs,to,mlength,-10,(long) j);
-  val_buffer->length(length);
-  if (zerofill)
-    prepend_zeros(val_buffer);
-  return val_buffer;
-}
-
-
-bool Field_long::send_binary(Protocol *protocol)
-{
-  return protocol->store_long(Field_long::val_int());
-}
-
-int Field_long::cmp(const uchar *a_ptr, const uchar *b_ptr)
-{
-  int32 a,b;
-#ifdef WORDS_BIGENDIAN
-  if (table->s->db_low_byte_first)
-  {
-    a=sint4korr(a_ptr);
-    b=sint4korr(b_ptr);
-  }
-  else
-#endif
-  {
-    longget(a,a_ptr);
-    longget(b,b_ptr);
-  }
-  if (unsigned_flag)
-    return ((uint32) a < (uint32) b) ? -1 : ((uint32) a > (uint32) b) ? 1 : 0;
-  return (a < b) ? -1 : (a > b) ? 1 : 0;
-}
-
-void Field_long::sort_string(uchar *to,uint length __attribute__((unused)))
-{
-#ifdef WORDS_BIGENDIAN
-  if (!table->s->db_low_byte_first)
-  {
-    if (unsigned_flag)
-      to[0] = ptr[0];
-    else
-      to[0] = (char) (ptr[0] ^ 128);		/* Revers signbit */
-    to[1]   = ptr[1];
-    to[2]   = ptr[2];
-    to[3]   = ptr[3];
-  }
-  else
-#endif
-  {
-    if (unsigned_flag)
-      to[0] = ptr[3];
-    else
-      to[0] = (char) (ptr[3] ^ 128);		/* Revers signbit */
-    to[1]   = ptr[2];
-    to[2]   = ptr[1];
-    to[3]   = ptr[0];
-  }
-}
-
-
-void Field_long::sql_type(String &res) const
-{
-  CHARSET_INFO *cs=res.charset();
-  res.length(cs->cset->snprintf(cs,(char*) res.ptr(),res.alloced_length(),
-			  "int(%d)",(int) field_length));
-  add_zerofill_and_unsigned(res);
-}
-
-/****************************************************************************
- Field type int64_t int (8 bytes)
-****************************************************************************/
-
-int Field_int64_t::store(const char *from,uint len,CHARSET_INFO *cs)
-{
-  int error= 0;
-  char *end;
-  uint64_t tmp;
-
-  tmp= cs->cset->strntoull10rnd(cs,from,len,unsigned_flag,&end,&error);
-  if (error == MY_ERRNO_ERANGE)
-  {
-    set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
-    error= 1;
-  }
-  else if (table->in_use->count_cuted_fields && 
-           check_int(cs, from, len, end, error))
-    error= 1;
-  else
-    error= 0;
-#ifdef WORDS_BIGENDIAN
-  if (table->s->db_low_byte_first)
-  {
-    int8store(ptr,tmp);
-  }
-  else
-#endif
-    int64_tstore(ptr,tmp);
-  return error;
-}
-
-
-int Field_int64_t::store(double nr)
-{
-  int error= 0;
-  int64_t res;
-
-  nr= rint(nr);
-  if (unsigned_flag)
-  {
-    if (nr < 0)
-    {
-      res=0;
-      error= 1;
-    }
-    else if (nr >= (double) UINT64_MAX)
-    {
-      res= ~(int64_t) 0;
-      error= 1;
-    }
-    else
-      res=(int64_t) (uint64_t) nr;
-  }
-  else
-  {
-    if (nr <= (double) INT64_MIN)
-    {
-      res= INT64_MIN;
-      error= (nr < (double) INT64_MIN);
-    }
-    else if (nr >= (double) (uint64_t) INT64_MAX)
-    {
-      res= INT64_MAX;
-      error= (nr > (double) INT64_MAX);
-    }
-    else
-      res=(int64_t) nr;
-  }
-  if (error)
-    set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
-
-#ifdef WORDS_BIGENDIAN
-  if (table->s->db_low_byte_first)
-  {
-    int8store(ptr,res);
-  }
-  else
-#endif
-    int64_tstore(ptr,res);
-  return error;
-}
-
-
-int Field_int64_t::store(int64_t nr, bool unsigned_val)
-{
-  int error= 0;
-
-  if (nr < 0)                                   // Only possible error
-  {
-    /*
-      if field is unsigned and value is signed (< 0) or
-      if field is signed and value is unsigned we have an overflow
-    */
-    if (unsigned_flag != unsigned_val)
-    {
-      nr= unsigned_flag ? (uint64_t) 0 : (uint64_t) INT64_MAX;
-      set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
-      error= 1;
-    }
-  }
-
-#ifdef WORDS_BIGENDIAN
-  if (table->s->db_low_byte_first)
-  {
-    int8store(ptr,nr);
-  }
-  else
-#endif
-    int64_tstore(ptr,nr);
-  return error;
-}
-
-
-double Field_int64_t::val_real(void)
-{
-  int64_t j;
-#ifdef WORDS_BIGENDIAN
-  if (table->s->db_low_byte_first)
-  {
-    j=sint8korr(ptr);
-  }
-  else
-#endif
-    int64_tget(j,ptr);
-  /* The following is open coded to avoid a bug in gcc 3.3 */
-  if (unsigned_flag)
-  {
-    uint64_t tmp= (uint64_t) j;
-    return uint64_t2double(tmp);
-  }
-  return (double) j;
-}
-
-
-int64_t Field_int64_t::val_int(void)
-{
-  int64_t j;
-#ifdef WORDS_BIGENDIAN
-  if (table->s->db_low_byte_first)
-    j=sint8korr(ptr);
-  else
-#endif
-    int64_tget(j,ptr);
-  return j;
-}
-
-
-String *Field_int64_t::val_str(String *val_buffer,
-				String *val_ptr __attribute__((unused)))
-{
-  CHARSET_INFO *cs= &my_charset_bin;
-  uint length;
-  uint mlength=max(field_length+1,22*cs->mbmaxlen);
-  val_buffer->alloc(mlength);
-  char *to=(char*) val_buffer->ptr();
-  int64_t j;
-#ifdef WORDS_BIGENDIAN
-  if (table->s->db_low_byte_first)
-    j=sint8korr(ptr);
-  else
-#endif
-    int64_tget(j,ptr);
-
-  length=(uint) (cs->cset->int64_t10_to_str)(cs,to,mlength,
-					unsigned_flag ? 10 : -10, j);
-  val_buffer->length(length);
-  if (zerofill)
-    prepend_zeros(val_buffer);
-  return val_buffer;
-}
-
-
-bool Field_int64_t::send_binary(Protocol *protocol)
-{
-  return protocol->store_int64_t(Field_int64_t::val_int(), unsigned_flag);
-}
-
-
-int Field_int64_t::cmp(const uchar *a_ptr, const uchar *b_ptr)
-{
-  int64_t a,b;
-#ifdef WORDS_BIGENDIAN
-  if (table->s->db_low_byte_first)
-  {
-    a=sint8korr(a_ptr);
-    b=sint8korr(b_ptr);
-  }
-  else
-#endif
-  {
-    int64_tget(a,a_ptr);
-    int64_tget(b,b_ptr);
-  }
-  if (unsigned_flag)
-    return ((uint64_t) a < (uint64_t) b) ? -1 :
-    ((uint64_t) a > (uint64_t) b) ? 1 : 0;
-  return (a < b) ? -1 : (a > b) ? 1 : 0;
-}
-
-void Field_int64_t::sort_string(uchar *to,uint length __attribute__((unused)))
-{
-#ifdef WORDS_BIGENDIAN
-  if (!table->s->db_low_byte_first)
-  {
-    if (unsigned_flag)
-      to[0] = ptr[0];
-    else
-      to[0] = (char) (ptr[0] ^ 128);		/* Revers signbit */
-    to[1]   = ptr[1];
-    to[2]   = ptr[2];
-    to[3]   = ptr[3];
-    to[4]   = ptr[4];
-    to[5]   = ptr[5];
-    to[6]   = ptr[6];
-    to[7]   = ptr[7];
-  }
-  else
-#endif
-  {
-    if (unsigned_flag)
-      to[0] = ptr[7];
-    else
-      to[0] = (char) (ptr[7] ^ 128);		/* Revers signbit */
-    to[1]   = ptr[6];
-    to[2]   = ptr[5];
-    to[3]   = ptr[4];
-    to[4]   = ptr[3];
-    to[5]   = ptr[2];
-    to[6]   = ptr[1];
-    to[7]   = ptr[0];
-  }
-}
-
-
-void Field_int64_t::sql_type(String &res) const
-{
-  CHARSET_INFO *cs=res.charset();
-  res.length(cs->cset->snprintf(cs,(char*) res.ptr(),res.alloced_length(),
-			  "bigint(%d)",(int) field_length));
-  add_zerofill_and_unsigned(res);
-}
-
-
-/*
-  Floating-point numbers
- */
-
-uchar *
-Field_real::pack(uchar *to, const uchar *from,
-                 uint max_length, bool low_byte_first)
-{
-  assert(max_length >= pack_length());
-#ifdef WORDS_BIGENDIAN
-  if (low_byte_first != table->s->db_low_byte_first)
-  {
-    const uchar *dptr= from + pack_length();
-    while (dptr-- > from)
-      *to++ = *dptr;
-    return(to);
-  }
-  else
-#endif
-    return(Field::pack(to, from, max_length, low_byte_first));
-}
-
-const uchar *
-Field_real::unpack(uchar *to, const uchar *from,
-                   uint param_data, bool low_byte_first)
-{
-#ifdef WORDS_BIGENDIAN
-  if (low_byte_first != table->s->db_low_byte_first)
-  {
-    const uchar *dptr= from + pack_length();
-    while (dptr-- > from)
-      *to++ = *dptr;
-    return(from + pack_length());
-  }
-  else
-#endif
-    return(Field::unpack(to, from, param_data, low_byte_first));
-}
-
-/****************************************************************************
-  double precision floating point numbers
-****************************************************************************/
-
-int Field_double::store(const char *from,uint len,CHARSET_INFO *cs)
-{
-  int error;
-  char *end;
-  double nr= my_strntod(cs,(char*) from, len, &end, &error);
-  if (error || (!len || (((uint) (end-from) != len) && table->in_use->count_cuted_fields)))
-  {
-    set_warning(MYSQL_ERROR::WARN_LEVEL_WARN,
-                (error ? ER_WARN_DATA_OUT_OF_RANGE : WARN_DATA_TRUNCATED), 1);
-    error= error ? 1 : 2;
-  }
-  Field_double::store(nr);
-  return error;
-}
-
-
-int Field_double::store(double nr)
-{
-  int error= truncate(&nr, DBL_MAX);
-
-#ifdef WORDS_BIGENDIAN
-  if (table->s->db_low_byte_first)
-  {
-    float8store(ptr,nr);
-  }
-  else
-#endif
-    doublestore(ptr,nr);
-  return error;
-}
-
-
-int Field_double::store(int64_t nr, bool unsigned_val)
-{
-  return Field_double::store(unsigned_val ? uint64_t2double((uint64_t) nr) :
-                             (double) nr);
-}
-
-/*
-  If a field has fixed length, truncate the double argument pointed to by 'nr'
-  appropriately.
-  Also ensure that the argument is within [-max_value; max_value] range.
-*/
-
-int Field_real::truncate(double *nr, double max_value)
-{
-  int error= 1;
-  double res= *nr;
-  
-  if (isnan(res))
-  {
-    res= 0;
-    set_null();
-    set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
-    goto end;
-  }
-  else if (unsigned_flag && res < 0)
-  {
-    res= 0;
-    set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
-    goto end;
-  }
-
-  if (!not_fixed)
-  {
-    uint order= field_length - dec;
-    uint step= array_elements(log_10) - 1;
-    max_value= 1.0;
-    for (; order > step; order-= step)
-      max_value*= log_10[step];
-    max_value*= log_10[order];
-    max_value-= 1.0 / log_10[dec];
-
-    /* Check for infinity so we don't get NaN in calculations */
-    if (!my_isinf(res))
-    {
-      double tmp= rint((res - floor(res)) * log_10[dec]) / log_10[dec];
-      res= floor(res) + tmp;
-    }
-  }
-  
-  if (res < -max_value)
-  {
-   res= -max_value;
-   set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
-  }
-  else if (res > max_value)
-  {
-    res= max_value;
-    set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
-  }
-  else
-    error= 0;
-
-end:
-  *nr= res;
-  return error;
-}
-
-
-int Field_real::store_decimal(const my_decimal *dm)
-{
-  double dbl;
-  my_decimal2double(E_DEC_FATAL_ERROR, dm, &dbl);
-  return store(dbl);
-}
-
-double Field_double::val_real(void)
-{
-  double j;
-#ifdef WORDS_BIGENDIAN
-  if (table->s->db_low_byte_first)
-  {
-    float8get(j,ptr);
-  }
-  else
-#endif
-    doubleget(j,ptr);
-  return j;
-}
-
-int64_t Field_double::val_int(void)
-{
-  double j;
-  int64_t res;
-#ifdef WORDS_BIGENDIAN
-  if (table->s->db_low_byte_first)
-  {
-    float8get(j,ptr);
-  }
-  else
-#endif
-    doubleget(j,ptr);
-  /* Check whether we fit into int64_t range */
-  if (j <= (double) INT64_MIN)
-  {
-    res= (int64_t) INT64_MIN;
-    goto warn;
-  }
-  if (j >= (double) (uint64_t) INT64_MAX)
-  {
-    res= (int64_t) INT64_MAX;
-    goto warn;
-  }
-  return (int64_t) rint(j);
-
-warn:
-  {
-    char buf[DOUBLE_TO_STRING_CONVERSION_BUFFER_SIZE];
-    String tmp(buf, sizeof(buf), &my_charset_latin1), *str;
-    str= val_str(&tmp, 0);
-    push_warning_printf(current_thd, MYSQL_ERROR::WARN_LEVEL_WARN,
-                        ER_TRUNCATED_WRONG_VALUE,
-                        ER(ER_TRUNCATED_WRONG_VALUE), "INTEGER",
-                        str->c_ptr());
-  }
-  return res;
-}
-
-
-my_decimal *Field_real::val_decimal(my_decimal *decimal_value)
-{
-  double2my_decimal(E_DEC_FATAL_ERROR, val_real(), decimal_value);
-  return decimal_value;
-}
-
-
-String *Field_double::val_str(String *val_buffer,
-			      String *val_ptr __attribute__((unused)))
-{
-  double nr;
-#ifdef WORDS_BIGENDIAN
-  if (table->s->db_low_byte_first)
-  {
-    float8get(nr,ptr);
-  }
-  else
-#endif
-    doubleget(nr,ptr);
-
-  uint to_length=max(field_length, DOUBLE_TO_STRING_CONVERSION_BUFFER_SIZE);
-  val_buffer->alloc(to_length);
-  char *to=(char*) val_buffer->ptr();
-  size_t len;
-
-  if (dec >= NOT_FIXED_DEC)
-    len= my_gcvt(nr, MY_GCVT_ARG_DOUBLE, to_length - 1, to, NULL);
-  else
-    len= my_fcvt(nr, dec, to, NULL);
-
-  val_buffer->length((uint) len);
-  if (zerofill)
-    prepend_zeros(val_buffer);
-  return val_buffer;
-}
-
-bool Field_double::send_binary(Protocol *protocol)
-{
-  return protocol->store((double) Field_double::val_real(), dec, (String*) 0);
-}
-
-
-int Field_double::cmp(const uchar *a_ptr, const uchar *b_ptr)
-{
-  double a,b;
-#ifdef WORDS_BIGENDIAN
-  if (table->s->db_low_byte_first)
-  {
-    float8get(a,a_ptr);
-    float8get(b,b_ptr);
-  }
-  else
-#endif
-  {
-    doubleget(a, a_ptr);
-    doubleget(b, b_ptr);
-  }
-  return (a < b) ? -1 : (a > b) ? 1 : 0;
-}
-
-
-#define DBL_EXP_DIG (sizeof(double)*8-DBL_MANT_DIG)
-
-/* The following should work for IEEE */
-
-void Field_double::sort_string(uchar *to,uint length __attribute__((unused)))
-{
-  double nr;
-#ifdef WORDS_BIGENDIAN
-  if (table->s->db_low_byte_first)
-  {
-    float8get(nr,ptr);
-  }
-  else
-#endif
-    doubleget(nr,ptr);
-  change_double_for_sort(nr, to);
-}
-
-
-/**
-   Save the field metadata for double fields.
-
-   Saves the pack length in the first byte of the field metadata array
-   at index of *metadata_ptr.
-
-   @param   metadata_ptr   First byte of field metadata
-
-   @returns number of bytes written to metadata_ptr
-*/
-int Field_double::do_save_field_metadata(uchar *metadata_ptr)
-{
-  *metadata_ptr= pack_length();
-  return 1;
-}
-
-
-void Field_double::sql_type(String &res) const
-{
-  CHARSET_INFO *cs=res.charset();
-  if (dec == NOT_FIXED_DEC)
-  {
-    res.set_ascii(STRING_WITH_LEN("double"));
-  }
-  else
-  {
-    res.length(cs->cset->snprintf(cs,(char*) res.ptr(),res.alloced_length(),
-			    "double(%d,%d)",(int) field_length,dec));
-  }
-  add_zerofill_and_unsigned(res);
-}
-
-
-/**
-  TIMESTAMP type holds datetime values in range from 1970-01-01 00:00:01 UTC to 
-  2038-01-01 00:00:00 UTC stored as number of seconds since Unix 
-  Epoch in UTC.
-  
-  Up to one of timestamps columns in the table can be automatically 
-  set on row update and/or have NOW() as default value.
-  TABLE::timestamp_field points to Field object for such timestamp with 
-  auto-set-on-update. TABLE::time_stamp holds offset in record + 1 for this
-  field, and is used by handler code which performs updates required.
-  
-  Actually SQL-99 says that we should allow niladic functions (like NOW())
-  as defaults for any field. Current limitations (only NOW() and only 
-  for one TIMESTAMP field) are because of restricted binary .frm format 
-  and should go away in the future.
-  
-  Also because of this limitation of binary .frm format we use 5 different
-  unireg_check values with TIMESTAMP field to distinguish various cases of
-  DEFAULT or ON UPDATE values. These values are:
-  
-  TIMESTAMP_OLD_FIELD - old timestamp, if there was not any fields with
-    auto-set-on-update (or now() as default) in this table before, then this 
-    field has NOW() as default and is updated when row changes, else it is 
-    field which has 0 as default value and is not automatically updated.
-  TIMESTAMP_DN_FIELD - field with NOW() as default but not set on update
-    automatically (TIMESTAMP DEFAULT NOW())
-  TIMESTAMP_UN_FIELD - field which is set on update automatically but has not 
-    NOW() as default (but it may has 0 or some other const timestamp as 
-    default) (TIMESTAMP ON UPDATE NOW()).
-  TIMESTAMP_DNUN_FIELD - field which has now() as default and is auto-set on 
-    update. (TIMESTAMP DEFAULT NOW() ON UPDATE NOW())
-  NONE - field which is not auto-set on update with some other than NOW() 
-    default value (TIMESTAMP DEFAULT 0).
-
-  Note that TIMESTAMP_OLD_FIELDs are never created explicitly now, they are 
-  left only for preserving ability to read old tables. Such fields replaced 
-  with their newer analogs in CREATE TABLE and in SHOW CREATE TABLE. This is 
-  because we want to prefer NONE unireg_check before TIMESTAMP_OLD_FIELD for 
-  "TIMESTAMP DEFAULT 'Const'" field. (Old timestamps allowed such 
-  specification too but ignored default value for first timestamp, which of 
-  course is non-standard.) In most cases user won't notice any change, only
-  exception is different behavior of old/new timestamps during ALTER TABLE.
- */
-
-Field_timestamp::Field_timestamp(uchar *ptr_arg,
-                                 uint32 len_arg __attribute__((__unused__)),
-                                 uchar *null_ptr_arg, uchar null_bit_arg,
-                                 enum utype unireg_check_arg,
-                                 const char *field_name_arg,
-                                 TABLE_SHARE *share,
-                                 CHARSET_INFO *cs)
-  :Field_str(ptr_arg, MAX_DATETIME_WIDTH, null_ptr_arg, null_bit_arg,
-	     unireg_check_arg, field_name_arg, cs)
-{
-  /* For 4.0 MYD and 4.0 InnoDB compatibility */
-  flags|= ZEROFILL_FLAG | UNSIGNED_FLAG;
-  if (!share->timestamp_field && unireg_check != NONE)
-  {
-    /* This timestamp has auto-update */
-    share->timestamp_field= this;
-    flags|= TIMESTAMP_FLAG;
-    if (unireg_check != TIMESTAMP_DN_FIELD)
-      flags|= ON_UPDATE_NOW_FLAG;
-  }
-}
-
-
-Field_timestamp::Field_timestamp(bool maybe_null_arg,
-                                 const char *field_name_arg,
-                                 CHARSET_INFO *cs)
-  :Field_str((uchar*) 0, MAX_DATETIME_WIDTH,
-             maybe_null_arg ? (uchar*) "": 0, 0,
-	     NONE, field_name_arg, cs)
-{
-  /* For 4.0 MYD and 4.0 InnoDB compatibility */
-  flags|= ZEROFILL_FLAG | UNSIGNED_FLAG;
-    if (unireg_check != TIMESTAMP_DN_FIELD)
-      flags|= ON_UPDATE_NOW_FLAG;
-}
-
-
-/**
-  Get auto-set type for TIMESTAMP field.
-
-  Returns value indicating during which operations this TIMESTAMP field
-  should be auto-set to current timestamp.
-*/
-timestamp_auto_set_type Field_timestamp::get_auto_set_type() const
-{
-  switch (unireg_check)
-  {
-  case TIMESTAMP_DN_FIELD:
-    return TIMESTAMP_AUTO_SET_ON_INSERT;
-  case TIMESTAMP_UN_FIELD:
-    return TIMESTAMP_AUTO_SET_ON_UPDATE;
-  case TIMESTAMP_OLD_FIELD:
-    /*
-      Although we can have several such columns in legacy tables this
-      function should be called only for first of them (i.e. the one
-      having auto-set property).
-    */
-    assert(table->timestamp_field == this);
-    /* Fall-through */
-  case TIMESTAMP_DNUN_FIELD:
-    return TIMESTAMP_AUTO_SET_ON_BOTH;
-  default:
-    /*
-      Normally this function should not be called for TIMESTAMPs without
-      auto-set property.
-    */
-    assert(0);
-    return TIMESTAMP_NO_AUTO_SET;
-  }
-}
-
-
-int Field_timestamp::store(const char *from,
-                           uint len,
-                           CHARSET_INFO *cs __attribute__((__unused__)))
-{
-  MYSQL_TIME l_time;
-  my_time_t tmp= 0;
-  int error;
-  bool have_smth_to_conv;
-  bool in_dst_time_gap;
-  THD *thd= table ? table->in_use : current_thd;
-
-  /* We don't want to store invalid or fuzzy datetime values in TIMESTAMP */
-  have_smth_to_conv= (str_to_datetime(from, len, &l_time, 1, &error) >
-                      MYSQL_TIMESTAMP_ERROR);
-
-  if (error || !have_smth_to_conv)
-  {
-    error= 1;
-    set_datetime_warning(MYSQL_ERROR::WARN_LEVEL_WARN, WARN_DATA_TRUNCATED,
-                         from, len, MYSQL_TIMESTAMP_DATETIME, 1);
-  }
-
-  /* Only convert a correct date (not a zero date) */
-  if (have_smth_to_conv && l_time.month)
-  {
-    if (!(tmp= TIME_to_timestamp(thd, &l_time, &in_dst_time_gap)))
-    {
-      set_datetime_warning(MYSQL_ERROR::WARN_LEVEL_WARN,
-                           ER_WARN_DATA_OUT_OF_RANGE,
-                           from, len, MYSQL_TIMESTAMP_DATETIME, !error);
-      error= 1;
-    }
-    else if (in_dst_time_gap)
-    {
-      set_datetime_warning(MYSQL_ERROR::WARN_LEVEL_WARN,
-                           ER_WARN_INVALID_TIMESTAMP,
-                           from, len, MYSQL_TIMESTAMP_DATETIME, !error);
-      error= 1;
-    }
-  }
-  store_timestamp(tmp);
-  return error;
-}
-
-
-int Field_timestamp::store(double nr)
-{
-  int error= 0;
-  if (nr < 0 || nr > 99991231235959.0)
-  {
-    set_datetime_warning(MYSQL_ERROR::WARN_LEVEL_WARN,
-                         ER_WARN_DATA_OUT_OF_RANGE,
-                         nr, MYSQL_TIMESTAMP_DATETIME);
-    nr= 0;					// Avoid overflow on buff
-    error= 1;
-  }
-  error|= Field_timestamp::store((int64_t) rint(nr), false);
-  return error;
-}
-
-
-int Field_timestamp::store(int64_t nr,
-                           bool unsigned_val __attribute__((__unused__)))
-{
-  MYSQL_TIME l_time;
-  my_time_t timestamp= 0;
-  int error;
-  bool in_dst_time_gap;
-  THD *thd= table ? table->in_use : current_thd;
-
-  /* We don't want to store invalid or fuzzy datetime values in TIMESTAMP */
-  int64_t tmp= number_to_datetime(nr, &l_time, (thd->variables.sql_mode &
-                                                 MODE_NO_ZERO_DATE) |
-                                   MODE_NO_ZERO_IN_DATE, &error);
-  if (tmp == -1LL)
-  {
-    error= 2;
-  }
-
-  if (!error && tmp)
-  {
-    if (!(timestamp= TIME_to_timestamp(thd, &l_time, &in_dst_time_gap)))
-    {
-      set_datetime_warning(MYSQL_ERROR::WARN_LEVEL_WARN,
-                           ER_WARN_DATA_OUT_OF_RANGE,
-                           nr, MYSQL_TIMESTAMP_DATETIME, 1);
-      error= 1;
-    }
-    if (in_dst_time_gap)
-    {
-      set_datetime_warning(MYSQL_ERROR::WARN_LEVEL_WARN,
-                           ER_WARN_INVALID_TIMESTAMP,
-                           nr, MYSQL_TIMESTAMP_DATETIME, 1);
-      error= 1;
-    }
-  } else if (error)
-    set_datetime_warning(MYSQL_ERROR::WARN_LEVEL_WARN,
-                         WARN_DATA_TRUNCATED,
-                         nr, MYSQL_TIMESTAMP_DATETIME, 1);
-
-  store_timestamp(timestamp);
-  return error;
-}
-
-double Field_timestamp::val_real(void)
-{
-  return (double) Field_timestamp::val_int();
-}
-
-int64_t Field_timestamp::val_int(void)
-{
-  uint32 temp;
-  MYSQL_TIME time_tmp;
-  THD  *thd= table ? table->in_use : current_thd;
-
-  thd->time_zone_used= 1;
-#ifdef WORDS_BIGENDIAN
-  if (table && table->s->db_low_byte_first)
-    temp=uint4korr(ptr);
-  else
-#endif
-    longget(temp,ptr);
-
-  if (temp == 0L)				// No time
-    return(0);					/* purecov: inspected */
-  
-  thd->variables.time_zone->gmt_sec_to_TIME(&time_tmp, (my_time_t)temp);
-  
-  return time_tmp.year * 10000000000LL + time_tmp.month * 100000000LL +
-         time_tmp.day * 1000000L + time_tmp.hour * 10000L +
-         time_tmp.minute * 100 + time_tmp.second;
-}
-
-
-String *Field_timestamp::val_str(String *val_buffer, String *val_ptr)
-{
-  uint32 temp, temp2;
-  MYSQL_TIME time_tmp;
-  THD *thd= table ? table->in_use : current_thd;
-  char *to;
-
-  val_buffer->alloc(field_length+1);
-  to= (char*) val_buffer->ptr();
-  val_buffer->length(field_length);
-
-  thd->time_zone_used= 1;
-#ifdef WORDS_BIGENDIAN
-  if (table && table->s->db_low_byte_first)
-    temp=uint4korr(ptr);
-  else
-#endif
-    longget(temp,ptr);
-
-  if (temp == 0L)
-  {				      /* Zero time is "000000" */
-    val_ptr->set(STRING_WITH_LEN("0000-00-00 00:00:00"), &my_charset_bin);
-    return val_ptr;
-  }
-  val_buffer->set_charset(&my_charset_bin);	// Safety
-  
-  thd->variables.time_zone->gmt_sec_to_TIME(&time_tmp,(my_time_t)temp);
-
-  temp= time_tmp.year % 100;
-  if (temp < YY_PART_YEAR - 1)
-  {
-    *to++= '2';
-    *to++= '0';
-  }
-  else
-  {
-    *to++= '1';
-    *to++= '9';
-  }
-  temp2=temp/10; temp=temp-temp2*10;
-  *to++= (char) ('0'+(char) (temp2));
-  *to++= (char) ('0'+(char) (temp));
-  *to++= '-';
-  temp=time_tmp.month;
-  temp2=temp/10; temp=temp-temp2*10;
-  *to++= (char) ('0'+(char) (temp2));
-  *to++= (char) ('0'+(char) (temp));
-  *to++= '-';
-  temp=time_tmp.day;
-  temp2=temp/10; temp=temp-temp2*10;
-  *to++= (char) ('0'+(char) (temp2));
-  *to++= (char) ('0'+(char) (temp));
-  *to++= ' ';
-  temp=time_tmp.hour;
-  temp2=temp/10; temp=temp-temp2*10;
-  *to++= (char) ('0'+(char) (temp2));
-  *to++= (char) ('0'+(char) (temp));
-  *to++= ':';
-  temp=time_tmp.minute;
-  temp2=temp/10; temp=temp-temp2*10;
-  *to++= (char) ('0'+(char) (temp2));
-  *to++= (char) ('0'+(char) (temp));
-  *to++= ':';
-  temp=time_tmp.second;
-  temp2=temp/10; temp=temp-temp2*10;
-  *to++= (char) ('0'+(char) (temp2));
-  *to++= (char) ('0'+(char) (temp));
-  *to= 0;
-  return val_buffer;
-}
-
-
-bool Field_timestamp::get_date(MYSQL_TIME *ltime, uint fuzzydate)
-{
-  long temp;
-  THD *thd= table ? table->in_use : current_thd;
-  thd->time_zone_used= 1;
-#ifdef WORDS_BIGENDIAN
-  if (table && table->s->db_low_byte_first)
-    temp=uint4korr(ptr);
-  else
-#endif
-    longget(temp,ptr);
-  if (temp == 0L)
-  {				      /* Zero time is "000000" */
-    if (fuzzydate & TIME_NO_ZERO_DATE)
-      return 1;
-    bzero((char*) ltime,sizeof(*ltime));
-  }
-  else
-  {
-    thd->variables.time_zone->gmt_sec_to_TIME(ltime, (my_time_t)temp);
-  }
-  return 0;
-}
-
-bool Field_timestamp::get_time(MYSQL_TIME *ltime)
-{
-  return Field_timestamp::get_date(ltime,0);
-}
-
-
-bool Field_timestamp::send_binary(Protocol *protocol)
-{
-  MYSQL_TIME tm;
-  Field_timestamp::get_date(&tm, 0);
-  return protocol->store(&tm);
-}
-
-
-int Field_timestamp::cmp(const uchar *a_ptr, const uchar *b_ptr)
-{
-  int32 a,b;
-#ifdef WORDS_BIGENDIAN
-  if (table && table->s->db_low_byte_first)
-  {
-    a=sint4korr(a_ptr);
-    b=sint4korr(b_ptr);
-  }
-  else
-#endif
-  {
-  longget(a,a_ptr);
-  longget(b,b_ptr);
-  }
-  return ((uint32) a < (uint32) b) ? -1 : ((uint32) a > (uint32) b) ? 1 : 0;
-}
-
-
-void Field_timestamp::sort_string(uchar *to,uint length __attribute__((unused)))
-{
-#ifdef WORDS_BIGENDIAN
-  if (!table || !table->s->db_low_byte_first)
-  {
-    to[0] = ptr[0];
-    to[1] = ptr[1];
-    to[2] = ptr[2];
-    to[3] = ptr[3];
-  }
-  else
-#endif
-  {
-    to[0] = ptr[3];
-    to[1] = ptr[2];
-    to[2] = ptr[1];
-    to[3] = ptr[0];
-  }
-}
-
-
-void Field_timestamp::sql_type(String &res) const
-{
-  res.set_ascii(STRING_WITH_LEN("timestamp"));
-}
-
-
-void Field_timestamp::set_time()
-{
-  THD *thd= table ? table->in_use : current_thd;
-  long tmp= (long) thd->query_start();
-  set_notnull();
-  store_timestamp(tmp);
-}
-
-/****************************************************************************
-** time type
-** In string context: HH:MM:SS
-** In number context: HHMMSS
-** Stored as a 3 byte unsigned int
-****************************************************************************/
-
-int Field_time::store(const char *from,
-                      uint len,
-                      CHARSET_INFO *cs __attribute__((__unused__)))
-{
-  MYSQL_TIME ltime;
-  long tmp;
-  int error= 0;
-  int warning;
-
-  if (str_to_time(from, len, &ltime, &warning))
-  {
-    tmp=0L;
-    error= 2;
-    set_datetime_warning(MYSQL_ERROR::WARN_LEVEL_WARN, WARN_DATA_TRUNCATED,
-                         from, len, MYSQL_TIMESTAMP_TIME, 1);
-  }
-  else
-  {
-    if (warning & MYSQL_TIME_WARN_TRUNCATED)
-    {
-      set_datetime_warning(MYSQL_ERROR::WARN_LEVEL_WARN,
-                           WARN_DATA_TRUNCATED,
-                           from, len, MYSQL_TIMESTAMP_TIME, 1);
-      error= 1;
-    }
-    if (warning & MYSQL_TIME_WARN_OUT_OF_RANGE)
-    {
-      set_datetime_warning(MYSQL_ERROR::WARN_LEVEL_WARN, 
-                           ER_WARN_DATA_OUT_OF_RANGE,
-                           from, len, MYSQL_TIMESTAMP_TIME, !error);
-      error= 1;
-    }
-    if (ltime.month)
-      ltime.day=0;
-    tmp=(ltime.day*24L+ltime.hour)*10000L+(ltime.minute*100+ltime.second);
-  }
-  
-  if (ltime.neg)
-    tmp= -tmp;
-  int3store(ptr,tmp);
-  return error;
-}
-
-
-int Field_time::store_time(MYSQL_TIME *ltime,
-                           timestamp_type time_type __attribute__((__unused__)))
-{
-  long tmp= ((ltime->month ? 0 : ltime->day * 24L) + ltime->hour) * 10000L +
-            (ltime->minute * 100 + ltime->second);
-  if (ltime->neg)
-    tmp= -tmp;
-  return Field_time::store((int64_t) tmp, false);
-}
-
-
-int Field_time::store(double nr)
-{
-  long tmp;
-  int error= 0;
-  if (nr > (double)TIME_MAX_VALUE)
-  {
-    tmp= TIME_MAX_VALUE;
-    set_datetime_warning(MYSQL_ERROR::WARN_LEVEL_WARN,
-                         ER_WARN_DATA_OUT_OF_RANGE, nr, MYSQL_TIMESTAMP_TIME);
-    error= 1;
-  }
-  else if (nr < (double)-TIME_MAX_VALUE)
-  {
-    tmp= -TIME_MAX_VALUE;
-    set_datetime_warning(MYSQL_ERROR::WARN_LEVEL_WARN, 
-                         ER_WARN_DATA_OUT_OF_RANGE, nr, MYSQL_TIMESTAMP_TIME);
-    error= 1;
-  }
-  else
-  {
-    tmp=(long) floor(fabs(nr));			// Remove fractions
-    if (nr < 0)
-      tmp= -tmp;
-    if (tmp % 100 > 59 || tmp/100 % 100 > 59)
-    {
-      tmp=0;
-      set_datetime_warning(MYSQL_ERROR::WARN_LEVEL_WARN, 
-                           ER_WARN_DATA_OUT_OF_RANGE, nr,
-                           MYSQL_TIMESTAMP_TIME);
-      error= 1;
-    }
-  }
-  int3store(ptr,tmp);
-  return error;
-}
-
-
-int Field_time::store(int64_t nr, bool unsigned_val)
-{
-  long tmp;
-  int error= 0;
-  if (nr < (int64_t) -TIME_MAX_VALUE && !unsigned_val)
-  {
-    tmp= -TIME_MAX_VALUE;
-    set_datetime_warning(MYSQL_ERROR::WARN_LEVEL_WARN, 
-                         ER_WARN_DATA_OUT_OF_RANGE, nr,
-                         MYSQL_TIMESTAMP_TIME, 1);
-    error= 1;
-  }
-  else if (nr > (int64_t) TIME_MAX_VALUE || (nr < 0 && unsigned_val))
-  {
-    tmp= TIME_MAX_VALUE;
-    set_datetime_warning(MYSQL_ERROR::WARN_LEVEL_WARN, 
-                         ER_WARN_DATA_OUT_OF_RANGE, nr,
-                         MYSQL_TIMESTAMP_TIME, 1);
-    error= 1;
-  }
-  else
-  {
-    tmp=(long) nr;
-    if (tmp % 100 > 59 || tmp/100 % 100 > 59)
-    {
-      tmp=0;
-      set_datetime_warning(MYSQL_ERROR::WARN_LEVEL_WARN, 
-                           ER_WARN_DATA_OUT_OF_RANGE, nr,
-                           MYSQL_TIMESTAMP_TIME, 1);
-      error= 1;
-    }
-  }
-  int3store(ptr,tmp);
-  return error;
-}
-
-
-double Field_time::val_real(void)
-{
-  uint32 j= (uint32) uint3korr(ptr);
-  return (double) j;
-}
-
-int64_t Field_time::val_int(void)
-{
-  return (int64_t) sint3korr(ptr);
-}
-
-
-/**
-  @note
-  This function is multi-byte safe as the result string is always of type
-  my_charset_bin
-*/
-
-String *Field_time::val_str(String *val_buffer,
-			    String *val_ptr __attribute__((unused)))
-{
-  MYSQL_TIME ltime;
-  val_buffer->alloc(MAX_DATE_STRING_REP_LENGTH);
-  long tmp=(long) sint3korr(ptr);
-  ltime.neg= 0;
-  if (tmp < 0)
-  {
-    tmp= -tmp;
-    ltime.neg= 1;
-  }
-  ltime.day= (uint) 0;
-  ltime.hour= (uint) (tmp/10000);
-  ltime.minute= (uint) (tmp/100 % 100);
-  ltime.second= (uint) (tmp % 100);
-  make_time((DATE_TIME_FORMAT*) 0, &ltime, val_buffer);
-  return val_buffer;
-}
-
-
-/**
-  @note
-  Normally we would not consider 'time' as a valid date, but we allow
-  get_date() here to be able to do things like
-  DATE_FORMAT(time, "%l.%i %p")
-*/
- 
-bool Field_time::get_date(MYSQL_TIME *ltime, uint fuzzydate)
-{
-  long tmp;
-  THD *thd= table ? table->in_use : current_thd;
-  if (!(fuzzydate & TIME_FUZZY_DATE))
-  {
-    push_warning_printf(thd, MYSQL_ERROR::WARN_LEVEL_WARN,
-                        ER_WARN_DATA_OUT_OF_RANGE,
-                        ER(ER_WARN_DATA_OUT_OF_RANGE), field_name,
-                        thd->row_count);
-    return 1;
-  }
-  tmp=(long) sint3korr(ptr);
-  ltime->neg=0;
-  if (tmp < 0)
-  {
-    ltime->neg= 1;
-    tmp=-tmp;
-  }
-  ltime->hour=tmp/10000;
-  tmp-=ltime->hour*10000;
-  ltime->minute=   tmp/100;
-  ltime->second= tmp % 100;
-  ltime->year= ltime->month= ltime->day= ltime->second_part= 0;
-  return 0;
-}
-
-
-bool Field_time::get_time(MYSQL_TIME *ltime)
-{
-  long tmp=(long) sint3korr(ptr);
-  ltime->neg=0;
-  if (tmp < 0)
-  {
-    ltime->neg= 1;
-    tmp=-tmp;
-  }
-  ltime->day= 0;
-  ltime->hour=   (int) (tmp/10000);
-  tmp-=ltime->hour*10000;
-  ltime->minute= (int) tmp/100;
-  ltime->second= (int) tmp % 100;
-  ltime->second_part=0;
-  ltime->time_type= MYSQL_TIMESTAMP_TIME;
-  return 0;
-}
-
-
-bool Field_time::send_binary(Protocol *protocol)
-{
-  MYSQL_TIME tm;
-  Field_time::get_time(&tm);
-  tm.day= tm.hour/24;				// Move hours to days
-  tm.hour-= tm.day*24;
-  return protocol->store_time(&tm);
-}
-
-
-int Field_time::cmp(const uchar *a_ptr, const uchar *b_ptr)
-{
-  int32 a,b;
-  a=(int32) sint3korr(a_ptr);
-  b=(int32) sint3korr(b_ptr);
-  return (a < b) ? -1 : (a > b) ? 1 : 0;
-}
-
-void Field_time::sort_string(uchar *to,uint length __attribute__((unused)))
-{
-  to[0] = (uchar) (ptr[2] ^ 128);
-  to[1] = ptr[1];
-  to[2] = ptr[0];
-}
-
-void Field_time::sql_type(String &res) const
-{
-  res.set_ascii(STRING_WITH_LEN("time"));
-}
-
-/****************************************************************************
-** year type
-** Save in a byte the year 0, 1901->2155
-** Can handle 2 byte or 4 byte years!
-****************************************************************************/
-
-int Field_year::store(const char *from, uint len,CHARSET_INFO *cs)
-{
-  char *end;
-  int error;
-  int64_t nr= cs->cset->strntoull10rnd(cs, from, len, 0, &end, &error);
-
-  if (nr < 0 || (nr >= 100 && nr <= 1900) || nr > 2155 || 
-      error == MY_ERRNO_ERANGE)
-  {
-    *ptr=0;
-    set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
-    return 1;
-  }
-  if (table->in_use->count_cuted_fields && 
-      (error= check_int(cs, from, len, end, error)))
-  {
-    if (error == 1)  /* empty or incorrect string */
-    {
-      *ptr= 0;
-      return 1;
-    }
-    error= 1;
-  }
-
-  if (nr != 0 || len != 4)
-  {
-    if (nr < YY_PART_YEAR)
-      nr+=100;					// 2000 - 2069
-    else if (nr > 1900)
-      nr-= 1900;
-  }
-  *ptr= (char) (uchar) nr;
-  return error;
-}
-
-
-int Field_year::store(double nr)
-{
-  if (nr < 0.0 || nr >= 2155.0)
-  {
-    (void) Field_year::store((int64_t) -1, false);
-    return 1;
-  }
-  return Field_year::store((int64_t) nr, false);
-}
-
-
-int Field_year::store(int64_t nr,
-                      bool unsigned_val __attribute__((__unused__)))
-{
-  if (nr < 0 || (nr >= 100 && nr <= 1900) || nr > 2155)
-  {
-    *ptr= 0;
-    set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
-    return 1;
-  }
-  if (nr != 0 || field_length != 4)		// 0000 -> 0; 00 -> 2000
-  {
-    if (nr < YY_PART_YEAR)
-      nr+=100;					// 2000 - 2069
-    else if (nr > 1900)
-      nr-= 1900;
-  }
-  *ptr= (char) (uchar) nr;
-  return 0;
-}
-
-
-bool Field_year::send_binary(Protocol *protocol)
-{
-  uint64_t tmp= Field_year::val_int();
-  return protocol->store_short(tmp);
-}
-
-
-double Field_year::val_real(void)
-{
-  return (double) Field_year::val_int();
-}
-
-
-int64_t Field_year::val_int(void)
-{
-  int tmp= (int) ptr[0];
-  if (field_length != 4)
-    tmp%=100;					// Return last 2 char
-  else if (tmp)
-    tmp+=1900;
-  return (int64_t) tmp;
-}
-
-
-String *Field_year::val_str(String *val_buffer,
-			    String *val_ptr __attribute__((unused)))
-{
-  val_buffer->alloc(5);
-  val_buffer->length(field_length);
-  char *to=(char*) val_buffer->ptr();
-  sprintf(to,field_length == 2 ? "%02d" : "%04d",(int) Field_year::val_int());
-  return val_buffer;
-}
-
-
-void Field_year::sql_type(String &res) const
-{
-  CHARSET_INFO *cs=res.charset();
-  res.length(cs->cset->snprintf(cs,(char*)res.ptr(),res.alloced_length(),
-			  "year(%d)",(int) field_length));
-}
-
-
-/****************************************************************************
-** The new date type
-** This is identical to the old date type, but stored on 3 bytes instead of 4
-** In number context: YYYYMMDD
-****************************************************************************/
-
-/*
-  Store string into a date field
-
-  SYNOPSIS
-    Field_newdate::store()
-    from                Date string
-    len                 Length of date field
-    cs                  Character set (not used)
-
-  RETURN
-    0  ok
-    1  Value was cut during conversion
-    2  Wrong date string
-    3  Datetime value that was cut (warning level NOTE)
-       This is used by opt_range.cc:get_mm_leaf(). Note that there is a
-       nearly-identical class Field_date doesn't ever return 3 from its
-       store function.
-*/
-
-int Field_newdate::store(const char *from,
-                         uint len,
-                         CHARSET_INFO *cs __attribute__((__unused__)))
-{
-  long tmp;
-  MYSQL_TIME l_time;
-  int error;
-  THD *thd= table ? table->in_use : current_thd;
-  enum enum_mysql_timestamp_type ret;
-  if ((ret= str_to_datetime(from, len, &l_time,
-                            (TIME_FUZZY_DATE |
-                             (thd->variables.sql_mode &
-                              (MODE_NO_ZERO_IN_DATE | MODE_NO_ZERO_DATE |
-                               MODE_INVALID_DATES))),
-                            &error)) <= MYSQL_TIMESTAMP_ERROR)
-  {
-    tmp= 0;
-    error= 2;
-  }
-  else
-  {
-    tmp= l_time.day + l_time.month*32 + l_time.year*16*32;
-    if (!error && (ret != MYSQL_TIMESTAMP_DATE) &&
-        (l_time.hour || l_time.minute || l_time.second || l_time.second_part))
-      error= 3;                                 // Datetime was cut (note)
-  }
-
-  if (error)
-    set_datetime_warning(error == 3 ? MYSQL_ERROR::WARN_LEVEL_NOTE :
-                         MYSQL_ERROR::WARN_LEVEL_WARN,
-                         WARN_DATA_TRUNCATED,
-                         from, len, MYSQL_TIMESTAMP_DATE, 1);
-
-  int3store(ptr, tmp);
-  return error;
-}
-
-
-int Field_newdate::store(double nr)
-{
-  if (nr < 0.0 || nr > 99991231235959.0)
-  {
-    int3store(ptr,(int32) 0);
-    set_datetime_warning(MYSQL_ERROR::WARN_LEVEL_WARN,
-                         WARN_DATA_TRUNCATED, nr, MYSQL_TIMESTAMP_DATE);
-    return 1;
-  }
-  return Field_newdate::store((int64_t) rint(nr), false);
-}
-
-
-int Field_newdate::store(int64_t nr,
-                         bool unsigned_val __attribute__((__unused__)))
-{
-  MYSQL_TIME l_time;
-  int64_t tmp;
-  int error;
-  THD *thd= table ? table->in_use : current_thd;
-  if (number_to_datetime(nr, &l_time,
-                         (TIME_FUZZY_DATE |
-                          (thd->variables.sql_mode &
-                           (MODE_NO_ZERO_IN_DATE | MODE_NO_ZERO_DATE |
-                            MODE_INVALID_DATES))),
-                         &error) == -1LL)
-  {
-    tmp= 0L;
-    error= 2;
-  }
-  else
-    tmp= l_time.day + l_time.month*32 + l_time.year*16*32;
-
-  if (!error && l_time.time_type != MYSQL_TIMESTAMP_DATE &&
-      (l_time.hour || l_time.minute || l_time.second || l_time.second_part))
-    error= 3;
-
-  if (error)
-    set_datetime_warning(error == 3 ? MYSQL_ERROR::WARN_LEVEL_NOTE :
-                         MYSQL_ERROR::WARN_LEVEL_WARN,
-                         error == 2 ? 
-                         ER_WARN_DATA_OUT_OF_RANGE : WARN_DATA_TRUNCATED,
-                         nr,MYSQL_TIMESTAMP_DATE, 1);
-
-  int3store(ptr,tmp);
-  return error;
-}
-
-
-int Field_newdate::store_time(MYSQL_TIME *ltime,timestamp_type time_type)
-{
-  long tmp;
-  int error= 0;
-  if (time_type == MYSQL_TIMESTAMP_DATE ||
-      time_type == MYSQL_TIMESTAMP_DATETIME)
-  {
-    tmp=ltime->year*16*32+ltime->month*32+ltime->day;
-    if (check_date(ltime, tmp != 0,
-                   (TIME_FUZZY_DATE |
-                    (current_thd->variables.sql_mode &
-                     (MODE_NO_ZERO_IN_DATE | MODE_NO_ZERO_DATE |
-                      MODE_INVALID_DATES))), &error))
-    {
-      char buff[MAX_DATE_STRING_REP_LENGTH];
-      String str(buff, sizeof(buff), &my_charset_latin1);
-      make_date((DATE_TIME_FORMAT *) 0, ltime, &str);
-      set_datetime_warning(MYSQL_ERROR::WARN_LEVEL_WARN, WARN_DATA_TRUNCATED,
-                           str.ptr(), str.length(), MYSQL_TIMESTAMP_DATE, 1);
-    }
-    if (!error && ltime->time_type != MYSQL_TIMESTAMP_DATE &&
-        (ltime->hour || ltime->minute || ltime->second || ltime->second_part))
-    {
-      char buff[MAX_DATE_STRING_REP_LENGTH];
-      String str(buff, sizeof(buff), &my_charset_latin1);
-      make_datetime((DATE_TIME_FORMAT *) 0, ltime, &str);
-      set_datetime_warning(MYSQL_ERROR::WARN_LEVEL_NOTE,
-                           WARN_DATA_TRUNCATED,
-                           str.ptr(), str.length(), MYSQL_TIMESTAMP_DATE, 1);
-      error= 3;
-    }
-  }
-  else
-  {
-    tmp=0;
-    error= 1;
-    set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, WARN_DATA_TRUNCATED, 1);
-  }
-  int3store(ptr,tmp);
-  return error;
-}
-
-
-bool Field_newdate::send_binary(Protocol *protocol)
-{
-  MYSQL_TIME tm;
-  Field_newdate::get_date(&tm,0);
-  return protocol->store_date(&tm);
-}
-
-
-double Field_newdate::val_real(void)
-{
-  return (double) Field_newdate::val_int();
-}
-
-
-int64_t Field_newdate::val_int(void)
-{
-  ulong j= uint3korr(ptr);
-  j= (j % 32L)+(j / 32L % 16L)*100L + (j/(16L*32L))*10000L;
-  return (int64_t) j;
-}
-
-
-String *Field_newdate::val_str(String *val_buffer,
-			       String *val_ptr __attribute__((unused)))
-{
-  val_buffer->alloc(field_length);
-  val_buffer->length(field_length);
-  uint32 tmp=(uint32) uint3korr(ptr);
-  int part;
-  char *pos=(char*) val_buffer->ptr()+10;
-
-  /* Open coded to get more speed */
-  *pos--=0;					// End NULL
-  part=(int) (tmp & 31);
-  *pos--= (char) ('0'+part%10);
-  *pos--= (char) ('0'+part/10);
-  *pos--= '-';
-  part=(int) (tmp >> 5 & 15);
-  *pos--= (char) ('0'+part%10);
-  *pos--= (char) ('0'+part/10);
-  *pos--= '-';
-  part=(int) (tmp >> 9);
-  *pos--= (char) ('0'+part%10); part/=10;
-  *pos--= (char) ('0'+part%10); part/=10;
-  *pos--= (char) ('0'+part%10); part/=10;
-  *pos=   (char) ('0'+part);
-  return val_buffer;
-}
-
-
-bool Field_newdate::get_date(MYSQL_TIME *ltime,uint fuzzydate)
-{
-  uint32 tmp=(uint32) uint3korr(ptr);
-  ltime->day=   tmp & 31;
-  ltime->month= (tmp >> 5) & 15;
-  ltime->year=  (tmp >> 9);
-  ltime->time_type= MYSQL_TIMESTAMP_DATE;
-  ltime->hour= ltime->minute= ltime->second= ltime->second_part= ltime->neg= 0;
-  return ((!(fuzzydate & TIME_FUZZY_DATE) && (!ltime->month || !ltime->day)) ?
-          1 : 0);
-}
-
-
-bool Field_newdate::get_time(MYSQL_TIME *ltime)
-{
-  return Field_newdate::get_date(ltime,0);
-}
-
-
-int Field_newdate::cmp(const uchar *a_ptr, const uchar *b_ptr)
-{
-  uint32 a,b;
-  a=(uint32) uint3korr(a_ptr);
-  b=(uint32) uint3korr(b_ptr);
-  return (a < b) ? -1 : (a > b) ? 1 : 0;
-}
-
-
-void Field_newdate::sort_string(uchar *to,uint length __attribute__((unused)))
-{
-  to[0] = ptr[2];
-  to[1] = ptr[1];
-  to[2] = ptr[0];
-}
-
-
-void Field_newdate::sql_type(String &res) const
-{
-  res.set_ascii(STRING_WITH_LEN("date"));
-}
-
-
-/****************************************************************************
-** datetime type
-** In string context: YYYY-MM-DD HH:MM:DD
-** In number context: YYYYMMDDHHMMDD
-** Stored as a 8 byte unsigned int. Should sometimes be change to a 6 byte int.
-****************************************************************************/
-
-int Field_datetime::store(const char *from,
-                          uint len,
-                          CHARSET_INFO *cs __attribute__((__unused__)))
-{
-  MYSQL_TIME time_tmp;
-  int error;
-  uint64_t tmp= 0;
-  enum enum_mysql_timestamp_type func_res;
-  THD *thd= table ? table->in_use : current_thd;
-
-  func_res= str_to_datetime(from, len, &time_tmp,
-                            (TIME_FUZZY_DATE |
-                             (thd->variables.sql_mode &
-                              (MODE_NO_ZERO_IN_DATE | MODE_NO_ZERO_DATE |
-                               MODE_INVALID_DATES))),
-                            &error);
-  if ((int) func_res > (int) MYSQL_TIMESTAMP_ERROR)
-    tmp= TIME_to_uint64_t_datetime(&time_tmp);
-  else
-    error= 1;                                 // Fix if invalid zero date
-
-  if (error)
-    set_datetime_warning(MYSQL_ERROR::WARN_LEVEL_WARN,
-                         ER_WARN_DATA_OUT_OF_RANGE,
-                         from, len, MYSQL_TIMESTAMP_DATETIME, 1);
-
-#ifdef WORDS_BIGENDIAN
-  if (table && table->s->db_low_byte_first)
-  {
-    int8store(ptr,tmp);
-  }
-  else
-#endif
-    int64_tstore(ptr,tmp);
-  return error;
-}
-
-
-int Field_datetime::store(double nr)
-{
-  int error= 0;
-  if (nr < 0.0 || nr > 99991231235959.0)
-  {
-    set_datetime_warning(MYSQL_ERROR::WARN_LEVEL_WARN, 
-                         ER_WARN_DATA_OUT_OF_RANGE,
-                         nr, MYSQL_TIMESTAMP_DATETIME);
-    nr= 0.0;
-    error= 1;
-  }
-  error|= Field_datetime::store((int64_t) rint(nr), false);
-  return error;
-}
-
-
-int Field_datetime::store(int64_t nr,
-                          bool unsigned_val __attribute__((__unused__)))
-{
-  MYSQL_TIME not_used;
-  int error;
-  int64_t initial_nr= nr;
-  THD *thd= table ? table->in_use : current_thd;
-
-  nr= number_to_datetime(nr, &not_used, (TIME_FUZZY_DATE |
-                                         (thd->variables.sql_mode &
-                                          (MODE_NO_ZERO_IN_DATE |
-                                           MODE_NO_ZERO_DATE |
-                                           MODE_INVALID_DATES))), &error);
-
-  if (nr == -1LL)
-  {
-    nr= 0;
-    error= 2;
-  }
-
-  if (error)
-    set_datetime_warning(MYSQL_ERROR::WARN_LEVEL_WARN,
-                         error == 2 ? ER_WARN_DATA_OUT_OF_RANGE :
-                         WARN_DATA_TRUNCATED, initial_nr,
-                         MYSQL_TIMESTAMP_DATETIME, 1);
-
-#ifdef WORDS_BIGENDIAN
-  if (table && table->s->db_low_byte_first)
-  {
-    int8store(ptr,nr);
-  }
-  else
-#endif
-    int64_tstore(ptr,nr);
-  return error;
-}
-
-
-int Field_datetime::store_time(MYSQL_TIME *ltime,timestamp_type time_type)
-{
-  int64_t tmp;
-  int error= 0;
-  /*
-    We don't perform range checking here since values stored in TIME
-    structure always fit into DATETIME range.
-  */
-  if (time_type == MYSQL_TIMESTAMP_DATE ||
-      time_type == MYSQL_TIMESTAMP_DATETIME)
-  {
-    tmp=((ltime->year*10000L+ltime->month*100+ltime->day)*1000000LL+
-	 (ltime->hour*10000L+ltime->minute*100+ltime->second));
-    if (check_date(ltime, tmp != 0,
-                   (TIME_FUZZY_DATE |
-                    (current_thd->variables.sql_mode &
-                     (MODE_NO_ZERO_IN_DATE | MODE_NO_ZERO_DATE |
-                      MODE_INVALID_DATES))), &error))
-    {
-      char buff[MAX_DATE_STRING_REP_LENGTH];
-      String str(buff, sizeof(buff), &my_charset_latin1);
-      make_datetime((DATE_TIME_FORMAT *) 0, ltime, &str);
-      set_datetime_warning(MYSQL_ERROR::WARN_LEVEL_WARN, WARN_DATA_TRUNCATED,
-                           str.ptr(), str.length(), MYSQL_TIMESTAMP_DATETIME,1);
-    }
-  }
-  else
-  {
-    tmp=0;
-    error= 1;
-    set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, WARN_DATA_TRUNCATED, 1);
-  }
-#ifdef WORDS_BIGENDIAN
-  if (table && table->s->db_low_byte_first)
-  {
-    int8store(ptr,tmp);
-  }
-  else
-#endif
-    int64_tstore(ptr,tmp);
-  return error;
-}
-
-bool Field_datetime::send_binary(Protocol *protocol)
-{
-  MYSQL_TIME tm;
-  Field_datetime::get_date(&tm, TIME_FUZZY_DATE);
-  return protocol->store(&tm);
-}
-
-
-double Field_datetime::val_real(void)
-{
-  return (double) Field_datetime::val_int();
-}
-
-int64_t Field_datetime::val_int(void)
-{
-  int64_t j;
-#ifdef WORDS_BIGENDIAN
-  if (table && table->s->db_low_byte_first)
-    j=sint8korr(ptr);
-  else
-#endif
-    int64_tget(j,ptr);
-  return j;
-}
-
-
-String *Field_datetime::val_str(String *val_buffer,
-				String *val_ptr __attribute__((unused)))
-{
-  val_buffer->alloc(field_length);
-  val_buffer->length(field_length);
-  uint64_t tmp;
-  long part1,part2;
-  char *pos;
-  int part3;
-
-#ifdef WORDS_BIGENDIAN
-  if (table && table->s->db_low_byte_first)
-    tmp=sint8korr(ptr);
-  else
-#endif
-    int64_tget(tmp,ptr);
-
-  /*
-    Avoid problem with slow int64_t arithmetic and sprintf
-  */
-
-  part1=(long) (tmp/1000000LL);
-  part2=(long) (tmp - (uint64_t) part1*1000000LL);
-
-  pos=(char*) val_buffer->ptr() + MAX_DATETIME_WIDTH;
-  *pos--=0;
-  *pos--= (char) ('0'+(char) (part2%10)); part2/=10;
-  *pos--= (char) ('0'+(char) (part2%10)); part3= (int) (part2 / 10);
-  *pos--= ':';
-  *pos--= (char) ('0'+(char) (part3%10)); part3/=10;
-  *pos--= (char) ('0'+(char) (part3%10)); part3/=10;
-  *pos--= ':';
-  *pos--= (char) ('0'+(char) (part3%10)); part3/=10;
-  *pos--= (char) ('0'+(char) part3);
-  *pos--= ' ';
-  *pos--= (char) ('0'+(char) (part1%10)); part1/=10;
-  *pos--= (char) ('0'+(char) (part1%10)); part1/=10;
-  *pos--= '-';
-  *pos--= (char) ('0'+(char) (part1%10)); part1/=10;
-  *pos--= (char) ('0'+(char) (part1%10)); part3= (int) (part1/10);
-  *pos--= '-';
-  *pos--= (char) ('0'+(char) (part3%10)); part3/=10;
-  *pos--= (char) ('0'+(char) (part3%10)); part3/=10;
-  *pos--= (char) ('0'+(char) (part3%10)); part3/=10;
-  *pos=(char) ('0'+(char) part3);
-  return val_buffer;
-}
-
-bool Field_datetime::get_date(MYSQL_TIME *ltime, uint fuzzydate)
-{
-  int64_t tmp=Field_datetime::val_int();
-  uint32 part1,part2;
-  part1=(uint32) (tmp/1000000LL);
-  part2=(uint32) (tmp - (uint64_t) part1*1000000LL);
-
-  ltime->time_type=	MYSQL_TIMESTAMP_DATETIME;
-  ltime->neg=		0;
-  ltime->second_part=	0;
-  ltime->second=	(int) (part2%100);
-  ltime->minute=	(int) (part2/100%100);
-  ltime->hour=		(int) (part2/10000);
-  ltime->day=		(int) (part1%100);
-  ltime->month= 	(int) (part1/100%100);
-  ltime->year= 		(int) (part1/10000);
-  return (!(fuzzydate & TIME_FUZZY_DATE) && (!ltime->month || !ltime->day)) ? 1 : 0;
-}
-
-bool Field_datetime::get_time(MYSQL_TIME *ltime)
-{
-  return Field_datetime::get_date(ltime,0);
-}
-
-int Field_datetime::cmp(const uchar *a_ptr, const uchar *b_ptr)
-{
-  int64_t a,b;
-#ifdef WORDS_BIGENDIAN
-  if (table && table->s->db_low_byte_first)
-  {
-    a=sint8korr(a_ptr);
-    b=sint8korr(b_ptr);
-  }
-  else
-#endif
-  {
-    int64_tget(a,a_ptr);
-    int64_tget(b,b_ptr);
-  }
-  return ((uint64_t) a < (uint64_t) b) ? -1 :
-    ((uint64_t) a > (uint64_t) b) ? 1 : 0;
-}
-
-void Field_datetime::sort_string(uchar *to,uint length __attribute__((unused)))
-{
-#ifdef WORDS_BIGENDIAN
-  if (!table || !table->s->db_low_byte_first)
-  {
-    to[0] = ptr[0];
-    to[1] = ptr[1];
-    to[2] = ptr[2];
-    to[3] = ptr[3];
-    to[4] = ptr[4];
-    to[5] = ptr[5];
-    to[6] = ptr[6];
-    to[7] = ptr[7];
-  }
-  else
-#endif
-  {
-    to[0] = ptr[7];
-    to[1] = ptr[6];
-    to[2] = ptr[5];
-    to[3] = ptr[4];
-    to[4] = ptr[3];
-    to[5] = ptr[2];
-    to[6] = ptr[1];
-    to[7] = ptr[0];
-  }
-}
-
-
-void Field_datetime::sql_type(String &res) const
-{
-  res.set_ascii(STRING_WITH_LEN("datetime"));
-}
-
-/****************************************************************************
-** string type
-** A string may be varchar or binary
-****************************************************************************/
 
 /*
   Report "not well formed" or "cannot convert" error
@@ -4505,7 +1691,7 @@
     true  - If an error happened
 */
 
-static bool
+bool
 check_string_copy_error(Field_str *field,
                         const char *well_formed_error_pos,
                         const char *cannot_convert_error_pos,
@@ -4604,40 +1790,6 @@
 }
 
 
-	/* Copy a string and fill with space */
-
-int Field_string::store(const char *from,uint length,CHARSET_INFO *cs)
-{
-  uint copy_length;
-  const char *well_formed_error_pos;
-  const char *cannot_convert_error_pos;
-  const char *from_end_pos;
-
-  /* See the comment for Field_long::store(long long) */
-  assert(table->in_use == current_thd);
-
-  copy_length= well_formed_copy_nchars(field_charset,
-                                       (char*) ptr, field_length,
-                                       cs, from, length,
-                                       field_length / field_charset->mbmaxlen,
-                                       &well_formed_error_pos,
-                                       &cannot_convert_error_pos,
-                                       &from_end_pos);
-
-  /* Append spaces if the string was shorter than the field. */
-  if (copy_length < field_length)
-    field_charset->cset->fill(field_charset,(char*) ptr+copy_length,
-                              field_length-copy_length,
-                              field_charset->pad_char);
-
-  if (check_string_copy_error(this, well_formed_error_pos,
-                              cannot_convert_error_pos, from + length, cs))
-    return 2;
-
-  return report_if_important_data(from_end_pos, from + length);
-}
-
-
 /**
   Store double value in Field_string or Field_varstring.
 
@@ -4693,17 +1845,6 @@
 }
 
 
-int Field_string::store(int64_t nr, bool unsigned_val)
-{
-  char buff[64];
-  int  l;
-  CHARSET_INFO *cs=charset();
-  l= (cs->cset->int64_t10_to_str)(cs,buff,sizeof(buff),
-                                   unsigned_val ? 10 : -10, nr);
-  return Field_string::store(buff,(uint)l,cs);
-}
-
-
 int Field_longstr::store_decimal(const my_decimal *d)
 {
   char buff[DECIMAL_MAX_STR_LENGTH+1];
@@ -4718,1623 +1859,6 @@
 }
 
 
-double Field_string::val_real(void)
-{
-  int error;
-  char *end;
-  CHARSET_INFO *cs= charset();
-  double result;
-  
-  result=  my_strntod(cs,(char*) ptr,field_length,&end,&error);
-  if (!table->in_use->no_errors &&
-      (error || (field_length != (uint32)(end - (char*) ptr) && 
-                 !check_if_only_end_space(cs, end,
-                                          (char*) ptr + field_length))))
-  {
-    char buf[DOUBLE_TO_STRING_CONVERSION_BUFFER_SIZE];
-    String tmp(buf, sizeof(buf), cs);
-    tmp.copy((char*) ptr, field_length, cs);
-    push_warning_printf(current_thd, MYSQL_ERROR::WARN_LEVEL_WARN,
-                        ER_TRUNCATED_WRONG_VALUE, 
-                        ER(ER_TRUNCATED_WRONG_VALUE),
-                        "DOUBLE", tmp.c_ptr());
-  }
-  return result;
-}
-
-
-int64_t Field_string::val_int(void)
-{
-  int error;
-  char *end;
-  CHARSET_INFO *cs= charset();
-  int64_t result;
-
-  result= my_strntoll(cs, (char*) ptr,field_length,10,&end,&error);
-  if (!table->in_use->no_errors &&
-      (error || (field_length != (uint32)(end - (char*) ptr) && 
-                 !check_if_only_end_space(cs, end,
-                                          (char*) ptr + field_length))))
-  {
-    char buf[LONGLONG_TO_STRING_CONVERSION_BUFFER_SIZE];
-    String tmp(buf, sizeof(buf), cs);
-    tmp.copy((char*) ptr, field_length, cs);
-    push_warning_printf(current_thd, MYSQL_ERROR::WARN_LEVEL_WARN,
-                        ER_TRUNCATED_WRONG_VALUE, 
-                        ER(ER_TRUNCATED_WRONG_VALUE),
-                        "INTEGER", tmp.c_ptr());
-  }
-  return result;
-}
-
-
-String *Field_string::val_str(String *val_buffer __attribute__((unused)),
-			      String *val_ptr)
-{
-  /* See the comment for Field_long::store(long long) */
-  assert(table->in_use == current_thd);
-  uint length;
-  if (table->in_use->variables.sql_mode &
-      MODE_PAD_CHAR_TO_FULL_LENGTH)
-    length= my_charpos(field_charset, ptr, ptr + field_length, field_length);
-  else
-    length= field_charset->cset->lengthsp(field_charset, (const char*) ptr,
-                                          field_length);
-  val_ptr->set((const char*) ptr, length, field_charset);
-  return val_ptr;
-}
-
-
-my_decimal *Field_string::val_decimal(my_decimal *decimal_value)
-{
-  int err= str2my_decimal(E_DEC_FATAL_ERROR, (char*) ptr, field_length,
-                          charset(), decimal_value);
-  if (!table->in_use->no_errors && err)
-  {
-    char buf[DECIMAL_TO_STRING_CONVERSION_BUFFER_SIZE];
-    CHARSET_INFO *cs= charset();
-    String tmp(buf, sizeof(buf), cs);
-    tmp.copy((char*) ptr, field_length, cs);
-    push_warning_printf(current_thd, MYSQL_ERROR::WARN_LEVEL_WARN,
-                        ER_TRUNCATED_WRONG_VALUE, 
-                        ER(ER_TRUNCATED_WRONG_VALUE),
-                        "DECIMAL", tmp.c_ptr());
-  }
-
-  return decimal_value;
-}
-
-
-int Field_string::cmp(const uchar *a_ptr, const uchar *b_ptr)
-{
-  uint a_len, b_len;
-
-  if (field_charset->mbmaxlen != 1)
-  {
-    uint char_len= field_length/field_charset->mbmaxlen;
-    a_len= my_charpos(field_charset, a_ptr, a_ptr + field_length, char_len);
-    b_len= my_charpos(field_charset, b_ptr, b_ptr + field_length, char_len);
-  }
-  else
-    a_len= b_len= field_length;
-  /*
-    We have to remove end space to be able to compare multi-byte-characters
-    like in latin_de 'ae' and 0xe4
-  */
-  return field_charset->coll->strnncollsp(field_charset,
-                                          a_ptr, a_len,
-                                          b_ptr, b_len,
-                                          0);
-}
-
-
-void Field_string::sort_string(uchar *to,uint length)
-{
-  uint tmp= my_strnxfrm(field_charset,
-                                 to, length,
-                                 ptr, field_length);
-  assert(tmp == length);
-}
-
-
-void Field_string::sql_type(String &res) const
-{
-  THD *thd= table->in_use;
-  CHARSET_INFO *cs=res.charset();
-  ulong length;
-
-  length= cs->cset->snprintf(cs,(char*) res.ptr(),
-                             res.alloced_length(), "%s(%d)",
-                             ((type() == MYSQL_TYPE_VAR_STRING &&
-                               !thd->variables.new_mode) ?
-                              (has_charset() ? "varchar" : "varbinary") :
-			      (has_charset() ? "char" : "binary")),
-                             (int) field_length / charset()->mbmaxlen);
-  res.length(length);
-  if ((thd->variables.sql_mode & (MODE_MYSQL323 | MODE_MYSQL40)) &&
-      has_charset() && (charset()->state & MY_CS_BINSORT))
-    res.append(STRING_WITH_LEN(" binary"));
-}
-
-
-uchar *Field_string::pack(uchar *to, const uchar *from,
-                          uint max_length,
-                          bool low_byte_first __attribute__((unused)))
-{
-  uint length=      min(field_length,max_length);
-  uint local_char_length= max_length/field_charset->mbmaxlen;
-  if (length > local_char_length)
-    local_char_length= my_charpos(field_charset, from, from+length,
-                                  local_char_length);
-  set_if_smaller(length, local_char_length);
-  while (length && from[length-1] == field_charset->pad_char)
-    length--;
-
-  // Length always stored little-endian
-  *to++= (uchar) length;
-  if (field_length > 255)
-    *to++= (uchar) (length >> 8);
-
-  // Store the actual bytes of the string
-  memcpy(to, from, length);
-  return to+length;
-}
-
-
-/**
-   Unpack a string field from row data.
-
-   This method is used to unpack a string field from a master whose size 
-   of the field is less than that of the slave. Note that there can be a
-   variety of field types represented with this class. Certain types like
-   ENUM or SET are processed differently. Hence, the upper byte of the 
-   @c param_data argument contains the result of field->real_type() from
-   the master.
-
-   @param   to         Destination of the data
-   @param   from       Source of the data
-   @param   param_data Real type (upper) and length (lower) values
-
-   @return  New pointer into memory based on from + length of the data
-*/
-const uchar *
-Field_string::unpack(uchar *to,
-                     const uchar *from,
-                     uint param_data,
-                     bool low_byte_first __attribute__((unused)))
-{
-  uint from_length=
-    param_data ? min(param_data & 0x00ff, field_length) : field_length;
-  uint length;
-
-  if (from_length > 255)
-  {
-    length= uint2korr(from);
-    from+= 2;
-  }
-  else
-    length= (uint) *from++;
-
-  memcpy(to, from, length);
-  // Pad the string with the pad character of the fields charset
-  bfill(to + length, field_length - length, field_charset->pad_char);
-  return from+length;
-}
-
-
-/**
-   Save the field metadata for string fields.
-
-   Saves the real type in the first byte and the field length in the 
-   second byte of the field metadata array at index of *metadata_ptr and
-   *(metadata_ptr + 1).
-
-   @param   metadata_ptr   First byte of field metadata
-
-   @returns number of bytes written to metadata_ptr
-*/
-int Field_string::do_save_field_metadata(uchar *metadata_ptr)
-{
-  *metadata_ptr= real_type();
-  *(metadata_ptr + 1)= field_length;
-  return 2;
-}
-
-
-/*
-  Compare two packed keys
-
-  SYNOPSIS
-    pack_cmp()
-     a			New key
-     b			Original key
-     length		Key length
-     insert_or_update	1 if this is an insert or update
-
-  RETURN
-    < 0	  a < b
-    0	  a = b
-    > 0   a > b
-*/
-
-int Field_string::pack_cmp(const uchar *a, const uchar *b, uint length,
-                           my_bool insert_or_update)
-{
-  uint a_length, b_length;
-  if (length > 255)
-  {
-    a_length= uint2korr(a);
-    b_length= uint2korr(b);
-    a+= 2;
-    b+= 2;
-  }
-  else
-  {
-    a_length= (uint) *a++;
-    b_length= (uint) *b++;
-  }
-  return field_charset->coll->strnncollsp(field_charset,
-                                          a, a_length,
-                                          b, b_length,
-                                          insert_or_update);
-}
-
-
-/**
-  Compare a packed key against row.
-
-  @param key		        Original key
-  @param length		Key length. (May be less than field length)
-  @param insert_or_update	1 if this is an insert or update
-
-  @return
-    < 0	  row < key
-  @return
-    0	  row = key
-  @return
-    > 0   row > key
-*/
-
-int Field_string::pack_cmp(const uchar *key, uint length,
-                           my_bool insert_or_update)
-{
-  uint row_length, local_key_length;
-  uchar *end;
-  if (length > 255)
-  {
-    local_key_length= uint2korr(key);
-    key+= 2;
-  }
-  else
-    local_key_length= (uint) *key++;
-  
-  /* Only use 'length' of key, not field_length */
-  end= ptr + length;
-  while (end > ptr && end[-1] == ' ')
-    end--;
-  row_length= (uint) (end - ptr);
-
-  return field_charset->coll->strnncollsp(field_charset,
-                                          ptr, row_length,
-                                          key, local_key_length,
-                                          insert_or_update);
-}
-
-
-uint Field_string::packed_col_length(const uchar *data_ptr, uint length)
-{
-  if (length > 255)
-    return uint2korr(data_ptr)+2;
-  return (uint) *data_ptr + 1;
-}
-
-
-uint Field_string::max_packed_col_length(uint max_length)
-{
-  return (max_length > 255 ? 2 : 1)+max_length;
-}
-
-
-uint Field_string::get_key_image(uchar *buff,
-                                 uint length,
-                                 imagetype type_arg __attribute__((__unused__)))
-{
-  uint bytes = my_charpos(field_charset, (char*) ptr,
-                          (char*) ptr + field_length,
-                          length / field_charset->mbmaxlen);
-  memcpy(buff, ptr, bytes);
-  if (bytes < length)
-    field_charset->cset->fill(field_charset, (char*) buff + bytes,
-                              length - bytes, field_charset->pad_char);
-  return bytes;
-}
-
-
-Field *Field_string::new_field(MEM_ROOT *root, struct st_table *new_table,
-                               bool keep_type)
-{
-  Field *field;
-  if (type() != MYSQL_TYPE_VAR_STRING || keep_type)
-    field= Field::new_field(root, new_table, keep_type);
-  else if ((field= new Field_varstring(field_length, maybe_null(), field_name,
-                                       new_table->s, charset())))
-  {
-    /*
-      Old VARCHAR field which should be modified to a VARCHAR on copy
-      This is done to ensure that ALTER TABLE will convert old VARCHAR fields
-      to now VARCHAR fields.
-    */
-    field->init(new_table);
-    /*
-      Normally orig_table is different from table only if field was created
-      via ::new_field.  Here we alter the type of field, so ::new_field is
-      not applicable. But we still need to preserve the original field
-      metadata for the client-server protocol.
-    */
-    field->orig_table= orig_table;
-  }
-  return field;
-}
-
-
-/****************************************************************************
-  VARCHAR type
-  Data in field->ptr is stored as:
-    1 or 2 bytes length-prefix-header  (from Field_varstring::length_bytes)
-    data
-
-  NOTE:
-  When VARCHAR is stored in a key (for handler::index_read() etc) it's always
-  stored with a 2 byte prefix. (Just like blob keys).
-
-  Normally length_bytes is calculated as (field_length < 256 : 1 ? 2)
-  The exception is if there is a prefix key field that is part of a long
-  VARCHAR, in which case field_length for this may be 1 but the length_bytes
-  is 2.
-****************************************************************************/
-
-const uint Field_varstring::MAX_SIZE= UINT16_MAX;
-
-/**
-   Save the field metadata for varstring fields.
-
-   Saves the field length in the first byte. Note: may consume
-   2 bytes. Caller must ensure second byte is contiguous with
-   first byte (e.g. array index 0,1).
-
-   @param   metadata_ptr   First byte of field metadata
-
-   @returns number of bytes written to metadata_ptr
-*/
-int Field_varstring::do_save_field_metadata(uchar *metadata_ptr)
-{
-  char *ptr= (char *)metadata_ptr;
-  assert(field_length <= 65535);
-  int2store(ptr, field_length);
-  return 2;
-}
-
-int Field_varstring::store(const char *from,uint length,CHARSET_INFO *cs)
-{
-  uint copy_length;
-  const char *well_formed_error_pos;
-  const char *cannot_convert_error_pos;
-  const char *from_end_pos;
-
-  copy_length= well_formed_copy_nchars(field_charset,
-                                       (char*) ptr + length_bytes,
-                                       field_length,
-                                       cs, from, length,
-                                       field_length / field_charset->mbmaxlen,
-                                       &well_formed_error_pos,
-                                       &cannot_convert_error_pos,
-                                       &from_end_pos);
-
-  if (length_bytes == 1)
-    *ptr= (uchar) copy_length;
-  else
-    int2store(ptr, copy_length);
-
-  if (check_string_copy_error(this, well_formed_error_pos,
-                              cannot_convert_error_pos, from + length, cs))
-    return 2;
-
-  return report_if_important_data(from_end_pos, from + length);
-}
-
-
-int Field_varstring::store(int64_t nr, bool unsigned_val)
-{
-  char buff[64];
-  uint  length;
-  length= (uint) (field_charset->cset->int64_t10_to_str)(field_charset,
-                                                          buff,
-                                                          sizeof(buff),
-                                                          (unsigned_val ? 10:
-                                                           -10),
-                                                           nr);
-  return Field_varstring::store(buff, length, field_charset);
-}
-
-
-double Field_varstring::val_real(void)
-{
-  int not_used;
-  char *end_not_used;
-  uint length= length_bytes == 1 ? (uint) *ptr : uint2korr(ptr);
-  return my_strntod(field_charset, (char*) ptr+length_bytes, length,
-                    &end_not_used, &not_used);
-}
-
-
-int64_t Field_varstring::val_int(void)
-{
-  int not_used;
-  char *end_not_used;
-  uint length= length_bytes == 1 ? (uint) *ptr : uint2korr(ptr);
-  return my_strntoll(field_charset, (char*) ptr+length_bytes, length, 10,
-                     &end_not_used, &not_used);
-}
-
-String *Field_varstring::val_str(String *val_buffer __attribute__((unused)),
-				 String *val_ptr)
-{
-  uint length=  length_bytes == 1 ? (uint) *ptr : uint2korr(ptr);
-  val_ptr->set((const char*) ptr+length_bytes, length, field_charset);
-  return val_ptr;
-}
-
-
-my_decimal *Field_varstring::val_decimal(my_decimal *decimal_value)
-{
-  uint length= length_bytes == 1 ? (uint) *ptr : uint2korr(ptr);
-  str2my_decimal(E_DEC_FATAL_ERROR, (char*) ptr+length_bytes, length,
-                 charset(), decimal_value);
-  return decimal_value;
-}
-
-
-int Field_varstring::cmp_max(const uchar *a_ptr, const uchar *b_ptr,
-                             uint max_len)
-{
-  uint a_length, b_length;
-  int diff;
-
-  if (length_bytes == 1)
-  {
-    a_length= (uint) *a_ptr;
-    b_length= (uint) *b_ptr;
-  }
-  else
-  {
-    a_length= uint2korr(a_ptr);
-    b_length= uint2korr(b_ptr);
-  }
-  set_if_smaller(a_length, max_len);
-  set_if_smaller(b_length, max_len);
-  diff= field_charset->coll->strnncollsp(field_charset,
-                                         a_ptr+
-                                         length_bytes,
-                                         a_length,
-                                         b_ptr+
-                                         length_bytes,
-                                         b_length,0);
-  return diff;
-}
-
-
-/**
-  @note
-    varstring and blob keys are ALWAYS stored with a 2 byte length prefix
-*/
-
-int Field_varstring::key_cmp(const uchar *key_ptr, uint max_key_length)
-{
-  uint length=  length_bytes == 1 ? (uint) *ptr : uint2korr(ptr);
-  uint local_char_length= max_key_length / field_charset->mbmaxlen;
-
-  local_char_length= my_charpos(field_charset, ptr + length_bytes,
-                          ptr + length_bytes + length, local_char_length);
-  set_if_smaller(length, local_char_length);
-  return field_charset->coll->strnncollsp(field_charset, 
-                                          ptr + length_bytes,
-                                          length,
-                                          key_ptr+
-                                          HA_KEY_BLOB_LENGTH,
-                                          uint2korr(key_ptr), 0);
-}
-
-
-/**
-  Compare to key segments (always 2 byte length prefix).
-
-  @note
-    This is used only to compare key segments created for index_read().
-    (keys are created and compared in key.cc)
-*/
-
-int Field_varstring::key_cmp(const uchar *a,const uchar *b)
-{
-  return field_charset->coll->strnncollsp(field_charset,
-                                          a + HA_KEY_BLOB_LENGTH,
-                                          uint2korr(a),
-                                          b + HA_KEY_BLOB_LENGTH,
-                                          uint2korr(b),
-                                          0);
-}
-
-
-void Field_varstring::sort_string(uchar *to,uint length)
-{
-  uint tot_length=  length_bytes == 1 ? (uint) *ptr : uint2korr(ptr);
-
-  if (field_charset == &my_charset_bin)
-  {
-    /* Store length last in high-byte order to sort longer strings first */
-    if (length_bytes == 1)
-      to[length-1]= tot_length;
-    else
-      mi_int2store(to+length-2, tot_length);
-    length-= length_bytes;
-  }
- 
-  tot_length= my_strnxfrm(field_charset,
-			  to, length, ptr + length_bytes,
-			  tot_length);
-  assert(tot_length == length);
-}
-
-
-enum ha_base_keytype Field_varstring::key_type() const
-{
-  enum ha_base_keytype res;
-
-  if (binary())
-    res= length_bytes == 1 ? HA_KEYTYPE_VARBINARY1 : HA_KEYTYPE_VARBINARY2;
-  else
-    res= length_bytes == 1 ? HA_KEYTYPE_VARTEXT1 : HA_KEYTYPE_VARTEXT2;
-  return res;
-}
-
-
-void Field_varstring::sql_type(String &res) const
-{
-  THD *thd= table->in_use;
-  CHARSET_INFO *cs=res.charset();
-  ulong length;
-
-  length= cs->cset->snprintf(cs,(char*) res.ptr(),
-                             res.alloced_length(), "%s(%d)",
-                              (has_charset() ? "varchar" : "varbinary"),
-                             (int) field_length / charset()->mbmaxlen);
-  res.length(length);
-  if ((thd->variables.sql_mode & (MODE_MYSQL323 | MODE_MYSQL40)) &&
-      has_charset() && (charset()->state & MY_CS_BINSORT))
-    res.append(STRING_WITH_LEN(" binary"));
-}
-
-
-uint32 Field_varstring::data_length()
-{
-  return length_bytes == 1 ? (uint32) *ptr : uint2korr(ptr);
-}
-
-uint32 Field_varstring::used_length()
-{
-  return length_bytes == 1 ? 1 + (uint32) (uchar) *ptr : 2 + uint2korr(ptr);
-}
-
-/*
-  Functions to create a packed row.
-  Here the number of length bytes are depending on the given max_length
-*/
-
-uchar *Field_varstring::pack(uchar *to, const uchar *from,
-                             uint max_length,
-                             bool low_byte_first __attribute__((unused)))
-{
-  uint length= length_bytes == 1 ? (uint) *from : uint2korr(from);
-  set_if_smaller(max_length, field_length);
-  if (length > max_length)
-    length=max_length;
-
-  /* Length always stored little-endian */
-  *to++= length & 0xFF;
-  if (max_length > 255)
-    *to++= (length >> 8) & 0xFF;
-
-  /* Store bytes of string */
-  if (length > 0)
-    memcpy(to, from+length_bytes, length);
-  return to+length;
-}
-
-
-uchar *
-Field_varstring::pack_key(uchar *to, const uchar *key, uint max_length,
-                          bool low_byte_first __attribute__((unused)))
-{
-  uint length=  length_bytes == 1 ? (uint) *key : uint2korr(key);
-  uint local_char_length= ((field_charset->mbmaxlen > 1) ?
-                     max_length/field_charset->mbmaxlen : max_length);
-  key+= length_bytes;
-  if (length > local_char_length)
-  {
-    local_char_length= my_charpos(field_charset, key, key+length,
-                                  local_char_length);
-    set_if_smaller(length, local_char_length);
-  }
-  *to++= (char) (length & 255);
-  if (max_length > 255)
-    *to++= (char) (length >> 8);
-  if (length)
-    memcpy(to, key, length);
-  return to+length;
-}
-
-
-/**
-  Unpack a key into a record buffer.
-
-  A VARCHAR key has a maximum size of 64K-1.
-  In its packed form, the length field is one or two bytes long,
-  depending on 'max_length'.
-
-  @param to                          Pointer into the record buffer.
-  @param key                         Pointer to the packed key.
-  @param max_length                  Key length limit from key description.
-
-  @return
-    Pointer to end of 'key' (To the next key part if multi-segment key)
-*/
-
-const uchar *
-Field_varstring::unpack_key(uchar *to __attribute__((__unused__)),
-                            const uchar *key, uint max_length,
-                            bool low_byte_first __attribute__((unused)))
-{
-  /* get length of the blob key */
-  uint32 length= *key++;
-  if (max_length > 255)
-    length+= (*key++) << 8;
-
-  /* put the length into the record buffer */
-  if (length_bytes == 1)
-    *ptr= (uchar) length;
-  else
-    int2store(ptr, length);
-  memcpy(ptr + length_bytes, key, length);
-  return key + length;
-}
-
-/**
-  Create a packed key that will be used for storage in the index tree.
-
-  @param to		Store packed key segment here
-  @param from		Key segment (as given to index_read())
-  @param max_length  	Max length of key
-
-  @return
-    end of key storage
-*/
-
-uchar *
-Field_varstring::pack_key_from_key_image(uchar *to, const uchar *from, uint max_length,
-                                         bool low_byte_first __attribute__((unused)))
-{
-  /* Key length is always stored as 2 bytes */
-  uint length= uint2korr(from);
-  if (length > max_length)
-    length= max_length;
-  *to++= (char) (length & 255);
-  if (max_length > 255)
-    *to++= (char) (length >> 8);
-  if (length)
-    memcpy(to, from+HA_KEY_BLOB_LENGTH, length);
-  return to+length;
-}
-
-
-/**
-   Unpack a varstring field from row data.
-
-   This method is used to unpack a varstring field from a master
-   whose size of the field is less than that of the slave.
-
-   @note
-   The string length is always packed little-endian.
-  
-   @param   to         Destination of the data
-   @param   from       Source of the data
-   @param   param_data Length bytes from the master's field data
-
-   @return  New pointer into memory based on from + length of the data
-*/
-const uchar *
-Field_varstring::unpack(uchar *to, const uchar *from,
-                        uint param_data,
-                        bool low_byte_first __attribute__((unused)))
-{
-  uint length;
-  uint l_bytes= (param_data && (param_data < field_length)) ? 
-                (param_data <= 255) ? 1 : 2 : length_bytes;
-  if (l_bytes == 1)
-  {
-    to[0]= *from++;
-    length= to[0];
-    if (length_bytes == 2)
-      to[1]= 0;
-  }
-  else /* l_bytes == 2 */
-  {
-    length= uint2korr(from);
-    to[0]= *from++;
-    to[1]= *from++;
-  }
-  if (length)
-    memcpy(to+ length_bytes, from, length);
-  return from+length;
-}
-
-
-int Field_varstring::pack_cmp(const uchar *a, const uchar *b,
-                              uint key_length_arg,
-                              my_bool insert_or_update)
-{
-  uint a_length, b_length;
-  if (key_length_arg > 255)
-  {
-    a_length=uint2korr(a); a+= 2;
-    b_length=uint2korr(b); b+= 2;
-  }
-  else
-  {
-    a_length= (uint) *a++;
-    b_length= (uint) *b++;
-  }
-  return field_charset->coll->strnncollsp(field_charset,
-                                          a, a_length,
-                                          b, b_length,
-                                          insert_or_update);
-}
-
-
-int Field_varstring::pack_cmp(const uchar *b, uint key_length_arg,
-                              my_bool insert_or_update)
-{
-  uchar *a= ptr+ length_bytes;
-  uint a_length=  length_bytes == 1 ? (uint) *ptr : uint2korr(ptr);
-  uint b_length;
-  uint local_char_length= ((field_charset->mbmaxlen > 1) ?
-                           key_length_arg / field_charset->mbmaxlen :
-                           key_length_arg);
-
-  if (key_length_arg > 255)
-  {
-    b_length=uint2korr(b); b+= HA_KEY_BLOB_LENGTH;
-  }
-  else
-    b_length= (uint) *b++;
-
-  if (a_length > local_char_length)
-  {
-    local_char_length= my_charpos(field_charset, a, a+a_length,
-                                  local_char_length);
-    set_if_smaller(a_length, local_char_length);
-  }
-
-  return field_charset->coll->strnncollsp(field_charset,
-                                          a, a_length,
-                                          b, b_length,
-                                          insert_or_update);
-}
-
-
-uint Field_varstring::packed_col_length(const uchar *data_ptr, uint length)
-{
-  if (length > 255)
-    return uint2korr(data_ptr)+2;
-  return (uint) *data_ptr + 1;
-}
-
-
-uint Field_varstring::max_packed_col_length(uint max_length)
-{
-  return (max_length > 255 ? 2 : 1)+max_length;
-}
-
-uint Field_varstring::get_key_image(uchar *buff,
-                                    uint length,
-                                    imagetype type __attribute__((__unused__)))
-{
-  uint f_length=  length_bytes == 1 ? (uint) *ptr : uint2korr(ptr);
-  uint local_char_length= length / field_charset->mbmaxlen;
-  uchar *pos= ptr+length_bytes;
-  local_char_length= my_charpos(field_charset, pos, pos + f_length,
-                                local_char_length);
-  set_if_smaller(f_length, local_char_length);
-  /* Key is always stored with 2 bytes */
-  int2store(buff,f_length);
-  memcpy(buff+HA_KEY_BLOB_LENGTH, pos, f_length);
-  if (f_length < length)
-  {
-    /*
-      Must clear this as we do a memcmp in opt_range.cc to detect
-      identical keys
-    */
-    bzero(buff+HA_KEY_BLOB_LENGTH+f_length, (length-f_length));
-  }
-  return HA_KEY_BLOB_LENGTH+f_length;
-}
-
-
-void Field_varstring::set_key_image(const uchar *buff,uint length)
-{
-  length= uint2korr(buff);			// Real length is here
-  (void) Field_varstring::store((const char*) buff+HA_KEY_BLOB_LENGTH, length,
-                                field_charset);
-}
-
-
-int Field_varstring::cmp_binary(const uchar *a_ptr, const uchar *b_ptr,
-                                uint32 max_length)
-{
-  uint32 a_length,b_length;
-
-  if (length_bytes == 1)
-  {
-    a_length= (uint) *a_ptr;
-    b_length= (uint) *b_ptr;
-  }
-  else
-  {
-    a_length= uint2korr(a_ptr);
-    b_length= uint2korr(b_ptr);
-  }
-  set_if_smaller(a_length, max_length);
-  set_if_smaller(b_length, max_length);
-  if (a_length != b_length)
-    return 1;
-  return memcmp(a_ptr+length_bytes, b_ptr+length_bytes, a_length);
-}
-
-
-Field *Field_varstring::new_field(MEM_ROOT *root, struct st_table *new_table,
-                                  bool keep_type)
-{
-  Field_varstring *res= (Field_varstring*) Field::new_field(root, new_table,
-                                                            keep_type);
-  if (res)
-    res->length_bytes= length_bytes;
-  return res;
-}
-
-
-Field *Field_varstring::new_key_field(MEM_ROOT *root,
-                                      struct st_table *new_table,
-                                      uchar *new_ptr, uchar *new_null_ptr,
-                                      uint new_null_bit)
-{
-  Field_varstring *res;
-  if ((res= (Field_varstring*) Field::new_key_field(root,
-                                                    new_table,
-                                                    new_ptr,
-                                                    new_null_ptr,
-                                                    new_null_bit)))
-  {
-    /* Keys length prefixes are always packed with 2 bytes */
-    res->length_bytes= 2;
-  }
-  return res;
-}
-
-
-uint Field_varstring::is_equal(Create_field *new_field)
-{
-  if (new_field->sql_type == real_type() &&
-      new_field->charset == field_charset)
-  {
-    if (new_field->length == max_display_length())
-      return IS_EQUAL_YES;
-    if (new_field->length > max_display_length() &&
-	((new_field->length <= 255 && max_display_length() <= 255) ||
-	 (new_field->length > 255 && max_display_length() > 255)))
-      return IS_EQUAL_PACK_LENGTH; // VARCHAR, longer variable length
-  }
-  return IS_EQUAL_NO;
-}
-
-
-void Field_varstring::hash(ulong *nr, ulong *nr2)
-{
-  if (is_null())
-  {
-    *nr^= (*nr << 1) | 1;
-  }
-  else
-  {
-    uint len=  length_bytes == 1 ? (uint) *ptr : uint2korr(ptr);
-    CHARSET_INFO *cs= charset();
-    cs->coll->hash_sort(cs, ptr + length_bytes, len, nr, nr2);
-  }
-}
-
-
-/****************************************************************************
-** blob type
-** A blob is saved as a length and a pointer. The length is stored in the
-** packlength slot and may be from 1-4.
-****************************************************************************/
-
-Field_blob::Field_blob(uchar *ptr_arg, uchar *null_ptr_arg, uchar null_bit_arg,
-		       enum utype unireg_check_arg, const char *field_name_arg,
-                       TABLE_SHARE *share, uint blob_pack_length,
-		       CHARSET_INFO *cs)
-  :Field_longstr(ptr_arg, BLOB_PACK_LENGTH_TO_MAX_LENGH(blob_pack_length),
-                 null_ptr_arg, null_bit_arg, unireg_check_arg, field_name_arg,
-                 cs),
-   packlength(blob_pack_length)
-{
-  flags|= BLOB_FLAG;
-  share->blob_fields++;
-  /* TODO: why do not fill table->s->blob_field array here? */
-}
-
-
-void Field_blob::store_length(uchar *i_ptr,
-                              uint i_packlength,
-                              uint32 i_number,
-                              bool low_byte_first __attribute__((__unused__)))
-{
-  switch (i_packlength) {
-  case 1:
-    i_ptr[0]= (uchar) i_number;
-    break;
-  case 2:
-#ifdef WORDS_BIGENDIAN
-    if (low_byte_first)
-    {
-      int2store(i_ptr,(unsigned short) i_number);
-    }
-    else
-#endif
-      shortstore(i_ptr,(unsigned short) i_number);
-    break;
-  case 3:
-    int3store(i_ptr,i_number);
-    break;
-  case 4:
-#ifdef WORDS_BIGENDIAN
-    if (low_byte_first)
-    {
-      int4store(i_ptr,i_number);
-    }
-    else
-#endif
-      longstore(i_ptr,i_number);
-  }
-}
-
-
-uint32 Field_blob::get_length(const uchar *pos,
-                              uint packlength_arg,
-                              bool low_byte_first __attribute__((__unused__)))
-{
-  switch (packlength_arg) {
-  case 1:
-    return (uint32) pos[0];
-  case 2:
-    {
-      uint16 tmp;
-#ifdef WORDS_BIGENDIAN
-      if (low_byte_first)
-	tmp=sint2korr(pos);
-      else
-#endif
-	shortget(tmp,pos);
-      return (uint32) tmp;
-    }
-  case 3:
-    return (uint32) uint3korr(pos);
-  case 4:
-    {
-      uint32 tmp;
-#ifdef WORDS_BIGENDIAN
-      if (low_byte_first)
-	tmp=uint4korr(pos);
-      else
-#endif
-	longget(tmp,pos);
-      return (uint32) tmp;
-    }
-  }
-  return 0;					// Impossible
-}
-
-
-/**
-  Put a blob length field into a record buffer.
-
-  Depending on the maximum length of a blob, its length field is
-  put into 1 to 4 bytes. This is a property of the blob object,
-  described by 'packlength'.
-
-  @param pos                 Pointer into the record buffer.
-  @param length              The length value to put.
-*/
-
-void Field_blob::put_length(uchar *pos, uint32 length)
-{
-  switch (packlength) {
-  case 1:
-    *pos= (char) length;
-    break;
-  case 2:
-    int2store(pos, length);
-    break;
-  case 3:
-    int3store(pos, length);
-    break;
-  case 4:
-    int4store(pos, length);
-    break;
-  }
-}
-
-
-int Field_blob::store(const char *from,uint length,CHARSET_INFO *cs)
-{
-  uint copy_length, new_length;
-  const char *well_formed_error_pos;
-  const char *cannot_convert_error_pos;
-  const char *from_end_pos, *tmp;
-  char buff[STRING_BUFFER_USUAL_SIZE];
-  String tmpstr(buff,sizeof(buff), &my_charset_bin);
-
-  if (!length)
-  {
-    bzero(ptr,Field_blob::pack_length());
-    return 0;
-  }
-
-  if (from == value.ptr())
-  {
-    uint32 dummy_offset;
-    if (!String::needs_conversion(length, cs, field_charset, &dummy_offset))
-    {
-      Field_blob::store_length(length);
-      bmove(ptr+packlength,(char*) &from,sizeof(char*));
-      return 0;
-    }
-    if (tmpstr.copy(from, length, cs))
-      goto oom_error;
-    from= tmpstr.ptr();
-  }
-
-  new_length= min(max_data_length(), field_charset->mbmaxlen * length);
-  if (value.alloc(new_length))
-    goto oom_error;
-
-
-  if (f_is_hex_escape(flags))
-  {
-    copy_length= my_copy_with_hex_escaping(field_charset,
-                                           (char*) value.ptr(), new_length,
-                                            from, length);
-    Field_blob::store_length(copy_length);
-    tmp= value.ptr();
-    bmove(ptr + packlength, (uchar*) &tmp, sizeof(char*));
-    return 0;
-  }
-  /*
-    "length" is OK as "nchars" argument to well_formed_copy_nchars as this
-    is never used to limit the length of the data. The cut of long data
-    is done with the new_length value.
-  */
-  copy_length= well_formed_copy_nchars(field_charset,
-                                       (char*) value.ptr(), new_length,
-                                       cs, from, length,
-                                       length,
-                                       &well_formed_error_pos,
-                                       &cannot_convert_error_pos,
-                                       &from_end_pos);
-
-  Field_blob::store_length(copy_length);
-  tmp= value.ptr();
-  bmove(ptr+packlength,(uchar*) &tmp,sizeof(char*));
-
-  if (check_string_copy_error(this, well_formed_error_pos,
-                              cannot_convert_error_pos, from + length, cs))
-    return 2;
-
-  return report_if_important_data(from_end_pos, from + length);
-
-oom_error:
-  /* Fatal OOM error */
-  bzero(ptr,Field_blob::pack_length());
-  return -1; 
-}
-
-
-int Field_blob::store(double nr)
-{
-  CHARSET_INFO *cs=charset();
-  value.set_real(nr, NOT_FIXED_DEC, cs);
-  return Field_blob::store(value.ptr(),(uint) value.length(), cs);
-}
-
-
-int Field_blob::store(int64_t nr, bool unsigned_val)
-{
-  CHARSET_INFO *cs=charset();
-  value.set_int(nr, unsigned_val, cs);
-  return Field_blob::store(value.ptr(), (uint) value.length(), cs);
-}
-
-
-double Field_blob::val_real(void)
-{
-  int not_used;
-  char *end_not_used, *blob;
-  uint32 length;
-  CHARSET_INFO *cs;
-
-  memcpy_fixed(&blob,ptr+packlength,sizeof(char*));
-  if (!blob)
-    return 0.0;
-  length= get_length(ptr);
-  cs= charset();
-  return my_strntod(cs, blob, length, &end_not_used, &not_used);
-}
-
-
-int64_t Field_blob::val_int(void)
-{
-  int not_used;
-  char *blob;
-  memcpy_fixed(&blob,ptr+packlength,sizeof(char*));
-  if (!blob)
-    return 0;
-  uint32 length=get_length(ptr);
-  return my_strntoll(charset(),blob,length,10,NULL,&not_used);
-}
-
-String *Field_blob::val_str(String *val_buffer __attribute__((unused)),
-			    String *val_ptr)
-{
-  char *blob;
-  memcpy_fixed(&blob,ptr+packlength,sizeof(char*));
-  if (!blob)
-    val_ptr->set("",0,charset());	// A bit safer than ->length(0)
-  else
-    val_ptr->set((const char*) blob,get_length(ptr),charset());
-  return val_ptr;
-}
-
-
-my_decimal *Field_blob::val_decimal(my_decimal *decimal_value)
-{
-  const char *blob;
-  size_t length;
-  memcpy_fixed(&blob, ptr+packlength, sizeof(const uchar*));
-  if (!blob)
-  {
-    blob= "";
-    length= 0;
-  }
-  else
-    length= get_length(ptr);
-
-  str2my_decimal(E_DEC_FATAL_ERROR, blob, length, charset(),
-                 decimal_value);
-  return decimal_value;
-}
-
-
-int Field_blob::cmp(const uchar *a,uint32 a_length, const uchar *b,
-		    uint32 b_length)
-{
-  return field_charset->coll->strnncollsp(field_charset, 
-                                          a, a_length, b, b_length,
-                                          0);
-}
-
-
-int Field_blob::cmp_max(const uchar *a_ptr, const uchar *b_ptr,
-                        uint max_length)
-{
-  uchar *blob1,*blob2;
-  memcpy_fixed(&blob1,a_ptr+packlength,sizeof(char*));
-  memcpy_fixed(&blob2,b_ptr+packlength,sizeof(char*));
-  uint a_len= get_length(a_ptr), b_len= get_length(b_ptr);
-  set_if_smaller(a_len, max_length);
-  set_if_smaller(b_len, max_length);
-  return Field_blob::cmp(blob1,a_len,blob2,b_len);
-}
-
-
-int Field_blob::cmp_binary(const uchar *a_ptr, const uchar *b_ptr,
-			   uint32 max_length)
-{
-  char *a,*b;
-  uint diff;
-  uint32 a_length,b_length;
-  memcpy_fixed(&a,a_ptr+packlength,sizeof(char*));
-  memcpy_fixed(&b,b_ptr+packlength,sizeof(char*));
-  a_length=get_length(a_ptr);
-  if (a_length > max_length)
-    a_length=max_length;
-  b_length=get_length(b_ptr);
-  if (b_length > max_length)
-    b_length=max_length;
-  diff=memcmp(a,b,min(a_length,b_length));
-  return diff ? diff : (int) (a_length - b_length);
-}
-
-
-/* The following is used only when comparing a key */
-
-uint Field_blob::get_key_image(uchar *buff,
-                               uint length,
-                               imagetype type_arg __attribute__((__unused__)))
-{
-  uint32 blob_length= get_length(ptr);
-  uchar *blob;
-
-  get_ptr(&blob);
-  uint local_char_length= length / field_charset->mbmaxlen;
-  local_char_length= my_charpos(field_charset, blob, blob + blob_length,
-                          local_char_length);
-  set_if_smaller(blob_length, local_char_length);
-
-  if ((uint32) length > blob_length)
-  {
-    /*
-      Must clear this as we do a memcmp in opt_range.cc to detect
-      identical keys
-    */
-    bzero(buff+HA_KEY_BLOB_LENGTH+blob_length, (length-blob_length));
-    length=(uint) blob_length;
-  }
-  int2store(buff,length);
-  memcpy(buff+HA_KEY_BLOB_LENGTH, blob, length);
-  return HA_KEY_BLOB_LENGTH+length;
-}
-
-
-void Field_blob::set_key_image(const uchar *buff,uint length)
-{
-  length= uint2korr(buff);
-  (void) Field_blob::store((const char*) buff+HA_KEY_BLOB_LENGTH, length,
-                           field_charset);
-}
-
-
-int Field_blob::key_cmp(const uchar *key_ptr, uint max_key_length)
-{
-  uchar *blob1;
-  uint blob_length=get_length(ptr);
-  memcpy_fixed(&blob1,ptr+packlength,sizeof(char*));
-  CHARSET_INFO *cs= charset();
-  uint local_char_length= max_key_length / cs->mbmaxlen;
-  local_char_length= my_charpos(cs, blob1, blob1+blob_length,
-                                local_char_length);
-  set_if_smaller(blob_length, local_char_length);
-  return Field_blob::cmp(blob1, blob_length,
-			 key_ptr+HA_KEY_BLOB_LENGTH,
-			 uint2korr(key_ptr));
-}
-
-int Field_blob::key_cmp(const uchar *a,const uchar *b)
-{
-  return Field_blob::cmp(a+HA_KEY_BLOB_LENGTH, uint2korr(a),
-			 b+HA_KEY_BLOB_LENGTH, uint2korr(b));
-}
-
-
-/**
-   Save the field metadata for blob fields.
-
-   Saves the pack length in the first byte of the field metadata array
-   at index of *metadata_ptr.
-
-   @param   metadata_ptr   First byte of field metadata
-
-   @returns number of bytes written to metadata_ptr
-*/
-int Field_blob::do_save_field_metadata(uchar *metadata_ptr)
-{
-  *metadata_ptr= pack_length_no_ptr();
-  return 1;
-}
-
-
-uint32 Field_blob::sort_length() const
-{
-  return (uint32) (current_thd->variables.max_sort_length + 
-                   (field_charset == &my_charset_bin ? 0 : packlength));
-}
-
-
-void Field_blob::sort_string(uchar *to,uint length)
-{
-  uchar *blob;
-  uint blob_length=get_length();
-
-  if (!blob_length)
-    bzero(to,length);
-  else
-  {
-    if (field_charset == &my_charset_bin)
-    {
-      uchar *pos;
-
-      /*
-        Store length of blob last in blob to shorter blobs before longer blobs
-      */
-      length-= packlength;
-      pos= to+length;
-
-      switch (packlength) {
-      case 1:
-        *pos= (char) blob_length;
-        break;
-      case 2:
-        mi_int2store(pos, blob_length);
-        break;
-      case 3:
-        mi_int3store(pos, blob_length);
-        break;
-      case 4:
-        mi_int4store(pos, blob_length);
-        break;
-      }
-    }
-    memcpy_fixed(&blob,ptr+packlength,sizeof(char*));
-    
-    blob_length=my_strnxfrm(field_charset,
-                            to, length, blob, blob_length);
-    assert(blob_length == length);
-  }
-}
-
-
-void Field_blob::sql_type(String &res) const
-{
-  const char *str;
-  uint length;
-  switch (packlength) {
-  default: str="tiny"; length=4; break;
-  case 2:  str="";     length=0; break;
-  case 3:  str="medium"; length= 6; break;
-  case 4:  str="long";  length=4; break;
-  }
-  res.set_ascii(str,length);
-  if (charset() == &my_charset_bin)
-    res.append(STRING_WITH_LEN("blob"));
-  else
-  {
-    res.append(STRING_WITH_LEN("text"));
-  }
-}
-
-uchar *Field_blob::pack(uchar *to, const uchar *from,
-                        uint max_length, bool low_byte_first)
-{
-  uchar *save= ptr;
-  ptr= (uchar*) from;
-  uint32 length=get_length();			// Length of from string
-
-  /*
-    Store max length, which will occupy packlength bytes. If the max
-    length given is smaller than the actual length of the blob, we
-    just store the initial bytes of the blob.
-  */
-  store_length(to, packlength, min(length, max_length), low_byte_first);
-
-  /*
-    Store the actual blob data, which will occupy 'length' bytes.
-   */
-  if (length > 0)
-  {
-    get_ptr((uchar**) &from);
-    memcpy(to+packlength, from,length);
-  }
-  ptr=save;					// Restore org row pointer
-  return(to+packlength+length);
-}
-
-
-/**
-   Unpack a blob field from row data.
-
-   This method is used to unpack a blob field from a master whose size of 
-   the field is less than that of the slave. Note: This method is included
-   to satisfy inheritance rules, but is not needed for blob fields. It
-   simply is used as a pass-through to the original unpack() method for
-   blob fields.
-
-   @param   to         Destination of the data
-   @param   from       Source of the data
-   @param   param_data @c true if base types should be stored in little-
-                       endian format, @c false if native format should
-                       be used.
-
-   @return  New pointer into memory based on from + length of the data
-*/
-const uchar *Field_blob::unpack(uchar *to __attribute__((__unused__)),
-                                const uchar *from,
-                                uint param_data,
-                                bool low_byte_first)
-{
-  uint const master_packlength=
-    param_data > 0 ? param_data & 0xFF : packlength;
-  uint32 const length= get_length(from, master_packlength, low_byte_first);
-  bitmap_set_bit(table->write_set, field_index);
-  store(reinterpret_cast<const char*>(from) + master_packlength,
-        length, field_charset);
-  return(from + master_packlength + length);
-}
-
-/* Keys for blobs are like keys on varchars */
-
-int Field_blob::pack_cmp(const uchar *a, const uchar *b, uint key_length_arg,
-                         my_bool insert_or_update)
-{
-  uint a_length, b_length;
-  if (key_length_arg > 255)
-  {
-    a_length=uint2korr(a); a+=2;
-    b_length=uint2korr(b); b+=2;
-  }
-  else
-  {
-    a_length= (uint) *a++;
-    b_length= (uint) *b++;
-  }
-  return field_charset->coll->strnncollsp(field_charset,
-                                          a, a_length,
-                                          b, b_length,
-                                          insert_or_update);
-}
-
-
-int Field_blob::pack_cmp(const uchar *b, uint key_length_arg,
-                         my_bool insert_or_update)
-{
-  uchar *a;
-  uint a_length, b_length;
-  memcpy_fixed(&a,ptr+packlength,sizeof(char*));
-  if (!a)
-    return key_length_arg > 0 ? -1 : 0;
-
-  a_length= get_length(ptr);
-  if (key_length_arg > 255)
-  {
-    b_length= uint2korr(b); b+=2;
-  }
-  else
-    b_length= (uint) *b++;
-  return field_charset->coll->strnncollsp(field_charset,
-                                          a, a_length,
-                                          b, b_length,
-                                          insert_or_update);
-}
-
-/** Create a packed key that will be used for storage from a MySQL row. */
-
-uchar *
-Field_blob::pack_key(uchar *to, const uchar *from, uint max_length,
-                     bool low_byte_first __attribute__((unused)))
-{
-  uchar *save= ptr;
-  ptr= (uchar*) from;
-  uint32 length=get_length();        // Length of from string
-  uint local_char_length= ((field_charset->mbmaxlen > 1) ?
-                           max_length/field_charset->mbmaxlen : max_length);
-  if (length)
-    get_ptr((uchar**) &from);
-  if (length > local_char_length)
-    local_char_length= my_charpos(field_charset, from, from+length,
-                                  local_char_length);
-  set_if_smaller(length, local_char_length);
-  *to++= (uchar) length;
-  if (max_length > 255)				// 2 byte length
-    *to++= (uchar) (length >> 8);
-  memcpy(to, from, length);
-  ptr=save;					// Restore org row pointer
-  return to+length;
-}
-
-
-/**
-  Unpack a blob key into a record buffer.
-
-  A blob key has a maximum size of 64K-1.
-  In its packed form, the length field is one or two bytes long,
-  depending on 'max_length'.
-  Depending on the maximum length of a blob, its length field is
-  put into 1 to 4 bytes. This is a property of the blob object,
-  described by 'packlength'.
-  Blobs are internally stored apart from the record buffer, which
-  contains a pointer to the blob buffer.
-
-
-  @param to                          Pointer into the record buffer.
-  @param from                        Pointer to the packed key.
-  @param max_length                  Key length limit from key description.
-
-  @return
-    Pointer into 'from' past the last byte copied from packed key.
-*/
-
-const uchar *
-Field_blob::unpack_key(uchar *to, const uchar *from, uint max_length,
-                       bool low_byte_first __attribute__((unused)))
-{
-  /* get length of the blob key */
-  uint32 length= *from++;
-  if (max_length > 255)
-    length+= *from++ << 8;
-
-  /* put the length into the record buffer */
-  put_length(to, length);
-
-  /* put the address of the blob buffer or NULL */
-  if (length)
-    memcpy_fixed(to + packlength, &from, sizeof(from));
-  else
-    bzero(to + packlength, sizeof(from));
-
-  /* point to first byte of next field in 'from' */
-  return from + length;
-}
-
-
-/** Create a packed key that will be used for storage from a MySQL key. */
-
-uchar *
-Field_blob::pack_key_from_key_image(uchar *to, const uchar *from, uint max_length,
-                                    bool low_byte_first __attribute__((unused)))
-{
-  uint length=uint2korr(from);
-  if (length > max_length)
-    length=max_length;
-  *to++= (char) (length & 255);
-  if (max_length > 255)
-    *to++= (char) (length >> 8);
-  if (length)
-    memcpy(to, from+HA_KEY_BLOB_LENGTH, length);
-  return to+length;
-}
-
-
-uint Field_blob::packed_col_length(const uchar *data_ptr, uint length)
-{
-  if (length > 255)
-    return uint2korr(data_ptr)+2;
-  return (uint) *data_ptr + 1;
-}
-
-
-uint Field_blob::max_packed_col_length(uint max_length)
-{
-  return (max_length > 255 ? 2 : 1)+max_length;
-}
-
-
-uint Field_blob::is_equal(Create_field *new_field)
-{
-  if (compare_str_field_flags(new_field, flags))
-    return 0;
-
-  return ((new_field->sql_type == get_blob_type_from_length(max_data_length()))
-          && new_field->charset == field_charset &&
-          ((Field_blob *)new_field->field)->max_data_length() ==
-          max_data_length());
-}
-
-
 /****************************************************************************
 ** enum type.
 ** This is a string which only can have a selection of different values.
@@ -6602,120 +2126,6 @@
 }
 
 
-/*
-   set type.
-   This is a string which can have a collection of different values.
-   Each string value is separated with a ','.
-   For example "One,two,five"
-   If one uses this string in a number context one gets the bits as a int64_t
-   number.
-*/
-
-
-int Field_set::store(const char *from,uint length,CHARSET_INFO *cs)
-{
-  bool got_warning= 0;
-  int err= 0;
-  char *not_used;
-  uint not_used2;
-  uint32 not_used_offset;
-  char buff[STRING_BUFFER_USUAL_SIZE];
-  String tmpstr(buff,sizeof(buff), &my_charset_bin);
-
-  /* Convert character set if necessary */
-  if (String::needs_conversion(length, cs, field_charset, &not_used_offset))
-  { 
-    uint dummy_errors;
-    tmpstr.copy(from, length, cs, field_charset, &dummy_errors);
-    from= tmpstr.ptr();
-    length=  tmpstr.length();
-  }
-  uint64_t tmp= find_set(typelib, from, length, field_charset,
-                          &not_used, &not_used2, &got_warning);
-  if (!tmp && length && length < 22)
-  {
-    /* This is for reading numbers with LOAD DATA INFILE */
-    char *end;
-    tmp=my_strntoull(cs,from,length,10,&end,&err);
-    if (err || end != from+length ||
-	tmp > (uint64_t) (((int64_t) 1 << typelib->count) - (int64_t) 1))
-    {
-      tmp=0;      
-      set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, WARN_DATA_TRUNCATED, 1);
-    }
-  }
-  else if (got_warning)
-    set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, WARN_DATA_TRUNCATED, 1);
-  store_type(tmp);
-  return err;
-}
-
-
-int Field_set::store(int64_t nr,
-                     bool unsigned_val __attribute__((__unused__)))
-{
-  int error= 0;
-  uint64_t max_nr= set_bits(uint64_t, typelib->count);
-  if ((uint64_t) nr > max_nr)
-  {
-    nr&= max_nr;
-    set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, WARN_DATA_TRUNCATED, 1);
-    error=1;
-  }
-  store_type((uint64_t) nr);
-  return error;
-}
-
-
-String *Field_set::val_str(String *val_buffer,
-			   String *val_ptr __attribute__((unused)))
-{
-  uint64_t tmp=(uint64_t) Field_enum::val_int();
-  uint bitnr=0;
-
-  val_buffer->length(0);
-  val_buffer->set_charset(field_charset);
-  while (tmp && bitnr < (uint) typelib->count)
-  {
-    if (tmp & 1)
-    {
-      if (val_buffer->length())
-	val_buffer->append(&field_separator, 1, &my_charset_latin1);
-      String str(typelib->type_names[bitnr],
-		 typelib->type_lengths[bitnr],
-		 field_charset);
-      val_buffer->append(str);
-    }
-    tmp>>=1;
-    bitnr++;
-  }
-  return val_buffer;
-}
-
-
-void Field_set::sql_type(String &res) const
-{
-  char buffer[255];
-  String set_item(buffer, sizeof(buffer), res.charset());
-
-  res.length(0);
-  res.append(STRING_WITH_LEN("set("));
-
-  bool flag=0;
-  uint *len= typelib->type_lengths;
-  for (const char **pos= typelib->type_names; *pos; pos++, len++)
-  {
-    uint dummy_errors;
-    if (flag)
-      res.append(',');
-    /* convert to res.charset() == utf8, then quote */
-    set_item.copy(*pos, *len, charset(), res.charset(), &dummy_errors);
-    append_unescaped(&res, set_item.ptr(), set_item.length());
-    flag= 1;
-  }
-  res.append(')');
-}
-
 /**
   @retval
     1  if the fields are equally defined
@@ -7406,32 +2816,6 @@
 }
 
 
-/**
-  maximum possible display length for blob.
-
-  @return
-    length
-*/
-
-uint32 Field_blob::max_display_length()
-{
-  switch (packlength)
-  {
-  case 1:
-    return 255 * field_charset->mbmaxlen;
-  case 2:
-    return 65535 * field_charset->mbmaxlen;
-  case 3:
-    return 16777215 * field_charset->mbmaxlen;
-  case 4:
-    return (uint32) 4294967295U;
-  default:
-    assert(0); // we should never go here
-    return 0;
-  }
-}
-
-
 /*****************************************************************************
  Warning handling
 *****************************************************************************/

=== modified file 'server/field.h'
--- server/field.h	2008-07-15 16:08:59 +0000
+++ server/field.h	2008-07-22 05:25:22 +0000
@@ -24,6 +24,8 @@
 #endif
 
 #define DATETIME_DEC                     6
+#define DOUBLE_TO_STRING_CONVERSION_BUFFER_SIZE FLOATING_POINT_BUFFER
+
 const uint32 max_field_size= (uint32) 4294967295U;
 
 class Send_field;
@@ -565,6 +567,7 @@
                int64_t signed_min, int64_t signed_max);
 };
 
+/* base class for all string related classes */
 
 class Field_str :public Field {
 protected:
@@ -639,58 +642,6 @@
 };
 
 
-/* New decimal/numeric field which use fixed point arithmetic */
-class Field_new_decimal :public Field_num {
-private:
-  int do_save_field_metadata(uchar *first_byte);
-public:
-  /* The maximum number of decimal digits can be stored */
-  uint precision;
-  uint bin_size;
-  /*
-    Constructors take max_length of the field as a parameter - not the
-    precision as the number of decimal digits allowed.
-    So for example we need to count length from precision handling
-    CREATE TABLE ( DECIMAL(x,y)) 
-  */
-  Field_new_decimal(uchar *ptr_arg, uint32 len_arg, uchar *null_ptr_arg,
-                    uchar null_bit_arg,
-                    enum utype unireg_check_arg, const char *field_name_arg,
-                    uint8 dec_arg, bool zero_arg, bool unsigned_arg);
-  Field_new_decimal(uint32 len_arg, bool maybe_null_arg,
-                    const char *field_name_arg, uint8 dec_arg,
-                    bool unsigned_arg);
-  enum_field_types type() const { return MYSQL_TYPE_NEWDECIMAL;}
-  enum ha_base_keytype key_type() const { return HA_KEYTYPE_BINARY; }
-  Item_result result_type () const { return DECIMAL_RESULT; }
-  int  reset(void);
-  bool store_value(const my_decimal *decimal_value);
-  void set_value_on_overflow(my_decimal *decimal_value, bool sign);
-  int  store(const char *to, uint length, CHARSET_INFO *charset);
-  int  store(double nr);
-  int  store(int64_t nr, bool unsigned_val);
-  int store_time(MYSQL_TIME *ltime, timestamp_type t_type);
-  int  store_decimal(const my_decimal *);
-  double val_real(void);
-  int64_t val_int(void);
-  my_decimal *val_decimal(my_decimal *);
-  String *val_str(String*, String *);
-  int cmp(const uchar *, const uchar *);
-  void sort_string(uchar *buff, uint length);
-  bool zero_pack() const { return 0; }
-  void sql_type(String &str) const;
-  uint32 max_display_length() { return field_length; }
-  uint size_of() const { return sizeof(*this); } 
-  uint32 pack_length() const { return (uint32) bin_size; }
-  uint pack_length_from_metadata(uint field_metadata);
-  uint row_pack_length() { return pack_length(); }
-  int compatible_field_size(uint field_metadata);
-  uint is_equal(Create_field *new_field);
-  virtual const uchar *unpack(uchar* to, const uchar *from,
-                              uint param_data, bool low_byte_first);
-};
-
-
 class Field_tiny :public Field_num {
 public:
   Field_tiny(uchar *ptr_arg, uint32 len_arg, uchar *null_ptr_arg,
@@ -737,846 +688,6 @@
 };
 
 
-class Field_short :public Field_num {
-public:
-  Field_short(uchar *ptr_arg, uint32 len_arg, uchar *null_ptr_arg,
-	      uchar null_bit_arg,
-	      enum utype unireg_check_arg, const char *field_name_arg,
-	      bool zero_arg, bool unsigned_arg)
-    :Field_num(ptr_arg, len_arg, null_ptr_arg, null_bit_arg,
-	       unireg_check_arg, field_name_arg,
-	       0, zero_arg,unsigned_arg)
-    {}
-  Field_short(uint32 len_arg,bool maybe_null_arg, const char *field_name_arg,
-	      bool unsigned_arg)
-    :Field_num((uchar*) 0, len_arg, maybe_null_arg ? (uchar*) "": 0,0,
-	       NONE, field_name_arg, 0, 0, unsigned_arg)
-    {}
-  enum Item_result result_type () const { return INT_RESULT; }
-  enum_field_types type() const { return MYSQL_TYPE_SHORT;}
-  enum ha_base_keytype key_type() const
-    { return unsigned_flag ? HA_KEYTYPE_USHORT_INT : HA_KEYTYPE_SHORT_INT;}
-  int store(const char *to,uint length,CHARSET_INFO *charset);
-  int store(double nr);
-  int store(int64_t nr, bool unsigned_val);
-  int reset(void) { ptr[0]=ptr[1]=0; return 0; }
-  double val_real(void);
-  int64_t val_int(void);
-  String *val_str(String*,String *);
-  bool send_binary(Protocol *protocol);
-  int cmp(const uchar *,const uchar *);
-  void sort_string(uchar *buff,uint length);
-  uint32 pack_length() const { return 2; }
-  void sql_type(String &str) const;
-  uint32 max_display_length() { return 6; }
-
-  virtual uchar *pack(uchar* to, const uchar *from,
-                      uint max_length __attribute__((__unused__)),
-                      bool low_byte_first __attribute__((__unused__)))
-  {
-    int16 val;
-#ifdef WORDS_BIGENDIAN
-    if (table->s->db_low_byte_first)
-      val = sint2korr(from);
-    else
-#endif
-      shortget(val, from);
-
-#ifdef WORDS_BIGENDIAN
-    if (low_byte_first)
-      int2store(to, val);
-    else
-#endif
-      shortstore(to, val);
-    return to + sizeof(val);
-  }
-
-  virtual const uchar *unpack(uchar* to, const uchar *from,
-                              uint param_data __attribute__((__unused__)),
-                              bool low_byte_first __attribute__((__unused__)))
-  {
-    int16 val;
-#ifdef WORDS_BIGENDIAN
-    if (low_byte_first)
-      val = sint2korr(from);
-    else
-#endif
-      shortget(val, from);
-
-#ifdef WORDS_BIGENDIAN
-    if (table->s->db_low_byte_first)
-      int2store(to, val);
-    else
-#endif
-      shortstore(to, val);
-    return from + sizeof(val);
-  }
-};
-
-class Field_long :public Field_num {
-public:
-  Field_long(uchar *ptr_arg, uint32 len_arg, uchar *null_ptr_arg,
-	     uchar null_bit_arg,
-	     enum utype unireg_check_arg, const char *field_name_arg,
-	     bool zero_arg, bool unsigned_arg)
-    :Field_num(ptr_arg, len_arg, null_ptr_arg, null_bit_arg,
-	       unireg_check_arg, field_name_arg,
-	       0, zero_arg,unsigned_arg)
-    {}
-  Field_long(uint32 len_arg,bool maybe_null_arg, const char *field_name_arg,
-	     bool unsigned_arg)
-    :Field_num((uchar*) 0, len_arg, maybe_null_arg ? (uchar*) "": 0,0,
-	       NONE, field_name_arg,0,0,unsigned_arg)
-    {}
-  enum Item_result result_type () const { return INT_RESULT; }
-  enum_field_types type() const { return MYSQL_TYPE_LONG;}
-  enum ha_base_keytype key_type() const
-    { return unsigned_flag ? HA_KEYTYPE_ULONG_INT : HA_KEYTYPE_LONG_INT; }
-  int store(const char *to,uint length,CHARSET_INFO *charset);
-  int store(double nr);
-  int store(int64_t nr, bool unsigned_val);
-  int reset(void) { ptr[0]=ptr[1]=ptr[2]=ptr[3]=0; return 0; }
-  double val_real(void);
-  int64_t val_int(void);
-  bool send_binary(Protocol *protocol);
-  String *val_str(String*,String *);
-  int cmp(const uchar *,const uchar *);
-  void sort_string(uchar *buff,uint length);
-  uint32 pack_length() const { return 4; }
-  void sql_type(String &str) const;
-  uint32 max_display_length() { return MY_INT32_NUM_DECIMAL_DIGITS; }
-  virtual uchar *pack(uchar* to, const uchar *from,
-                      uint max_length __attribute__((__unused__)),
-                      bool low_byte_first __attribute__((__unused__)))
-  {
-    int32 val;
-#ifdef WORDS_BIGENDIAN
-    if (table->s->db_low_byte_first)
-      val = sint4korr(from);
-    else
-#endif
-      longget(val, from);
-
-#ifdef WORDS_BIGENDIAN
-    if (low_byte_first)
-      int4store(to, val);
-    else
-#endif
-      longstore(to, val);
-    return to + sizeof(val);
-  }
-
-  virtual const uchar *unpack(uchar* to, const uchar *from,
-                              uint param_data __attribute__((__unused__)),
-                              bool low_byte_first __attribute__((__unused__)))
-  {
-    int32 val;
-#ifdef WORDS_BIGENDIAN
-    if (low_byte_first)
-      val = sint4korr(from);
-    else
-#endif
-      longget(val, from);
-
-#ifdef WORDS_BIGENDIAN
-    if (table->s->db_low_byte_first)
-      int4store(to, val);
-    else
-#endif
-      longstore(to, val);
-    return from + sizeof(val);
-  }
-};
-
-
-class Field_int64_t :public Field_num {
-public:
-  Field_int64_t(uchar *ptr_arg, uint32 len_arg, uchar *null_ptr_arg,
-	      uchar null_bit_arg,
-	      enum utype unireg_check_arg, const char *field_name_arg,
-	      bool zero_arg, bool unsigned_arg)
-    :Field_num(ptr_arg, len_arg, null_ptr_arg, null_bit_arg,
-	       unireg_check_arg, field_name_arg,
-	       0, zero_arg,unsigned_arg)
-    {}
-  Field_int64_t(uint32 len_arg,bool maybe_null_arg,
-		 const char *field_name_arg,
-		  bool unsigned_arg)
-    :Field_num((uchar*) 0, len_arg, maybe_null_arg ? (uchar*) "": 0,0,
-	       NONE, field_name_arg,0,0,unsigned_arg)
-    {}
-  enum Item_result result_type () const { return INT_RESULT; }
-  enum_field_types type() const { return MYSQL_TYPE_LONGLONG;}
-  enum ha_base_keytype key_type() const
-    { return unsigned_flag ? HA_KEYTYPE_ULONGLONG : HA_KEYTYPE_LONGLONG; }
-  int store(const char *to,uint length,CHARSET_INFO *charset);
-  int store(double nr);
-  int store(int64_t nr, bool unsigned_val);
-  int reset(void)
-  {
-    ptr[0]=ptr[1]=ptr[2]=ptr[3]=ptr[4]=ptr[5]=ptr[6]=ptr[7]=0;
-    return 0;
-  }
-  double val_real(void);
-  int64_t val_int(void);
-  String *val_str(String*,String *);
-  bool send_binary(Protocol *protocol);
-  int cmp(const uchar *,const uchar *);
-  void sort_string(uchar *buff,uint length);
-  uint32 pack_length() const { return 8; }
-  void sql_type(String &str) const;
-  bool can_be_compared_as_int64_t() const { return true; }
-  uint32 max_display_length() { return 20; }
-  virtual uchar *pack(uchar* to, const uchar *from,
-                      uint max_length __attribute__((__unused__)),
-                      bool low_byte_first __attribute__((__unused__)))
-  {
-    int64_t val;
-#ifdef WORDS_BIGENDIAN
-    if (table->s->db_low_byte_first)
-      val = sint8korr(from);
-    else
-#endif
-      int64_tget(val, from);
-
-#ifdef WORDS_BIGENDIAN
-    if (low_byte_first)
-      int8store(to, val);
-    else
-#endif
-      int64_tstore(to, val);
-    return to + sizeof(val);
-  }
-
-  virtual const uchar *unpack(uchar* to, const uchar *from,
-                              uint param_data __attribute__((__unused__)),
-                              bool low_byte_first __attribute__((__unused__)))
-  {
-    int64_t val;
-#ifdef WORDS_BIGENDIAN
-    if (low_byte_first)
-      val = sint8korr(from);
-    else
-#endif
-      int64_tget(val, from);
-
-#ifdef WORDS_BIGENDIAN
-    if (table->s->db_low_byte_first)
-      int8store(to, val);
-    else
-#endif
-      int64_tstore(to, val);
-    return from + sizeof(val);
-  }
-};
-
-class Field_double :public Field_real {
-public:
-  Field_double(uchar *ptr_arg, uint32 len_arg, uchar *null_ptr_arg,
-	       uchar null_bit_arg,
-	       enum utype unireg_check_arg, const char *field_name_arg,
-	       uint8 dec_arg,bool zero_arg,bool unsigned_arg)
-    :Field_real(ptr_arg, len_arg, null_ptr_arg, null_bit_arg,
-                unireg_check_arg, field_name_arg,
-                dec_arg, zero_arg, unsigned_arg)
-    {}
-  Field_double(uint32 len_arg, bool maybe_null_arg, const char *field_name_arg,
-	       uint8 dec_arg)
-    :Field_real((uchar*) 0, len_arg, maybe_null_arg ? (uchar*) "" : 0, (uint) 0,
-                NONE, field_name_arg, dec_arg, 0, 0)
-    {}
-  Field_double(uint32 len_arg, bool maybe_null_arg, const char *field_name_arg,
-	       uint8 dec_arg, my_bool not_fixed_arg)
-    :Field_real((uchar*) 0, len_arg, maybe_null_arg ? (uchar*) "" : 0, (uint) 0,
-                NONE, field_name_arg, dec_arg, 0, 0)
-    {not_fixed= not_fixed_arg; }
-  enum_field_types type() const { return MYSQL_TYPE_DOUBLE;}
-  enum ha_base_keytype key_type() const { return HA_KEYTYPE_DOUBLE; }
-  int  store(const char *to,uint length,CHARSET_INFO *charset);
-  int  store(double nr);
-  int  store(int64_t nr, bool unsigned_val);
-  int reset(void) { bzero(ptr,sizeof(double)); return 0; }
-  double val_real(void);
-  int64_t val_int(void);
-  String *val_str(String*,String *);
-  bool send_binary(Protocol *protocol);
-  int cmp(const uchar *,const uchar *);
-  void sort_string(uchar *buff,uint length);
-  uint32 pack_length() const { return sizeof(double); }
-  uint row_pack_length() { return pack_length(); }
-  void sql_type(String &str) const;
-private:
-  int do_save_field_metadata(uchar *first_byte);
-};
-
-
-/* Everything saved in this will disappear. It will always return NULL */
-
-class Field_null :public Field_str {
-  static uchar null[1];
-public:
-  Field_null(uchar *ptr_arg, uint32 len_arg,
-	     enum utype unireg_check_arg, const char *field_name_arg,
-	     CHARSET_INFO *cs)
-    :Field_str(ptr_arg, len_arg, null, 1,
-	       unireg_check_arg, field_name_arg, cs)
-    {}
-  enum_field_types type() const { return MYSQL_TYPE_NULL;}
-  int  store(const char *to __attribute__((__unused__)),
-             uint length __attribute__((__unused__)),
-             CHARSET_INFO *cs __attribute__((__unused__)))
-  { null[0]=1; return 0; }
-  int store(double nr __attribute__((__unused__)))
-  { null[0]=1; return 0; }
-  int store(int64_t nr __attribute__((__unused__)),
-            bool unsigned_val __attribute__((__unused__)))
-  { null[0]=1; return 0; }
-  int store_decimal(const my_decimal *d __attribute__((__unused__)))
-  { null[0]=1; return 0; }
-  int reset(void)
-  { return 0; }
-  double val_real(void)
-  { return 0.0;}
-  int64_t val_int(void)
-  { return 0;}
-  my_decimal *val_decimal(my_decimal *) { return 0; }
-  String *val_str(String *value __attribute__((__unused__)),
-                  String *value2)
-  { value2->length(0); return value2;}
-  int cmp(const uchar *a __attribute__((__unused__)),
-          const uchar *b __attribute__((__unused__))) { return 0;}
-  void sort_string(uchar *buff __attribute__((__unused__)),
-                   uint length __attribute__((__unused__)))  {}
-  uint32 pack_length() const { return 0; }
-  void sql_type(String &str) const;
-  uint size_of() const { return sizeof(*this); }
-  uint32 max_display_length() { return 4; }
-};
-
-
-class Field_timestamp :public Field_str {
-public:
-  Field_timestamp(uchar *ptr_arg, uint32 len_arg,
-                  uchar *null_ptr_arg, uchar null_bit_arg,
-		  enum utype unireg_check_arg, const char *field_name_arg,
-		  TABLE_SHARE *share, CHARSET_INFO *cs);
-  Field_timestamp(bool maybe_null_arg, const char *field_name_arg,
-		  CHARSET_INFO *cs);
-  enum_field_types type() const { return MYSQL_TYPE_TIMESTAMP;}
-  enum ha_base_keytype key_type() const { return HA_KEYTYPE_ULONG_INT; }
-  enum Item_result cmp_type () const { return INT_RESULT; }
-  int  store(const char *to,uint length,CHARSET_INFO *charset);
-  int  store(double nr);
-  int  store(int64_t nr, bool unsigned_val);
-  int  reset(void) { ptr[0]=ptr[1]=ptr[2]=ptr[3]=0; return 0; }
-  double val_real(void);
-  int64_t val_int(void);
-  String *val_str(String*,String *);
-  bool send_binary(Protocol *protocol);
-  int cmp(const uchar *,const uchar *);
-  void sort_string(uchar *buff,uint length);
-  uint32 pack_length() const { return 4; }
-  void sql_type(String &str) const;
-  bool can_be_compared_as_int64_t() const { return true; }
-  bool zero_pack() const { return 0; }
-  void set_time();
-  virtual void set_default()
-  {
-    if (table->timestamp_field == this &&
-        unireg_check != TIMESTAMP_UN_FIELD)
-      set_time();
-    else
-      Field::set_default();
-  }
-  /* Get TIMESTAMP field value as seconds since begging of Unix Epoch */
-  inline long get_timestamp(my_bool *null_value)
-  {
-    if ((*null_value= is_null()))
-      return 0;
-#ifdef WORDS_BIGENDIAN
-    if (table && table->s->db_low_byte_first)
-      return sint4korr(ptr);
-#endif
-    long tmp;
-    longget(tmp,ptr);
-    return tmp;
-  }
-  inline void store_timestamp(my_time_t timestamp)
-  {
-#ifdef WORDS_BIGENDIAN
-    if (table && table->s->db_low_byte_first)
-    {
-      int4store(ptr,timestamp);
-    }
-    else
-#endif
-      longstore(ptr,(uint32) timestamp);
-  }
-  bool get_date(MYSQL_TIME *ltime,uint fuzzydate);
-  bool get_time(MYSQL_TIME *ltime);
-  timestamp_auto_set_type get_auto_set_type() const;
-};
-
-
-class Field_year :public Field_tiny {
-public:
-  Field_year(uchar *ptr_arg, uint32 len_arg, uchar *null_ptr_arg,
-	     uchar null_bit_arg,
-	     enum utype unireg_check_arg, const char *field_name_arg)
-    :Field_tiny(ptr_arg, len_arg, null_ptr_arg, null_bit_arg,
-		unireg_check_arg, field_name_arg, 1, 1)
-    {}
-  enum_field_types type() const { return MYSQL_TYPE_YEAR;}
-  int  store(const char *to,uint length,CHARSET_INFO *charset);
-  int  store(double nr);
-  int  store(int64_t nr, bool unsigned_val);
-  double val_real(void);
-  int64_t val_int(void);
-  String *val_str(String*,String *);
-  bool send_binary(Protocol *protocol);
-  void sql_type(String &str) const;
-  bool can_be_compared_as_int64_t() const { return true; }
-};
-
-
-class Field_newdate :public Field_str {
-public:
-  Field_newdate(uchar *ptr_arg, uchar *null_ptr_arg, uchar null_bit_arg,
-		enum utype unireg_check_arg, const char *field_name_arg,
-		CHARSET_INFO *cs)
-    :Field_str(ptr_arg, 10, null_ptr_arg, null_bit_arg,
-	       unireg_check_arg, field_name_arg, cs)
-    {}
-  Field_newdate(bool maybe_null_arg, const char *field_name_arg,
-                CHARSET_INFO *cs)
-    :Field_str((uchar*) 0,10, maybe_null_arg ? (uchar*) "": 0,0,
-               NONE, field_name_arg, cs) {}
-  enum_field_types type() const { return MYSQL_TYPE_NEWDATE;}
-  enum_field_types real_type() const { return MYSQL_TYPE_NEWDATE; }
-  enum ha_base_keytype key_type() const { return HA_KEYTYPE_UINT24; }
-  enum Item_result cmp_type () const { return INT_RESULT; }
-  int  store(const char *to,uint length,CHARSET_INFO *charset);
-  int  store(double nr);
-  int  store(int64_t nr, bool unsigned_val);
-  int store_time(MYSQL_TIME *ltime, timestamp_type type);
-  int reset(void) { ptr[0]=ptr[1]=ptr[2]=0; return 0; }
-  double val_real(void);
-  int64_t val_int(void);
-  String *val_str(String*,String *);
-  bool send_binary(Protocol *protocol);
-  int cmp(const uchar *,const uchar *);
-  void sort_string(uchar *buff,uint length);
-  uint32 pack_length() const { return 3; }
-  void sql_type(String &str) const;
-  bool can_be_compared_as_int64_t() const { return true; }
-  bool zero_pack() const { return 1; }
-  bool get_date(MYSQL_TIME *ltime,uint fuzzydate);
-  bool get_time(MYSQL_TIME *ltime);
-};
-
-
-class Field_time :public Field_str {
-public:
-  Field_time(uchar *ptr_arg, uchar *null_ptr_arg, uchar null_bit_arg,
-	     enum utype unireg_check_arg, const char *field_name_arg,
-	     CHARSET_INFO *cs)
-    :Field_str(ptr_arg, 8, null_ptr_arg, null_bit_arg,
-	       unireg_check_arg, field_name_arg, cs)
-    {}
-  Field_time(bool maybe_null_arg, const char *field_name_arg,
-             CHARSET_INFO *cs)
-    :Field_str((uchar*) 0,8, maybe_null_arg ? (uchar*) "": 0,0,
-	       NONE, field_name_arg, cs) {}
-  enum_field_types type() const { return MYSQL_TYPE_TIME;}
-  enum ha_base_keytype key_type() const { return HA_KEYTYPE_INT24; }
-  enum Item_result cmp_type () const { return INT_RESULT; }
-  int store_time(MYSQL_TIME *ltime, timestamp_type type);
-  int store(const char *to,uint length,CHARSET_INFO *charset);
-  int store(double nr);
-  int store(int64_t nr, bool unsigned_val);
-  int reset(void) { ptr[0]=ptr[1]=ptr[2]=0; return 0; }
-  double val_real(void);
-  int64_t val_int(void);
-  String *val_str(String*,String *);
-  bool get_date(MYSQL_TIME *ltime, uint fuzzydate);
-  bool send_binary(Protocol *protocol);
-  bool get_time(MYSQL_TIME *ltime);
-  int cmp(const uchar *,const uchar *);
-  void sort_string(uchar *buff,uint length);
-  uint32 pack_length() const { return 3; }
-  void sql_type(String &str) const;
-  bool can_be_compared_as_int64_t() const { return true; }
-  bool zero_pack() const { return 1; }
-};
-
-
-class Field_datetime :public Field_str {
-public:
-  Field_datetime(uchar *ptr_arg, uchar *null_ptr_arg, uchar null_bit_arg,
-		 enum utype unireg_check_arg, const char *field_name_arg,
-		 CHARSET_INFO *cs)
-    :Field_str(ptr_arg, 19, null_ptr_arg, null_bit_arg,
-	       unireg_check_arg, field_name_arg, cs)
-    {}
-  Field_datetime(bool maybe_null_arg, const char *field_name_arg,
-		 CHARSET_INFO *cs)
-    :Field_str((uchar*) 0,19, maybe_null_arg ? (uchar*) "": 0,0,
-	       NONE, field_name_arg, cs) {}
-  enum_field_types type() const { return MYSQL_TYPE_DATETIME;}
-  enum ha_base_keytype key_type() const { return HA_KEYTYPE_ULONGLONG; }
-  enum Item_result cmp_type () const { return INT_RESULT; }
-  uint decimals() const { return DATETIME_DEC; }
-  int  store(const char *to,uint length,CHARSET_INFO *charset);
-  int  store(double nr);
-  int  store(int64_t nr, bool unsigned_val);
-  int store_time(MYSQL_TIME *ltime, timestamp_type type);
-  int reset(void)
-  {
-    ptr[0]=ptr[1]=ptr[2]=ptr[3]=ptr[4]=ptr[5]=ptr[6]=ptr[7]=0;
-    return 0;
-  }
-  double val_real(void);
-  int64_t val_int(void);
-  String *val_str(String*,String *);
-  bool send_binary(Protocol *protocol);
-  int cmp(const uchar *,const uchar *);
-  void sort_string(uchar *buff,uint length);
-  uint32 pack_length() const { return 8; }
-  void sql_type(String &str) const;
-  bool can_be_compared_as_int64_t() const { return true; }
-  bool zero_pack() const { return 1; }
-  bool get_date(MYSQL_TIME *ltime,uint fuzzydate);
-  bool get_time(MYSQL_TIME *ltime);
-};
-
-
-class Field_string :public Field_longstr {
-public:
-  bool can_alter_field_type;
-  Field_string(uchar *ptr_arg, uint32 len_arg,uchar *null_ptr_arg,
-	       uchar null_bit_arg,
-	       enum utype unireg_check_arg, const char *field_name_arg,
-	       CHARSET_INFO *cs)
-    :Field_longstr(ptr_arg, len_arg, null_ptr_arg, null_bit_arg,
-                   unireg_check_arg, field_name_arg, cs),
-     can_alter_field_type(1) {};
-  Field_string(uint32 len_arg,bool maybe_null_arg, const char *field_name_arg,
-               CHARSET_INFO *cs)
-    :Field_longstr((uchar*) 0, len_arg, maybe_null_arg ? (uchar*) "": 0, 0,
-                   NONE, field_name_arg, cs),
-     can_alter_field_type(1) {};
-
-  enum_field_types type() const
-  {
-    return  MYSQL_TYPE_STRING;
-  }
-  enum ha_base_keytype key_type() const
-    { return binary() ? HA_KEYTYPE_BINARY : HA_KEYTYPE_TEXT; }
-  bool zero_pack() const { return 0; }
-  int reset(void)
-  {
-    charset()->cset->fill(charset(),(char*) ptr, field_length,
-                          (has_charset() ? ' ' : 0));
-    return 0;
-  }
-  int store(const char *to,uint length,CHARSET_INFO *charset);
-  int store(int64_t nr, bool unsigned_val);
-  int store(double nr) { return Field_str::store(nr); } /* QQ: To be deleted */
-  double val_real(void);
-  int64_t val_int(void);
-  String *val_str(String*,String *);
-  my_decimal *val_decimal(my_decimal *);
-  int cmp(const uchar *,const uchar *);
-  void sort_string(uchar *buff,uint length);
-  void sql_type(String &str) const;
-  virtual uchar *pack(uchar *to, const uchar *from,
-                      uint max_length, bool low_byte_first);
-  virtual const uchar *unpack(uchar* to, const uchar *from,
-                              uint param_data, bool low_byte_first);
-  uint pack_length_from_metadata(uint field_metadata)
-  { return (field_metadata & 0x00ff); }
-  uint row_pack_length() { return (field_length + 1); }
-  int pack_cmp(const uchar *a,const uchar *b,uint key_length,
-               my_bool insert_or_update);
-  int pack_cmp(const uchar *b,uint key_length,my_bool insert_or_update);
-  uint packed_col_length(const uchar *to, uint length);
-  uint max_packed_col_length(uint max_length);
-  uint size_of() const { return sizeof(*this); }
-  enum_field_types real_type() const { return MYSQL_TYPE_STRING; }
-  bool has_charset(void) const
-  { return charset() == &my_charset_bin ? false : true; }
-  Field *new_field(MEM_ROOT *root, struct st_table *new_table, bool keep_type);
-  virtual uint get_key_image(uchar *buff,uint length, imagetype type);
-private:
-  int do_save_field_metadata(uchar *first_byte);
-};
-
-
-class Field_varstring :public Field_longstr {
-public:
-  /*
-    The maximum space available in a Field_varstring, in bytes. See
-    length_bytes.
-  */
-  static const uint MAX_SIZE;
-  /* Store number of bytes used to store length (1 or 2) */
-  uint32 length_bytes;
-  Field_varstring(uchar *ptr_arg,
-                  uint32 len_arg, uint length_bytes_arg,
-                  uchar *null_ptr_arg, uchar null_bit_arg,
-		  enum utype unireg_check_arg, const char *field_name_arg,
-		  TABLE_SHARE *share, CHARSET_INFO *cs)
-    :Field_longstr(ptr_arg, len_arg, null_ptr_arg, null_bit_arg,
-                   unireg_check_arg, field_name_arg, cs),
-     length_bytes(length_bytes_arg)
-  {
-    share->varchar_fields++;
-  }
-  Field_varstring(uint32 len_arg,bool maybe_null_arg,
-                  const char *field_name_arg,
-                  TABLE_SHARE *share, CHARSET_INFO *cs)
-    :Field_longstr((uchar*) 0,len_arg, maybe_null_arg ? (uchar*) "": 0, 0,
-                   NONE, field_name_arg, cs),
-     length_bytes(len_arg < 256 ? 1 :2)
-  {
-    share->varchar_fields++;
-  }
-
-  enum_field_types type() const { return MYSQL_TYPE_VARCHAR; }
-  enum ha_base_keytype key_type() const;
-  uint row_pack_length() { return field_length; }
-  bool zero_pack() const { return 0; }
-  int  reset(void) { bzero(ptr,field_length+length_bytes); return 0; }
-  uint32 pack_length() const { return (uint32) field_length+length_bytes; }
-  uint32 key_length() const { return (uint32) field_length; }
-  uint32 sort_length() const
-  {
-    return (uint32) field_length + (field_charset == &my_charset_bin ?
-                                    length_bytes : 0);
-  }
-  int  store(const char *to,uint length,CHARSET_INFO *charset);
-  int  store(int64_t nr, bool unsigned_val);
-  int  store(double nr) { return Field_str::store(nr); } /* QQ: To be deleted */
-  double val_real(void);
-  int64_t val_int(void);
-  String *val_str(String*,String *);
-  my_decimal *val_decimal(my_decimal *);
-  int cmp_max(const uchar *, const uchar *, uint max_length);
-  int cmp(const uchar *a,const uchar *b)
-  {
-    return cmp_max(a, b, ~0L);
-  }
-  void sort_string(uchar *buff,uint length);
-  uint get_key_image(uchar *buff,uint length, imagetype type);
-  void set_key_image(const uchar *buff,uint length);
-  void sql_type(String &str) const;
-  virtual uchar *pack(uchar *to, const uchar *from,
-                      uint max_length, bool low_byte_first);
-  uchar *pack_key(uchar *to, const uchar *from, uint max_length, bool low_byte_first);
-  uchar *pack_key_from_key_image(uchar* to, const uchar *from,
-                                 uint max_length, bool low_byte_first);
-  virtual const uchar *unpack(uchar* to, const uchar *from,
-                              uint param_data, bool low_byte_first);
-  const uchar *unpack_key(uchar* to, const uchar *from,
-                          uint max_length, bool low_byte_first);
-  int pack_cmp(const uchar *a, const uchar *b, uint key_length,
-               my_bool insert_or_update);
-  int pack_cmp(const uchar *b, uint key_length,my_bool insert_or_update);
-  int cmp_binary(const uchar *a,const uchar *b, uint32 max_length=~0L);
-  int key_cmp(const uchar *,const uchar*);
-  int key_cmp(const uchar *str, uint length);
-  uint packed_col_length(const uchar *to, uint length);
-  uint max_packed_col_length(uint max_length);
-  uint32 data_length();
-  uint32 used_length();
-  uint size_of() const { return sizeof(*this); }
-  enum_field_types real_type() const { return MYSQL_TYPE_VARCHAR; }
-  bool has_charset(void) const
-  { return charset() == &my_charset_bin ? false : true; }
-  Field *new_field(MEM_ROOT *root, struct st_table *new_table, bool keep_type);
-  Field *new_key_field(MEM_ROOT *root, struct st_table *new_table,
-                       uchar *new_ptr, uchar *new_null_ptr,
-                       uint new_null_bit);
-  uint is_equal(Create_field *new_field);
-  void hash(ulong *nr, ulong *nr2);
-private:
-  int do_save_field_metadata(uchar *first_byte);
-};
-
-
-class Field_blob :public Field_longstr {
-protected:
-  uint packlength;
-  String value;				// For temporaries
-public:
-  Field_blob(uchar *ptr_arg, uchar *null_ptr_arg, uchar null_bit_arg,
-	     enum utype unireg_check_arg, const char *field_name_arg,
-	     TABLE_SHARE *share, uint blob_pack_length, CHARSET_INFO *cs);
-  Field_blob(uint32 len_arg,bool maybe_null_arg, const char *field_name_arg,
-             CHARSET_INFO *cs)
-    :Field_longstr((uchar*) 0, len_arg, maybe_null_arg ? (uchar*) "": 0, 0,
-                   NONE, field_name_arg, cs),
-    packlength(4)
-  {
-    flags|= BLOB_FLAG;
-  }
-  Field_blob(uint32 len_arg,bool maybe_null_arg, const char *field_name_arg,
-	     CHARSET_INFO *cs, bool set_packlength)
-    :Field_longstr((uchar*) 0,len_arg, maybe_null_arg ? (uchar*) "": 0, 0,
-                   NONE, field_name_arg, cs)
-  {
-    flags|= BLOB_FLAG;
-    packlength= 4;
-    if (set_packlength)
-    {
-      uint32 l_char_length= len_arg/cs->mbmaxlen;
-      packlength= l_char_length <= 255 ? 1 :
-                  l_char_length <= 65535 ? 2 :
-                  l_char_length <= 16777215 ? 3 : 4;
-    }
-  }
-  Field_blob(uint32 packlength_arg)
-    :Field_longstr((uchar*) 0, 0, (uchar*) "", 0, NONE, "temp", system_charset_info),
-    packlength(packlength_arg) {}
-  enum_field_types type() const { return MYSQL_TYPE_BLOB;}
-  enum ha_base_keytype key_type() const
-    { return binary() ? HA_KEYTYPE_VARBINARY2 : HA_KEYTYPE_VARTEXT2; }
-  int  store(const char *to,uint length,CHARSET_INFO *charset);
-  int  store(double nr);
-  int  store(int64_t nr, bool unsigned_val);
-  double val_real(void);
-  int64_t val_int(void);
-  String *val_str(String*,String *);
-  my_decimal *val_decimal(my_decimal *);
-  int cmp_max(const uchar *, const uchar *, uint max_length);
-  int cmp(const uchar *a,const uchar *b)
-    { return cmp_max(a, b, ~0L); }
-  int cmp(const uchar *a, uint32 a_length, const uchar *b, uint32 b_length);
-  int cmp_binary(const uchar *a,const uchar *b, uint32 max_length=~0L);
-  int key_cmp(const uchar *,const uchar*);
-  int key_cmp(const uchar *str, uint length);
-  uint32 key_length() const { return 0; }
-  void sort_string(uchar *buff,uint length);
-  uint32 pack_length() const
-  { return (uint32) (packlength+table->s->blob_ptr_size); }
-
-  /**
-     Return the packed length without the pointer size added. 
-
-     This is used to determine the size of the actual data in the row
-     buffer.
-
-     @returns The length of the raw data itself without the pointer.
-  */
-  uint32 pack_length_no_ptr() const
-  { return (uint32) (packlength); }
-  uint row_pack_length() { return pack_length_no_ptr(); }
-  uint32 sort_length() const;
-  virtual uint32 max_data_length() const
-  {
-    return (uint32) (((uint64_t) 1 << (packlength*8)) -1);
-  }
-  int reset(void) { bzero(ptr, packlength+sizeof(uchar*)); return 0; }
-  void reset_fields() { bzero((uchar*) &value,sizeof(value)); }
-#ifndef WORDS_BIGENDIAN
-  static
-#endif
-  void store_length(uchar *i_ptr, uint i_packlength, uint32 i_number, bool low_byte_first);
-  void store_length(uchar *i_ptr, uint i_packlength, uint32 i_number)
-  {
-    store_length(i_ptr, i_packlength, i_number, table->s->db_low_byte_first);
-  }
-  inline void store_length(uint32 number)
-  {
-    store_length(ptr, packlength, number);
-  }
-
-  /**
-     Return the packed length plus the length of the data. 
-
-     This is used to determine the size of the data plus the 
-     packed length portion in the row data.
-
-     @returns The length in the row plus the size of the data.
-  */
-  uint32 get_packed_size(const uchar *ptr_arg, bool low_byte_first)
-    {return packlength + get_length(ptr_arg, packlength, low_byte_first);}
-
-  inline uint32 get_length(uint row_offset= 0)
-  { return get_length(ptr+row_offset, this->packlength, table->s->db_low_byte_first); }
-  uint32 get_length(const uchar *ptr, uint packlength, bool low_byte_first);
-  uint32 get_length(const uchar *ptr_arg)
-  { return get_length(ptr_arg, this->packlength, table->s->db_low_byte_first); }
-  void put_length(uchar *pos, uint32 length);
-  inline void get_ptr(uchar **str)
-    {
-      memcpy_fixed((uchar*) str,ptr+packlength,sizeof(uchar*));
-    }
-  inline void get_ptr(uchar **str, uint row_offset)
-    {
-      memcpy_fixed((uchar*) str,ptr+packlength+row_offset,sizeof(char*));
-    }
-  inline void set_ptr(uchar *length, uchar *data)
-    {
-      memcpy(ptr,length,packlength);
-      memcpy_fixed(ptr+packlength,&data,sizeof(char*));
-    }
-  void set_ptr_offset(my_ptrdiff_t ptr_diff, uint32 length, uchar *data)
-    {
-      uchar *ptr_ofs= ADD_TO_PTR(ptr,ptr_diff,uchar*);
-      store_length(ptr_ofs, packlength, length);
-      memcpy_fixed(ptr_ofs+packlength,&data,sizeof(char*));
-    }
-  inline void set_ptr(uint32 length, uchar *data)
-    {
-      set_ptr_offset(0, length, data);
-    }
-  uint get_key_image(uchar *buff,uint length, imagetype type);
-  void set_key_image(const uchar *buff,uint length);
-  void sql_type(String &str) const;
-  inline bool copy()
-  {
-    uchar *tmp;
-    get_ptr(&tmp);
-    if (value.copy((char*) tmp, get_length(), charset()))
-    {
-      Field_blob::reset();
-      return 1;
-    }
-    tmp=(uchar*) value.ptr();
-    memcpy_fixed(ptr+packlength,&tmp,sizeof(char*));
-    return 0;
-  }
-  virtual uchar *pack(uchar *to, const uchar *from,
-                      uint max_length, bool low_byte_first);
-  uchar *pack_key(uchar *to, const uchar *from,
-                  uint max_length, bool low_byte_first);
-  uchar *pack_key_from_key_image(uchar* to, const uchar *from,
-                                 uint max_length, bool low_byte_first);
-  virtual const uchar *unpack(uchar *to, const uchar *from,
-                              uint param_data, bool low_byte_first);
-  const uchar *unpack_key(uchar* to, const uchar *from,
-                          uint max_length, bool low_byte_first);
-  int pack_cmp(const uchar *a, const uchar *b, uint key_length,
-               my_bool insert_or_update);
-  int pack_cmp(const uchar *b, uint key_length,my_bool insert_or_update);
-  uint packed_col_length(const uchar *col_ptr, uint length);
-  uint max_packed_col_length(uint max_length);
-  void free() { value.free(); }
-  inline void clear_temporary() { bzero((uchar*) &value,sizeof(value)); }
-  friend int field_conv(Field *to,Field *from);
-  uint size_of() const { return sizeof(*this); }
-  bool has_charset(void) const
-  { return charset() == &my_charset_bin ? false : true; }
-  uint32 max_display_length();
-  uint is_equal(Create_field *new_field);
-  inline bool in_read_set() { return bitmap_is_set(table->read_set, field_index); }
-  inline bool in_write_set() { return bitmap_is_set(table->write_set, field_index); }
-private:
-  int do_save_field_metadata(uchar *first_byte);
-};
-
-
 class Field_enum :public Field_str {
 protected:
   uint packlength;
@@ -1627,33 +738,6 @@
   int do_save_field_metadata(uchar *first_byte);
 };
 
-
-class Field_set :public Field_enum {
-public:
-  Field_set(uchar *ptr_arg, uint32 len_arg, uchar *null_ptr_arg,
-	    uchar null_bit_arg,
-	    enum utype unireg_check_arg, const char *field_name_arg,
-	    uint32 packlength_arg,
-	    TYPELIB *typelib_arg, CHARSET_INFO *charset_arg)
-    :Field_enum(ptr_arg, len_arg, null_ptr_arg, null_bit_arg,
-		    unireg_check_arg, field_name_arg,
-                packlength_arg,
-                typelib_arg,charset_arg)
-    {
-      flags=(flags & ~ENUM_FLAG) | SET_FLAG;
-    }
-  int  store(const char *to,uint length,CHARSET_INFO *charset);
-  int  store(double nr) { return Field_set::store((int64_t) nr, false); }
-  int  store(int64_t nr, bool unsigned_val);
-
-  virtual bool zero_pack() const { return 1; }
-  String *val_str(String*,String *);
-  void sql_type(String &str) const;
-  enum_field_types real_type() const { return MYSQL_TYPE_SET; }
-  bool has_charset(void) const { return true; }
-};
-
-
 /*
   Create field class for CREATE TABLE
 */
@@ -1772,6 +856,32 @@
 int set_field_to_null(Field *field);
 int set_field_to_null_with_conversions(Field *field, bool no_conversions);
 
+bool
+check_string_copy_error(Field_str *field,
+                        const char *well_formed_error_pos,
+                        const char *cannot_convert_error_pos,
+                        const char *end,
+                        CHARSET_INFO *cs);
+
+/*
+  Field subclasses
+ */
+#include "field/blob.h"
+#include "field/null.h"
+#include "field/year.h"
+#include "field/date.h"
+#include "field/decimal.h"
+#include "field/double.h"
+#include "field/short.h"
+#include "field/long.h"
+#include "field/int64_t.h"
+#include "field/timetype.h"
+#include "field/timestamp.h"
+#include "field/datetime.h"
+#include "field/string.h"
+#include "field/varstring.h"
+#include "field/set.h"
+
 /*
   The following are for the interface with the .frm file
 */
@@ -1820,3 +930,4 @@
 #define f_no_default(x)		(x & FIELDFLAG_NO_DEFAULT)
 #define f_bit_as_char(x)        ((x) & FIELDFLAG_TREAT_BIT_AS_CHAR)
 #define f_is_hex_escape(x)      ((x) & FIELDFLAG_HEX_ESCAPE)
+

=== added file 'server/field/blob.cc'
--- server/field/blob.cc	1970-01-01 00:00:00 +0000
+++ server/field/blob.cc	2008-07-17 05:59:20 +0000
@@ -0,0 +1,729 @@
+/* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 MySQL
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifdef USE_PRAGMA_IMPLEMENTATION
+#pragma implementation				// gcc: Class implementation
+#endif
+
+#include "blob.h"
+
+#define BLOB_PACK_LENGTH_TO_MAX_LENGH(arg) \
+((ulong) ((1LL << min(arg, 4) * 8) - 1LL))
+
+/****************************************************************************
+** blob type
+** A blob is saved as a length and a pointer. The length is stored in the
+** packlength slot and may be from 1-4.
+****************************************************************************/
+
+Field_blob::Field_blob(uchar *ptr_arg, uchar *null_ptr_arg, uchar null_bit_arg,
+		       enum utype unireg_check_arg, const char *field_name_arg,
+                       TABLE_SHARE *share, uint blob_pack_length,
+		       CHARSET_INFO *cs)
+  :Field_longstr(ptr_arg, BLOB_PACK_LENGTH_TO_MAX_LENGH(blob_pack_length),
+                 null_ptr_arg, null_bit_arg, unireg_check_arg, field_name_arg,
+                 cs),
+   packlength(blob_pack_length)
+{
+  flags|= BLOB_FLAG;
+  share->blob_fields++;
+  /* TODO: why do not fill table->s->blob_field array here? */
+}
+
+
+void Field_blob::store_length(uchar *i_ptr,
+                              uint i_packlength,
+                              uint32_t i_number,
+                              bool low_byte_first __attribute__((__unused__)))
+{
+  switch (i_packlength) {
+  case 1:
+    i_ptr[0]= (uchar) i_number;
+    break;
+  case 2:
+#ifdef WORDS_BIGENDIAN
+    if (low_byte_first)
+    {
+      int2store(i_ptr,(unsigned short) i_number);
+    }
+    else
+#endif
+      shortstore(i_ptr,(unsigned short) i_number);
+    break;
+  case 3:
+    int3store(i_ptr,i_number);
+    break;
+  case 4:
+#ifdef WORDS_BIGENDIAN
+    if (low_byte_first)
+    {
+      int4store(i_ptr,i_number);
+    }
+    else
+#endif
+      longstore(i_ptr,i_number);
+  }
+}
+
+
+uint32_t Field_blob::get_length(const uchar *pos,
+                              uint packlength_arg,
+                              bool low_byte_first __attribute__((__unused__)))
+{
+  switch (packlength_arg) {
+  case 1:
+    return (uint32_t) pos[0];
+  case 2:
+    {
+      uint16 tmp;
+#ifdef WORDS_BIGENDIAN
+      if (low_byte_first)
+	tmp=sint2korr(pos);
+      else
+#endif
+	shortget(tmp,pos);
+      return (uint32_t) tmp;
+    }
+  case 3:
+    return (uint32_t) uint3korr(pos);
+  case 4:
+    {
+      uint32_t tmp;
+#ifdef WORDS_BIGENDIAN
+      if (low_byte_first)
+	tmp=uint4korr(pos);
+      else
+#endif
+	longget(tmp,pos);
+      return (uint32_t) tmp;
+    }
+  }
+  return 0;					// Impossible
+}
+
+
+/**
+  Put a blob length field into a record buffer.
+
+  Depending on the maximum length of a blob, its length field is
+  put into 1 to 4 bytes. This is a property of the blob object,
+  described by 'packlength'.
+
+  @param pos                 Pointer into the record buffer.
+  @param length              The length value to put.
+*/
+
+void Field_blob::put_length(uchar *pos, uint32_t length)
+{
+  switch (packlength) {
+  case 1:
+    *pos= (char) length;
+    break;
+  case 2:
+    int2store(pos, length);
+    break;
+  case 3:
+    int3store(pos, length);
+    break;
+  case 4:
+    int4store(pos, length);
+    break;
+  }
+}
+
+
+int Field_blob::store(const char *from,uint length,CHARSET_INFO *cs)
+{
+  uint copy_length, new_length;
+  const char *well_formed_error_pos;
+  const char *cannot_convert_error_pos;
+  const char *from_end_pos, *tmp;
+  char buff[STRING_BUFFER_USUAL_SIZE];
+  String tmpstr(buff,sizeof(buff), &my_charset_bin);
+
+  if (!length)
+  {
+    bzero(ptr,Field_blob::pack_length());
+    return 0;
+  }
+
+  if (from == value.ptr())
+  {
+    uint32_t dummy_offset;
+    if (!String::needs_conversion(length, cs, field_charset, &dummy_offset))
+    {
+      Field_blob::store_length(length);
+      bmove(ptr+packlength,(char*) &from,sizeof(char*));
+      return 0;
+    }
+    if (tmpstr.copy(from, length, cs))
+      goto oom_error;
+    from= tmpstr.ptr();
+  }
+
+  new_length= min(max_data_length(), field_charset->mbmaxlen * length);
+  if (value.alloc(new_length))
+    goto oom_error;
+
+
+  if (f_is_hex_escape(flags))
+  {
+    copy_length= my_copy_with_hex_escaping(field_charset,
+                                           (char*) value.ptr(), new_length,
+                                            from, length);
+    Field_blob::store_length(copy_length);
+    tmp= value.ptr();
+    bmove(ptr + packlength, (uchar*) &tmp, sizeof(char*));
+    return 0;
+  }
+  /*
+    "length" is OK as "nchars" argument to well_formed_copy_nchars as this
+    is never used to limit the length of the data. The cut of long data
+    is done with the new_length value.
+  */
+  copy_length= well_formed_copy_nchars(field_charset,
+                                       (char*) value.ptr(), new_length,
+                                       cs, from, length,
+                                       length,
+                                       &well_formed_error_pos,
+                                       &cannot_convert_error_pos,
+                                       &from_end_pos);
+
+  Field_blob::store_length(copy_length);
+  tmp= value.ptr();
+  bmove(ptr+packlength,(uchar*) &tmp,sizeof(char*));
+
+  if (check_string_copy_error(this, well_formed_error_pos,
+                              cannot_convert_error_pos, from + length, cs))
+    return 2;
+
+  return report_if_important_data(from_end_pos, from + length);
+
+oom_error:
+  /* Fatal OOM error */
+  bzero(ptr,Field_blob::pack_length());
+  return -1; 
+}
+
+
+int Field_blob::store(double nr)
+{
+  CHARSET_INFO *cs=charset();
+  value.set_real(nr, NOT_FIXED_DEC, cs);
+  return Field_blob::store(value.ptr(),(uint) value.length(), cs);
+}
+
+
+int Field_blob::store(int64_t nr, bool unsigned_val)
+{
+  CHARSET_INFO *cs=charset();
+  value.set_int(nr, unsigned_val, cs);
+  return Field_blob::store(value.ptr(), (uint) value.length(), cs);
+}
+
+
+double Field_blob::val_real(void)
+{
+  int not_used;
+  char *end_not_used, *blob;
+  uint32_t length;
+  CHARSET_INFO *cs;
+
+  memcpy_fixed(&blob,ptr+packlength,sizeof(char*));
+  if (!blob)
+    return 0.0;
+  length= get_length(ptr);
+  cs= charset();
+  return my_strntod(cs, blob, length, &end_not_used, &not_used);
+}
+
+
+int64_t Field_blob::val_int(void)
+{
+  int not_used;
+  char *blob;
+  memcpy_fixed(&blob,ptr+packlength,sizeof(char*));
+  if (!blob)
+    return 0;
+  uint32_t length=get_length(ptr);
+  return my_strntoll(charset(),blob,length,10,NULL,&not_used);
+}
+
+String *Field_blob::val_str(String *val_buffer __attribute__((unused)),
+			    String *val_ptr)
+{
+  char *blob;
+  memcpy_fixed(&blob,ptr+packlength,sizeof(char*));
+  if (!blob)
+    val_ptr->set("",0,charset());	// A bit safer than ->length(0)
+  else
+    val_ptr->set((const char*) blob,get_length(ptr),charset());
+  return val_ptr;
+}
+
+
+my_decimal *Field_blob::val_decimal(my_decimal *decimal_value)
+{
+  const char *blob;
+  size_t length;
+  memcpy_fixed(&blob, ptr+packlength, sizeof(const uchar*));
+  if (!blob)
+  {
+    blob= "";
+    length= 0;
+  }
+  else
+    length= get_length(ptr);
+
+  str2my_decimal(E_DEC_FATAL_ERROR, blob, length, charset(),
+                 decimal_value);
+  return decimal_value;
+}
+
+
+int Field_blob::cmp(const uchar *a,uint32_t a_length, const uchar *b,
+		    uint32_t b_length)
+{
+  return field_charset->coll->strnncollsp(field_charset, 
+                                          a, a_length, b, b_length,
+                                          0);
+}
+
+
+int Field_blob::cmp_max(const uchar *a_ptr, const uchar *b_ptr,
+                        uint max_length)
+{
+  uchar *blob1,*blob2;
+  memcpy_fixed(&blob1,a_ptr+packlength,sizeof(char*));
+  memcpy_fixed(&blob2,b_ptr+packlength,sizeof(char*));
+  uint a_len= get_length(a_ptr), b_len= get_length(b_ptr);
+  set_if_smaller(a_len, max_length);
+  set_if_smaller(b_len, max_length);
+  return Field_blob::cmp(blob1,a_len,blob2,b_len);
+}
+
+
+int Field_blob::cmp_binary(const uchar *a_ptr, const uchar *b_ptr,
+			   uint32_t max_length)
+{
+  char *a,*b;
+  uint diff;
+  uint32_t a_length,b_length;
+  memcpy_fixed(&a,a_ptr+packlength,sizeof(char*));
+  memcpy_fixed(&b,b_ptr+packlength,sizeof(char*));
+  a_length=get_length(a_ptr);
+  if (a_length > max_length)
+    a_length=max_length;
+  b_length=get_length(b_ptr);
+  if (b_length > max_length)
+    b_length=max_length;
+  diff=memcmp(a,b,min(a_length,b_length));
+  return diff ? diff : (int) (a_length - b_length);
+}
+
+
+/* The following is used only when comparing a key */
+
+uint Field_blob::get_key_image(uchar *buff,
+                               uint length,
+                               imagetype type_arg __attribute__((__unused__)))
+{
+  uint32_t blob_length= get_length(ptr);
+  uchar *blob;
+
+  get_ptr(&blob);
+  uint local_char_length= length / field_charset->mbmaxlen;
+  local_char_length= my_charpos(field_charset, blob, blob + blob_length,
+                          local_char_length);
+  set_if_smaller(blob_length, local_char_length);
+
+  if ((uint32_t) length > blob_length)
+  {
+    /*
+      Must clear this as we do a memcmp in opt_range.cc to detect
+      identical keys
+    */
+    bzero(buff+HA_KEY_BLOB_LENGTH+blob_length, (length-blob_length));
+    length=(uint) blob_length;
+  }
+  int2store(buff,length);
+  memcpy(buff+HA_KEY_BLOB_LENGTH, blob, length);
+  return HA_KEY_BLOB_LENGTH+length;
+}
+
+
+void Field_blob::set_key_image(const uchar *buff,uint length)
+{
+  length= uint2korr(buff);
+  (void) Field_blob::store((const char*) buff+HA_KEY_BLOB_LENGTH, length,
+                           field_charset);
+}
+
+
+int Field_blob::key_cmp(const uchar *key_ptr, uint max_key_length)
+{
+  uchar *blob1;
+  uint blob_length=get_length(ptr);
+  memcpy_fixed(&blob1,ptr+packlength,sizeof(char*));
+  CHARSET_INFO *cs= charset();
+  uint local_char_length= max_key_length / cs->mbmaxlen;
+  local_char_length= my_charpos(cs, blob1, blob1+blob_length,
+                                local_char_length);
+  set_if_smaller(blob_length, local_char_length);
+  return Field_blob::cmp(blob1, blob_length,
+			 key_ptr+HA_KEY_BLOB_LENGTH,
+			 uint2korr(key_ptr));
+}
+
+int Field_blob::key_cmp(const uchar *a,const uchar *b)
+{
+  return Field_blob::cmp(a+HA_KEY_BLOB_LENGTH, uint2korr(a),
+			 b+HA_KEY_BLOB_LENGTH, uint2korr(b));
+}
+
+
+/**
+   Save the field metadata for blob fields.
+
+   Saves the pack length in the first byte of the field metadata array
+   at index of *metadata_ptr.
+
+   @param   metadata_ptr   First byte of field metadata
+
+   @returns number of bytes written to metadata_ptr
+*/
+int Field_blob::do_save_field_metadata(uchar *metadata_ptr)
+{
+  *metadata_ptr= pack_length_no_ptr();
+  return 1;
+}
+
+
+uint32_t Field_blob::sort_length() const
+{
+  return (uint32_t) (current_thd->variables.max_sort_length + 
+                   (field_charset == &my_charset_bin ? 0 : packlength));
+}
+
+
+void Field_blob::sort_string(uchar *to,uint length)
+{
+  uchar *blob;
+  uint blob_length=get_length();
+
+  if (!blob_length)
+    bzero(to,length);
+  else
+  {
+    if (field_charset == &my_charset_bin)
+    {
+      uchar *pos;
+
+      /*
+        Store length of blob last in blob to shorter blobs before longer blobs
+      */
+      length-= packlength;
+      pos= to+length;
+
+      switch (packlength) {
+      case 1:
+        *pos= (char) blob_length;
+        break;
+      case 2:
+        mi_int2store(pos, blob_length);
+        break;
+      case 3:
+        mi_int3store(pos, blob_length);
+        break;
+      case 4:
+        mi_int4store(pos, blob_length);
+        break;
+      }
+    }
+    memcpy_fixed(&blob,ptr+packlength,sizeof(char*));
+    
+    blob_length=my_strnxfrm(field_charset,
+                            to, length, blob, blob_length);
+    assert(blob_length == length);
+  }
+}
+
+
+void Field_blob::sql_type(String &res) const
+{
+  const char *str;
+  uint length;
+  switch (packlength) {
+  default: str="tiny"; length=4; break;
+  case 2:  str="";     length=0; break;
+  case 3:  str="medium"; length= 6; break;
+  case 4:  str="long";  length=4; break;
+  }
+  res.set_ascii(str,length);
+  if (charset() == &my_charset_bin)
+    res.append(STRING_WITH_LEN("blob"));
+  else
+  {
+    res.append(STRING_WITH_LEN("text"));
+  }
+}
+
+uchar *Field_blob::pack(uchar *to, const uchar *from,
+                        uint max_length, bool low_byte_first)
+{
+  uchar *save= ptr;
+  ptr= (uchar*) from;
+  uint32_t length=get_length();			// Length of from string
+
+  /*
+    Store max length, which will occupy packlength bytes. If the max
+    length given is smaller than the actual length of the blob, we
+    just store the initial bytes of the blob.
+  */
+  store_length(to, packlength, min(length, max_length), low_byte_first);
+
+  /*
+    Store the actual blob data, which will occupy 'length' bytes.
+   */
+  if (length > 0)
+  {
+    get_ptr((uchar**) &from);
+    memcpy(to+packlength, from,length);
+  }
+  ptr=save;					// Restore org row pointer
+  return(to+packlength+length);
+}
+
+
+/**
+   Unpack a blob field from row data.
+
+   This method is used to unpack a blob field from a master whose size of 
+   the field is less than that of the slave. Note: This method is included
+   to satisfy inheritance rules, but is not needed for blob fields. It
+   simply is used as a pass-through to the original unpack() method for
+   blob fields.
+
+   @param   to         Destination of the data
+   @param   from       Source of the data
+   @param   param_data @c true if base types should be stored in little-
+                       endian format, @c false if native format should
+                       be used.
+
+   @return  New pointer into memory based on from + length of the data
+*/
+const uchar *Field_blob::unpack(uchar *to __attribute__((__unused__)),
+                                const uchar *from,
+                                uint param_data,
+                                bool low_byte_first)
+{
+  uint const master_packlength=
+    param_data > 0 ? param_data & 0xFF : packlength;
+  uint32_t const length= get_length(from, master_packlength, low_byte_first);
+  bitmap_set_bit(table->write_set, field_index);
+  store(reinterpret_cast<const char*>(from) + master_packlength,
+        length, field_charset);
+  return(from + master_packlength + length);
+}
+
+/* Keys for blobs are like keys on varchars */
+
+int Field_blob::pack_cmp(const uchar *a, const uchar *b, uint key_length_arg,
+                         my_bool insert_or_update)
+{
+  uint a_length, b_length;
+  if (key_length_arg > 255)
+  {
+    a_length=uint2korr(a); a+=2;
+    b_length=uint2korr(b); b+=2;
+  }
+  else
+  {
+    a_length= (uint) *a++;
+    b_length= (uint) *b++;
+  }
+  return field_charset->coll->strnncollsp(field_charset,
+                                          a, a_length,
+                                          b, b_length,
+                                          insert_or_update);
+}
+
+
+int Field_blob::pack_cmp(const uchar *b, uint key_length_arg,
+                         my_bool insert_or_update)
+{
+  uchar *a;
+  uint a_length, b_length;
+  memcpy_fixed(&a,ptr+packlength,sizeof(char*));
+  if (!a)
+    return key_length_arg > 0 ? -1 : 0;
+
+  a_length= get_length(ptr);
+  if (key_length_arg > 255)
+  {
+    b_length= uint2korr(b); b+=2;
+  }
+  else
+    b_length= (uint) *b++;
+  return field_charset->coll->strnncollsp(field_charset,
+                                          a, a_length,
+                                          b, b_length,
+                                          insert_or_update);
+}
+
+/** Create a packed key that will be used for storage from a MySQL row. */
+
+uchar *
+Field_blob::pack_key(uchar *to, const uchar *from, uint max_length,
+                     bool low_byte_first __attribute__((unused)))
+{
+  uchar *save= ptr;
+  ptr= (uchar*) from;
+  uint32_t length=get_length();        // Length of from string
+  uint local_char_length= ((field_charset->mbmaxlen > 1) ?
+                           max_length/field_charset->mbmaxlen : max_length);
+  if (length)
+    get_ptr((uchar**) &from);
+  if (length > local_char_length)
+    local_char_length= my_charpos(field_charset, from, from+length,
+                                  local_char_length);
+  set_if_smaller(length, local_char_length);
+  *to++= (uchar) length;
+  if (max_length > 255)				// 2 byte length
+    *to++= (uchar) (length >> 8);
+  memcpy(to, from, length);
+  ptr=save;					// Restore org row pointer
+  return to+length;
+}
+
+
+/**
+  Unpack a blob key into a record buffer.
+
+  A blob key has a maximum size of 64K-1.
+  In its packed form, the length field is one or two bytes long,
+  depending on 'max_length'.
+  Depending on the maximum length of a blob, its length field is
+  put into 1 to 4 bytes. This is a property of the blob object,
+  described by 'packlength'.
+  Blobs are internally stored apart from the record buffer, which
+  contains a pointer to the blob buffer.
+
+
+  @param to                          Pointer into the record buffer.
+  @param from                        Pointer to the packed key.
+  @param max_length                  Key length limit from key description.
+
+  @return
+    Pointer into 'from' past the last byte copied from packed key.
+*/
+
+const uchar *
+Field_blob::unpack_key(uchar *to, const uchar *from, uint max_length,
+                       bool low_byte_first __attribute__((unused)))
+{
+  /* get length of the blob key */
+  uint32_t length= *from++;
+  if (max_length > 255)
+    length+= *from++ << 8;
+
+  /* put the length into the record buffer */
+  put_length(to, length);
+
+  /* put the address of the blob buffer or NULL */
+  if (length)
+    memcpy_fixed(to + packlength, &from, sizeof(from));
+  else
+    bzero(to + packlength, sizeof(from));
+
+  /* point to first byte of next field in 'from' */
+  return from + length;
+}
+
+
+/** Create a packed key that will be used for storage from a MySQL key. */
+
+uchar *
+Field_blob::pack_key_from_key_image(uchar *to, const uchar *from, uint max_length,
+                                    bool low_byte_first __attribute__((unused)))
+{
+  uint length=uint2korr(from);
+  if (length > max_length)
+    length=max_length;
+  *to++= (char) (length & 255);
+  if (max_length > 255)
+    *to++= (char) (length >> 8);
+  if (length)
+    memcpy(to, from+HA_KEY_BLOB_LENGTH, length);
+  return to+length;
+}
+
+
+uint Field_blob::packed_col_length(const uchar *data_ptr, uint length)
+{
+  if (length > 255)
+    return uint2korr(data_ptr)+2;
+  return (uint) *data_ptr + 1;
+}
+
+
+uint Field_blob::max_packed_col_length(uint max_length)
+{
+  return (max_length > 255 ? 2 : 1)+max_length;
+}
+
+
+uint Field_blob::is_equal(Create_field *new_field)
+{
+  if (compare_str_field_flags(new_field, flags))
+    return 0;
+
+  return ((new_field->sql_type == get_blob_type_from_length(max_data_length()))
+          && new_field->charset == field_charset &&
+          ((Field_blob *)new_field->field)->max_data_length() ==
+          max_data_length());
+}
+
+
+/**
+  maximum possible display length for blob.
+
+  @return
+    length
+*/
+
+uint32_t Field_blob::max_display_length()
+{
+  switch (packlength)
+  {
+  case 1:
+    return 255 * field_charset->mbmaxlen;
+  case 2:
+    return 65535 * field_charset->mbmaxlen;
+  case 3:
+    return 16777215 * field_charset->mbmaxlen;
+  case 4:
+    return (uint32_t) 4294967295U;
+  default:
+    assert(0); // we should never go here
+    return 0;
+  }
+}
+

=== added file 'server/field/blob.h'
--- server/field/blob.h	1970-01-01 00:00:00 +0000
+++ server/field/blob.h	2008-07-17 05:59:20 +0000
@@ -0,0 +1,199 @@
+/* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 MySQL
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLE_SERVER_FIELD_BLOB
+#define DRIZZLE_SERVER_FIELD_BLOB
+
+#include "mysql_priv.h"
+
+class Field_blob :public Field_longstr {
+protected:
+  uint packlength;
+  String value;				// For temporaries
+public:
+  Field_blob(uchar *ptr_arg, uchar *null_ptr_arg, uchar null_bit_arg,
+	     enum utype unireg_check_arg, const char *field_name_arg,
+	     TABLE_SHARE *share, uint blob_pack_length, CHARSET_INFO *cs);
+  Field_blob(uint32_t len_arg,bool maybe_null_arg, const char *field_name_arg,
+             CHARSET_INFO *cs)
+    :Field_longstr((uchar*) 0, len_arg, maybe_null_arg ? (uchar*) "": 0, 0,
+                   NONE, field_name_arg, cs),
+    packlength(4)
+  {
+    flags|= BLOB_FLAG;
+  }
+  Field_blob(uint32_t len_arg,bool maybe_null_arg, const char *field_name_arg,
+	     CHARSET_INFO *cs, bool set_packlength)
+    :Field_longstr((uchar*) 0,len_arg, maybe_null_arg ? (uchar*) "": 0, 0,
+                   NONE, field_name_arg, cs)
+  {
+    flags|= BLOB_FLAG;
+    packlength= 4;
+    if (set_packlength)
+    {
+      uint32_t l_char_length= len_arg/cs->mbmaxlen;
+      packlength= l_char_length <= 255 ? 1 :
+                  l_char_length <= 65535 ? 2 :
+                  l_char_length <= 16777215 ? 3 : 4;
+    }
+  }
+  Field_blob(uint32_t packlength_arg)
+    :Field_longstr((uchar*) 0, 0, (uchar*) "", 0, NONE, "temp", system_charset_info),
+    packlength(packlength_arg) {}
+  enum_field_types type() const { return MYSQL_TYPE_BLOB;}
+  enum ha_base_keytype key_type() const
+    { return binary() ? HA_KEYTYPE_VARBINARY2 : HA_KEYTYPE_VARTEXT2; }
+  int  store(const char *to,uint length,CHARSET_INFO *charset);
+  int  store(double nr);
+  int  store(int64_t nr, bool unsigned_val);
+  double val_real(void);
+  int64_t val_int(void);
+  String *val_str(String*,String *);
+  my_decimal *val_decimal(my_decimal *);
+  int cmp_max(const uchar *, const uchar *, uint max_length);
+  int cmp(const uchar *a,const uchar *b)
+    { return cmp_max(a, b, ~0L); }
+  int cmp(const uchar *a, uint32_t a_length, const uchar *b, uint32_t b_length);
+  int cmp_binary(const uchar *a,const uchar *b, uint32_t max_length=~0L);
+  int key_cmp(const uchar *,const uchar*);
+  int key_cmp(const uchar *str, uint length);
+  uint32_t key_length() const { return 0; }
+  void sort_string(uchar *buff,uint length);
+  uint32_t pack_length() const
+  { return (uint32_t) (packlength+table->s->blob_ptr_size); }
+
+  /**
+     Return the packed length without the pointer size added. 
+
+     This is used to determine the size of the actual data in the row
+     buffer.
+
+     @returns The length of the raw data itself without the pointer.
+  */
+  uint32_t pack_length_no_ptr() const
+  { return (uint32_t) (packlength); }
+  uint row_pack_length() { return pack_length_no_ptr(); }
+  uint32_t sort_length() const;
+  virtual uint32_t max_data_length() const
+  {
+    return (uint32_t) (((uint64_t) 1 << (packlength*8)) -1);
+  }
+  int reset(void) { bzero(ptr, packlength+sizeof(uchar*)); return 0; }
+  void reset_fields() { bzero((uchar*) &value,sizeof(value)); }
+#ifndef WORDS_BIGENDIAN
+  static
+#endif
+  void store_length(uchar *i_ptr, uint i_packlength, uint32_t i_number, bool low_byte_first);
+  void store_length(uchar *i_ptr, uint i_packlength, uint32_t i_number)
+  {
+    store_length(i_ptr, i_packlength, i_number, table->s->db_low_byte_first);
+  }
+  inline void store_length(uint32_t number)
+  {
+    store_length(ptr, packlength, number);
+  }
+
+  /**
+     Return the packed length plus the length of the data. 
+
+     This is used to determine the size of the data plus the 
+     packed length portion in the row data.
+
+     @returns The length in the row plus the size of the data.
+  */
+  uint32_t get_packed_size(const uchar *ptr_arg, bool low_byte_first)
+    {return packlength + get_length(ptr_arg, packlength, low_byte_first);}
+
+  inline uint32_t get_length(uint row_offset= 0)
+  { return get_length(ptr+row_offset, this->packlength, table->s->db_low_byte_first); }
+  uint32_t get_length(const uchar *ptr, uint packlength, bool low_byte_first);
+  uint32_t get_length(const uchar *ptr_arg)
+  { return get_length(ptr_arg, this->packlength, table->s->db_low_byte_first); }
+  void put_length(uchar *pos, uint32_t length);
+  inline void get_ptr(uchar **str)
+    {
+      memcpy_fixed((uchar*) str,ptr+packlength,sizeof(uchar*));
+    }
+  inline void get_ptr(uchar **str, uint row_offset)
+    {
+      memcpy_fixed((uchar*) str,ptr+packlength+row_offset,sizeof(char*));
+    }
+  inline void set_ptr(uchar *length, uchar *data)
+    {
+      memcpy(ptr,length,packlength);
+      memcpy_fixed(ptr+packlength,&data,sizeof(char*));
+    }
+  void set_ptr_offset(my_ptrdiff_t ptr_diff, uint32_t length, uchar *data)
+    {
+      uchar *ptr_ofs= ADD_TO_PTR(ptr,ptr_diff,uchar*);
+      store_length(ptr_ofs, packlength, length);
+      memcpy_fixed(ptr_ofs+packlength,&data,sizeof(char*));
+    }
+  inline void set_ptr(uint32_t length, uchar *data)
+    {
+      set_ptr_offset(0, length, data);
+    }
+  uint get_key_image(uchar *buff,uint length, imagetype type);
+  void set_key_image(const uchar *buff,uint length);
+  void sql_type(String &str) const;
+  inline bool copy()
+  {
+    uchar *tmp;
+    get_ptr(&tmp);
+    if (value.copy((char*) tmp, get_length(), charset()))
+    {
+      Field_blob::reset();
+      return 1;
+    }
+    tmp=(uchar*) value.ptr();
+    memcpy_fixed(ptr+packlength,&tmp,sizeof(char*));
+    return 0;
+  }
+  virtual uchar *pack(uchar *to, const uchar *from,
+                      uint max_length, bool low_byte_first);
+  uchar *pack_key(uchar *to, const uchar *from,
+                  uint max_length, bool low_byte_first);
+  uchar *pack_key_from_key_image(uchar* to, const uchar *from,
+                                 uint max_length, bool low_byte_first);
+  virtual const uchar *unpack(uchar *to, const uchar *from,
+                              uint param_data, bool low_byte_first);
+  const uchar *unpack_key(uchar* to, const uchar *from,
+                          uint max_length, bool low_byte_first);
+  int pack_cmp(const uchar *a, const uchar *b, uint key_length,
+               my_bool insert_or_update);
+  int pack_cmp(const uchar *b, uint key_length,my_bool insert_or_update);
+  uint packed_col_length(const uchar *col_ptr, uint length);
+  uint max_packed_col_length(uint max_length);
+  void free() { value.free(); }
+  inline void clear_temporary() { bzero((uchar*) &value,sizeof(value)); }
+  friend int field_conv(Field *to,Field *from);
+  uint size_of() const { return sizeof(*this); }
+  bool has_charset(void) const
+  { return charset() == &my_charset_bin ? false : true; }
+  uint32_t max_display_length();
+  uint is_equal(Create_field *new_field);
+  inline bool in_read_set() { return bitmap_is_set(table->read_set, field_index); }
+  inline bool in_write_set() { return bitmap_is_set(table->write_set, field_index); }
+private:
+  int do_save_field_metadata(uchar *first_byte);
+};
+
+#endif
+

=== added file 'server/field/date.cc'
--- server/field/date.cc	1970-01-01 00:00:00 +0000
+++ server/field/date.cc	2008-07-18 07:38:40 +0000
@@ -0,0 +1,272 @@
+/* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 MySQL
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifdef USE_PRAGMA_IMPLEMENTATION
+#pragma implementation				// gcc: Class implementation
+#endif
+
+#include "date.h"
+
+/****************************************************************************
+** The new date type
+** This is identical to the old date type, but stored on 3 bytes instead of 4
+** In number context: YYYYMMDD
+****************************************************************************/
+
+/*
+  Store string into a date field
+
+  SYNOPSIS
+    Field_newdate::store()
+    from                Date string
+    len                 Length of date field
+    cs                  Character set (not used)
+
+  RETURN
+    0  ok
+    1  Value was cut during conversion
+    2  Wrong date string
+    3  Datetime value that was cut (warning level NOTE)
+       This is used by opt_range.cc:get_mm_leaf(). Note that there is a
+       nearly-identical class Field_date doesn't ever return 3 from its
+       store function.
+*/
+
+int Field_newdate::store(const char *from,
+                         uint len,
+                         CHARSET_INFO *cs __attribute__((__unused__)))
+{
+  long tmp;
+  MYSQL_TIME l_time;
+  int error;
+  THD *thd= table ? table->in_use : current_thd;
+  enum enum_mysql_timestamp_type ret;
+  if ((ret= str_to_datetime(from, len, &l_time,
+                            (TIME_FUZZY_DATE |
+                             (thd->variables.sql_mode &
+                              (MODE_NO_ZERO_IN_DATE | MODE_NO_ZERO_DATE |
+                               MODE_INVALID_DATES))),
+                            &error)) <= MYSQL_TIMESTAMP_ERROR)
+  {
+    tmp= 0;
+    error= 2;
+  }
+  else
+  {
+    tmp= l_time.day + l_time.month*32 + l_time.year*16*32;
+    if (!error && (ret != MYSQL_TIMESTAMP_DATE) &&
+        (l_time.hour || l_time.minute || l_time.second || l_time.second_part))
+      error= 3;                                 // Datetime was cut (note)
+  }
+
+  if (error)
+    set_datetime_warning(error == 3 ? MYSQL_ERROR::WARN_LEVEL_NOTE :
+                         MYSQL_ERROR::WARN_LEVEL_WARN,
+                         WARN_DATA_TRUNCATED,
+                         from, len, MYSQL_TIMESTAMP_DATE, 1);
+
+  int3store(ptr, tmp);
+  return error;
+}
+
+
+int Field_newdate::store(double nr)
+{
+  if (nr < 0.0 || nr > 99991231235959.0)
+  {
+    int3store(ptr,(int32) 0);
+    set_datetime_warning(MYSQL_ERROR::WARN_LEVEL_WARN,
+                         WARN_DATA_TRUNCATED, nr, MYSQL_TIMESTAMP_DATE);
+    return 1;
+  }
+  return Field_newdate::store((int64_t) rint(nr), false);
+}
+
+
+int Field_newdate::store(int64_t nr,
+                         bool unsigned_val __attribute__((__unused__)))
+{
+  MYSQL_TIME l_time;
+  int64_t tmp;
+  int error;
+  THD *thd= table ? table->in_use : current_thd;
+  if (number_to_datetime(nr, &l_time,
+                         (TIME_FUZZY_DATE |
+                          (thd->variables.sql_mode &
+                           (MODE_NO_ZERO_IN_DATE | MODE_NO_ZERO_DATE |
+                            MODE_INVALID_DATES))),
+                         &error) == -1LL)
+  {
+    tmp= 0L;
+    error= 2;
+  }
+  else
+    tmp= l_time.day + l_time.month*32 + l_time.year*16*32;
+
+  if (!error && l_time.time_type != MYSQL_TIMESTAMP_DATE &&
+      (l_time.hour || l_time.minute || l_time.second || l_time.second_part))
+    error= 3;
+
+  if (error)
+    set_datetime_warning(error == 3 ? MYSQL_ERROR::WARN_LEVEL_NOTE :
+                         MYSQL_ERROR::WARN_LEVEL_WARN,
+                         error == 2 ? 
+                         ER_WARN_DATA_OUT_OF_RANGE : WARN_DATA_TRUNCATED,
+                         nr,MYSQL_TIMESTAMP_DATE, 1);
+
+  int3store(ptr,tmp);
+  return error;
+}
+
+
+int Field_newdate::store_time(MYSQL_TIME *ltime,timestamp_type time_type)
+{
+  long tmp;
+  int error= 0;
+  if (time_type == MYSQL_TIMESTAMP_DATE ||
+      time_type == MYSQL_TIMESTAMP_DATETIME)
+  {
+    tmp=ltime->year*16*32+ltime->month*32+ltime->day;
+    if (check_date(ltime, tmp != 0,
+                   (TIME_FUZZY_DATE |
+                    (current_thd->variables.sql_mode &
+                     (MODE_NO_ZERO_IN_DATE | MODE_NO_ZERO_DATE |
+                      MODE_INVALID_DATES))), &error))
+    {
+      char buff[MAX_DATE_STRING_REP_LENGTH];
+      String str(buff, sizeof(buff), &my_charset_latin1);
+      make_date((DATE_TIME_FORMAT *) 0, ltime, &str);
+      set_datetime_warning(MYSQL_ERROR::WARN_LEVEL_WARN, WARN_DATA_TRUNCATED,
+                           str.ptr(), str.length(), MYSQL_TIMESTAMP_DATE, 1);
+    }
+    if (!error && ltime->time_type != MYSQL_TIMESTAMP_DATE &&
+        (ltime->hour || ltime->minute || ltime->second || ltime->second_part))
+    {
+      char buff[MAX_DATE_STRING_REP_LENGTH];
+      String str(buff, sizeof(buff), &my_charset_latin1);
+      make_datetime((DATE_TIME_FORMAT *) 0, ltime, &str);
+      set_datetime_warning(MYSQL_ERROR::WARN_LEVEL_NOTE,
+                           WARN_DATA_TRUNCATED,
+                           str.ptr(), str.length(), MYSQL_TIMESTAMP_DATE, 1);
+      error= 3;
+    }
+  }
+  else
+  {
+    tmp=0;
+    error= 1;
+    set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, WARN_DATA_TRUNCATED, 1);
+  }
+  int3store(ptr,tmp);
+  return error;
+}
+
+
+bool Field_newdate::send_binary(Protocol *protocol)
+{
+  MYSQL_TIME tm;
+  Field_newdate::get_date(&tm,0);
+  return protocol->store_date(&tm);
+}
+
+
+double Field_newdate::val_real(void)
+{
+  return (double) Field_newdate::val_int();
+}
+
+
+int64_t Field_newdate::val_int(void)
+{
+  ulong j= uint3korr(ptr);
+  j= (j % 32L)+(j / 32L % 16L)*100L + (j/(16L*32L))*10000L;
+  return (int64_t) j;
+}
+
+
+String *Field_newdate::val_str(String *val_buffer,
+			       String *val_ptr __attribute__((unused)))
+{
+  val_buffer->alloc(field_length);
+  val_buffer->length(field_length);
+  uint32 tmp=(uint32) uint3korr(ptr);
+  int part;
+  char *pos=(char*) val_buffer->ptr()+10;
+
+  /* Open coded to get more speed */
+  *pos--=0;					// End NULL
+  part=(int) (tmp & 31);
+  *pos--= (char) ('0'+part%10);
+  *pos--= (char) ('0'+part/10);
+  *pos--= '-';
+  part=(int) (tmp >> 5 & 15);
+  *pos--= (char) ('0'+part%10);
+  *pos--= (char) ('0'+part/10);
+  *pos--= '-';
+  part=(int) (tmp >> 9);
+  *pos--= (char) ('0'+part%10); part/=10;
+  *pos--= (char) ('0'+part%10); part/=10;
+  *pos--= (char) ('0'+part%10); part/=10;
+  *pos=   (char) ('0'+part);
+  return val_buffer;
+}
+
+
+bool Field_newdate::get_date(MYSQL_TIME *ltime,uint fuzzydate)
+{
+  uint32 tmp=(uint32) uint3korr(ptr);
+  ltime->day=   tmp & 31;
+  ltime->month= (tmp >> 5) & 15;
+  ltime->year=  (tmp >> 9);
+  ltime->time_type= MYSQL_TIMESTAMP_DATE;
+  ltime->hour= ltime->minute= ltime->second= ltime->second_part= ltime->neg= 0;
+  return ((!(fuzzydate & TIME_FUZZY_DATE) && (!ltime->month || !ltime->day)) ?
+          1 : 0);
+}
+
+
+bool Field_newdate::get_time(MYSQL_TIME *ltime)
+{
+  return Field_newdate::get_date(ltime,0);
+}
+
+
+int Field_newdate::cmp(const uchar *a_ptr, const uchar *b_ptr)
+{
+  uint32 a,b;
+  a=(uint32) uint3korr(a_ptr);
+  b=(uint32) uint3korr(b_ptr);
+  return (a < b) ? -1 : (a > b) ? 1 : 0;
+}
+
+
+void Field_newdate::sort_string(uchar *to,uint length __attribute__((unused)))
+{
+  to[0] = ptr[2];
+  to[1] = ptr[1];
+  to[2] = ptr[0];
+}
+
+
+void Field_newdate::sql_type(String &res) const
+{
+  res.set_ascii(STRING_WITH_LEN("date"));
+}
+

=== added file 'server/field/date.h'
--- server/field/date.h	1970-01-01 00:00:00 +0000
+++ server/field/date.h	2008-07-18 07:38:40 +0000
@@ -0,0 +1,62 @@
+/* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 MySQL
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLE_SERVER_FIELD_NEW_DATE
+#define DRIZZLE_SERVER_FIELD_NEW_DATE
+
+#include "mysql_priv.h"
+
+class Field_newdate :public Field_str {
+public:
+  Field_newdate(uchar *ptr_arg, uchar *null_ptr_arg, uchar null_bit_arg,
+		enum utype unireg_check_arg, const char *field_name_arg,
+		CHARSET_INFO *cs)
+    :Field_str(ptr_arg, 10, null_ptr_arg, null_bit_arg,
+	       unireg_check_arg, field_name_arg, cs)
+    {}
+  Field_newdate(bool maybe_null_arg, const char *field_name_arg,
+                CHARSET_INFO *cs)
+    :Field_str((uchar*) 0,10, maybe_null_arg ? (uchar*) "": 0,0,
+               NONE, field_name_arg, cs) {}
+  enum_field_types type() const { return MYSQL_TYPE_NEWDATE;}
+  enum_field_types real_type() const { return MYSQL_TYPE_NEWDATE; }
+  enum ha_base_keytype key_type() const { return HA_KEYTYPE_UINT24; }
+  enum Item_result cmp_type () const { return INT_RESULT; }
+  int  store(const char *to,uint length,CHARSET_INFO *charset);
+  int  store(double nr);
+  int  store(int64_t nr, bool unsigned_val);
+  int store_time(MYSQL_TIME *ltime, timestamp_type type);
+  int reset(void) { ptr[0]=ptr[1]=ptr[2]=0; return 0; }
+  double val_real(void);
+  int64_t val_int(void);
+  String *val_str(String*,String *);
+  bool send_binary(Protocol *protocol);
+  int cmp(const uchar *,const uchar *);
+  void sort_string(uchar *buff,uint length);
+  uint32 pack_length() const { return 3; }
+  void sql_type(String &str) const;
+  bool can_be_compared_as_int64_t() const { return true; }
+  bool zero_pack() const { return 1; }
+  bool get_date(MYSQL_TIME *ltime,uint fuzzydate);
+  bool get_time(MYSQL_TIME *ltime);
+};
+
+#endif
+

=== added file 'server/field/datetime.cc'
--- server/field/datetime.cc	1970-01-01 00:00:00 +0000
+++ server/field/datetime.cc	2008-07-18 02:28:40 +0000
@@ -0,0 +1,319 @@
+/* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 MySQL
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifdef USE_PRAGMA_IMPLEMENTATION
+#pragma implementation				// gcc: Class implementation
+#endif
+
+#include "datetime.h"
+
+/****************************************************************************
+** datetime type
+** In string context: YYYY-MM-DD HH:MM:DD
+** In number context: YYYYMMDDHHMMDD
+** Stored as a 8 byte unsigned int. Should sometimes be change to a 6 byte int.
+****************************************************************************/
+
+int Field_datetime::store(const char *from,
+                          uint len,
+                          CHARSET_INFO *cs __attribute__((__unused__)))
+{
+  MYSQL_TIME time_tmp;
+  int error;
+  uint64_t tmp= 0;
+  enum enum_mysql_timestamp_type func_res;
+  THD *thd= table ? table->in_use : current_thd;
+
+  func_res= str_to_datetime(from, len, &time_tmp,
+                            (TIME_FUZZY_DATE |
+                             (thd->variables.sql_mode &
+                              (MODE_NO_ZERO_IN_DATE | MODE_NO_ZERO_DATE |
+                               MODE_INVALID_DATES))),
+                            &error);
+  if ((int) func_res > (int) MYSQL_TIMESTAMP_ERROR)
+    tmp= TIME_to_uint64_t_datetime(&time_tmp);
+  else
+    error= 1;                                 // Fix if invalid zero date
+
+  if (error)
+    set_datetime_warning(MYSQL_ERROR::WARN_LEVEL_WARN,
+                         ER_WARN_DATA_OUT_OF_RANGE,
+                         from, len, MYSQL_TIMESTAMP_DATETIME, 1);
+
+#ifdef WORDS_BIGENDIAN
+  if (table && table->s->db_low_byte_first)
+  {
+    int8store(ptr,tmp);
+  }
+  else
+#endif
+    int64_tstore(ptr,tmp);
+  return error;
+}
+
+
+int Field_datetime::store(double nr)
+{
+  int error= 0;
+  if (nr < 0.0 || nr > 99991231235959.0)
+  {
+    set_datetime_warning(MYSQL_ERROR::WARN_LEVEL_WARN, 
+                         ER_WARN_DATA_OUT_OF_RANGE,
+                         nr, MYSQL_TIMESTAMP_DATETIME);
+    nr= 0.0;
+    error= 1;
+  }
+  error|= Field_datetime::store((int64_t) rint(nr), false);
+  return error;
+}
+
+
+int Field_datetime::store(int64_t nr,
+                          bool unsigned_val __attribute__((__unused__)))
+{
+  MYSQL_TIME not_used;
+  int error;
+  int64_t initial_nr= nr;
+  THD *thd= table ? table->in_use : current_thd;
+
+  nr= number_to_datetime(nr, &not_used, (TIME_FUZZY_DATE |
+                                         (thd->variables.sql_mode &
+                                          (MODE_NO_ZERO_IN_DATE |
+                                           MODE_NO_ZERO_DATE |
+                                           MODE_INVALID_DATES))), &error);
+
+  if (nr == -1LL)
+  {
+    nr= 0;
+    error= 2;
+  }
+
+  if (error)
+    set_datetime_warning(MYSQL_ERROR::WARN_LEVEL_WARN,
+                         error == 2 ? ER_WARN_DATA_OUT_OF_RANGE :
+                         WARN_DATA_TRUNCATED, initial_nr,
+                         MYSQL_TIMESTAMP_DATETIME, 1);
+
+#ifdef WORDS_BIGENDIAN
+  if (table && table->s->db_low_byte_first)
+  {
+    int8store(ptr,nr);
+  }
+  else
+#endif
+    int64_tstore(ptr,nr);
+  return error;
+}
+
+
+int Field_datetime::store_time(MYSQL_TIME *ltime,timestamp_type time_type)
+{
+  int64_t tmp;
+  int error= 0;
+  /*
+    We don't perform range checking here since values stored in TIME
+    structure always fit into DATETIME range.
+  */
+  if (time_type == MYSQL_TIMESTAMP_DATE ||
+      time_type == MYSQL_TIMESTAMP_DATETIME)
+  {
+    tmp=((ltime->year*10000L+ltime->month*100+ltime->day)*1000000LL+
+	 (ltime->hour*10000L+ltime->minute*100+ltime->second));
+    if (check_date(ltime, tmp != 0,
+                   (TIME_FUZZY_DATE |
+                    (current_thd->variables.sql_mode &
+                     (MODE_NO_ZERO_IN_DATE | MODE_NO_ZERO_DATE |
+                      MODE_INVALID_DATES))), &error))
+    {
+      char buff[MAX_DATE_STRING_REP_LENGTH];
+      String str(buff, sizeof(buff), &my_charset_latin1);
+      make_datetime((DATE_TIME_FORMAT *) 0, ltime, &str);
+      set_datetime_warning(MYSQL_ERROR::WARN_LEVEL_WARN, WARN_DATA_TRUNCATED,
+                           str.ptr(), str.length(), MYSQL_TIMESTAMP_DATETIME,1);
+    }
+  }
+  else
+  {
+    tmp=0;
+    error= 1;
+    set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, WARN_DATA_TRUNCATED, 1);
+  }
+#ifdef WORDS_BIGENDIAN
+  if (table && table->s->db_low_byte_first)
+  {
+    int8store(ptr,tmp);
+  }
+  else
+#endif
+    int64_tstore(ptr,tmp);
+  return error;
+}
+
+bool Field_datetime::send_binary(Protocol *protocol)
+{
+  MYSQL_TIME tm;
+  Field_datetime::get_date(&tm, TIME_FUZZY_DATE);
+  return protocol->store(&tm);
+}
+
+
+double Field_datetime::val_real(void)
+{
+  return (double) Field_datetime::val_int();
+}
+
+int64_t Field_datetime::val_int(void)
+{
+  int64_t j;
+#ifdef WORDS_BIGENDIAN
+  if (table && table->s->db_low_byte_first)
+    j=sint8korr(ptr);
+  else
+#endif
+    int64_tget(j,ptr);
+  return j;
+}
+
+
+String *Field_datetime::val_str(String *val_buffer,
+				String *val_ptr __attribute__((unused)))
+{
+  val_buffer->alloc(field_length);
+  val_buffer->length(field_length);
+  uint64_t tmp;
+  long part1,part2;
+  char *pos;
+  int part3;
+
+#ifdef WORDS_BIGENDIAN
+  if (table && table->s->db_low_byte_first)
+    tmp=sint8korr(ptr);
+  else
+#endif
+    int64_tget(tmp,ptr);
+
+  /*
+    Avoid problem with slow int64_t arithmetic and sprintf
+  */
+
+  part1=(long) (tmp/1000000LL);
+  part2=(long) (tmp - (uint64_t) part1*1000000LL);
+
+  pos=(char*) val_buffer->ptr() + MAX_DATETIME_WIDTH;
+  *pos--=0;
+  *pos--= (char) ('0'+(char) (part2%10)); part2/=10;
+  *pos--= (char) ('0'+(char) (part2%10)); part3= (int) (part2 / 10);
+  *pos--= ':';
+  *pos--= (char) ('0'+(char) (part3%10)); part3/=10;
+  *pos--= (char) ('0'+(char) (part3%10)); part3/=10;
+  *pos--= ':';
+  *pos--= (char) ('0'+(char) (part3%10)); part3/=10;
+  *pos--= (char) ('0'+(char) part3);
+  *pos--= ' ';
+  *pos--= (char) ('0'+(char) (part1%10)); part1/=10;
+  *pos--= (char) ('0'+(char) (part1%10)); part1/=10;
+  *pos--= '-';
+  *pos--= (char) ('0'+(char) (part1%10)); part1/=10;
+  *pos--= (char) ('0'+(char) (part1%10)); part3= (int) (part1/10);
+  *pos--= '-';
+  *pos--= (char) ('0'+(char) (part3%10)); part3/=10;
+  *pos--= (char) ('0'+(char) (part3%10)); part3/=10;
+  *pos--= (char) ('0'+(char) (part3%10)); part3/=10;
+  *pos=(char) ('0'+(char) part3);
+  return val_buffer;
+}
+
+bool Field_datetime::get_date(MYSQL_TIME *ltime, uint fuzzydate)
+{
+  int64_t tmp=Field_datetime::val_int();
+  uint32 part1,part2;
+  part1=(uint32) (tmp/1000000LL);
+  part2=(uint32) (tmp - (uint64_t) part1*1000000LL);
+
+  ltime->time_type=	MYSQL_TIMESTAMP_DATETIME;
+  ltime->neg=		0;
+  ltime->second_part=	0;
+  ltime->second=	(int) (part2%100);
+  ltime->minute=	(int) (part2/100%100);
+  ltime->hour=		(int) (part2/10000);
+  ltime->day=		(int) (part1%100);
+  ltime->month= 	(int) (part1/100%100);
+  ltime->year= 		(int) (part1/10000);
+  return (!(fuzzydate & TIME_FUZZY_DATE) && (!ltime->month || !ltime->day)) ? 1 : 0;
+}
+
+bool Field_datetime::get_time(MYSQL_TIME *ltime)
+{
+  return Field_datetime::get_date(ltime,0);
+}
+
+int Field_datetime::cmp(const uchar *a_ptr, const uchar *b_ptr)
+{
+  int64_t a,b;
+#ifdef WORDS_BIGENDIAN
+  if (table && table->s->db_low_byte_first)
+  {
+    a=sint8korr(a_ptr);
+    b=sint8korr(b_ptr);
+  }
+  else
+#endif
+  {
+    int64_tget(a,a_ptr);
+    int64_tget(b,b_ptr);
+  }
+  return ((uint64_t) a < (uint64_t) b) ? -1 :
+    ((uint64_t) a > (uint64_t) b) ? 1 : 0;
+}
+
+void Field_datetime::sort_string(uchar *to,uint length __attribute__((unused)))
+{
+#ifdef WORDS_BIGENDIAN
+  if (!table || !table->s->db_low_byte_first)
+  {
+    to[0] = ptr[0];
+    to[1] = ptr[1];
+    to[2] = ptr[2];
+    to[3] = ptr[3];
+    to[4] = ptr[4];
+    to[5] = ptr[5];
+    to[6] = ptr[6];
+    to[7] = ptr[7];
+  }
+  else
+#endif
+  {
+    to[0] = ptr[7];
+    to[1] = ptr[6];
+    to[2] = ptr[5];
+    to[3] = ptr[4];
+    to[4] = ptr[3];
+    to[5] = ptr[2];
+    to[6] = ptr[1];
+    to[7] = ptr[0];
+  }
+}
+
+
+void Field_datetime::sql_type(String &res) const
+{
+  res.set_ascii(STRING_WITH_LEN("datetime"));
+}
+

=== added file 'server/field/datetime.h'
--- server/field/datetime.h	1970-01-01 00:00:00 +0000
+++ server/field/datetime.h	2008-07-18 02:28:40 +0000
@@ -0,0 +1,66 @@
+/* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 MySQL
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLE_SERVER_FIELD_DATETIME
+#define DRIZZLE_SERVER_FIELD_DATETIME
+
+#include "mysql_priv.h"
+
+class Field_datetime :public Field_str {
+public:
+  Field_datetime(uchar *ptr_arg, uchar *null_ptr_arg, uchar null_bit_arg,
+		 enum utype unireg_check_arg, const char *field_name_arg,
+		 CHARSET_INFO *cs)
+    :Field_str(ptr_arg, 19, null_ptr_arg, null_bit_arg,
+	       unireg_check_arg, field_name_arg, cs)
+    {}
+  Field_datetime(bool maybe_null_arg, const char *field_name_arg,
+		 CHARSET_INFO *cs)
+    :Field_str((uchar*) 0,19, maybe_null_arg ? (uchar*) "": 0,0,
+	       NONE, field_name_arg, cs) {}
+  enum_field_types type() const { return MYSQL_TYPE_DATETIME;}
+  enum ha_base_keytype key_type() const { return HA_KEYTYPE_ULONGLONG; }
+  enum Item_result cmp_type () const { return INT_RESULT; }
+  uint decimals() const { return DATETIME_DEC; }
+  int  store(const char *to,uint length,CHARSET_INFO *charset);
+  int  store(double nr);
+  int  store(int64_t nr, bool unsigned_val);
+  int store_time(MYSQL_TIME *ltime, timestamp_type type);
+  int reset(void)
+  {
+    ptr[0]=ptr[1]=ptr[2]=ptr[3]=ptr[4]=ptr[5]=ptr[6]=ptr[7]=0;
+    return 0;
+  }
+  double val_real(void);
+  int64_t val_int(void);
+  String *val_str(String*,String *);
+  bool send_binary(Protocol *protocol);
+  int cmp(const uchar *,const uchar *);
+  void sort_string(uchar *buff,uint length);
+  uint32 pack_length() const { return 8; }
+  void sql_type(String &str) const;
+  bool can_be_compared_as_int64_t() const { return true; }
+  bool zero_pack() const { return 1; }
+  bool get_date(MYSQL_TIME *ltime,uint fuzzydate);
+  bool get_time(MYSQL_TIME *ltime);
+};
+
+#endif
+

=== added file 'server/field/decimal.cc'
--- server/field/decimal.cc	1970-01-01 00:00:00 +0000
+++ server/field/decimal.cc	2008-07-18 07:38:40 +0000
@@ -0,0 +1,446 @@
+/* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 MySQL
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifdef USE_PRAGMA_IMPLEMENTATION
+#pragma implementation				// gcc: Class implementation
+#endif
+
+#include "decimal.h"
+
+/****************************************************************************
+** Field_new_decimal
+****************************************************************************/
+
+Field_new_decimal::Field_new_decimal(uchar *ptr_arg,
+                                     uint32 len_arg, uchar *null_ptr_arg,
+                                     uchar null_bit_arg,
+                                     enum utype unireg_check_arg,
+                                     const char *field_name_arg,
+                                     uint8 dec_arg,bool zero_arg,
+                                     bool unsigned_arg)
+  :Field_num(ptr_arg, len_arg, null_ptr_arg, null_bit_arg,
+             unireg_check_arg, field_name_arg, dec_arg, zero_arg, unsigned_arg)
+{
+  precision= my_decimal_length_to_precision(len_arg, dec_arg, unsigned_arg);
+  set_if_smaller(precision, DECIMAL_MAX_PRECISION);
+  assert((precision <= DECIMAL_MAX_PRECISION) &&
+              (dec <= DECIMAL_MAX_SCALE));
+  bin_size= my_decimal_get_binary_size(precision, dec);
+}
+
+
+Field_new_decimal::Field_new_decimal(uint32 len_arg,
+                                     bool maybe_null_arg,
+                                     const char *name,
+                                     uint8 dec_arg,
+                                     bool unsigned_arg)
+  :Field_num((uchar*) 0, len_arg,
+             maybe_null_arg ? (uchar*) "": 0, 0,
+             NONE, name, dec_arg, 0, unsigned_arg)
+{
+  precision= my_decimal_length_to_precision(len_arg, dec_arg, unsigned_arg);
+  set_if_smaller(precision, DECIMAL_MAX_PRECISION);
+  assert((precision <= DECIMAL_MAX_PRECISION) &&
+              (dec <= DECIMAL_MAX_SCALE));
+  bin_size= my_decimal_get_binary_size(precision, dec);
+}
+
+
+int Field_new_decimal::reset(void)
+{
+  store_value(&decimal_zero);
+  return 0;
+}
+
+
+/**
+  Generate max/min decimal value in case of overflow.
+
+  @param decimal_value     buffer for value
+  @param sign              sign of value which caused overflow
+*/
+
+void Field_new_decimal::set_value_on_overflow(my_decimal *decimal_value,
+                                              bool sign)
+{
+  max_my_decimal(decimal_value, precision, decimals());
+  if (sign)
+  {
+    if (unsigned_flag)
+      my_decimal_set_zero(decimal_value);
+    else
+      decimal_value->sign(true);
+  }
+  return;
+}
+
+
+/**
+  Store decimal value in the binary buffer.
+
+  Checks if decimal_value fits into field size.
+  If it does, stores the decimal in the buffer using binary format.
+  Otherwise sets maximal number that can be stored in the field.
+
+  @param decimal_value   my_decimal
+
+  @retval
+    0 ok
+  @retval
+    1 error
+*/
+
+bool Field_new_decimal::store_value(const my_decimal *decimal_value)
+{
+  int error= 0;
+
+  /* check that we do not try to write negative value in unsigned field */
+  if (unsigned_flag && decimal_value->sign())
+  {
+    set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
+    error= 1;
+    decimal_value= &decimal_zero;
+  }
+
+  if (warn_if_overflow(my_decimal2binary(E_DEC_FATAL_ERROR & ~E_DEC_OVERFLOW,
+                                         decimal_value, ptr, precision, dec)))
+  {
+    my_decimal buff;
+    set_value_on_overflow(&buff, decimal_value->sign());
+    my_decimal2binary(E_DEC_FATAL_ERROR, &buff, ptr, precision, dec);
+    error= 1;
+  }
+  return(error);
+}
+
+
+int Field_new_decimal::store(const char *from, uint length,
+                             CHARSET_INFO *charset_arg)
+{
+  int err;
+  my_decimal decimal_value;
+
+  if ((err= str2my_decimal(E_DEC_FATAL_ERROR &
+                           ~(E_DEC_OVERFLOW | E_DEC_BAD_NUM),
+                           from, length, charset_arg,
+                           &decimal_value)) &&
+      table->in_use->abort_on_warning)
+  {
+    /* Because "from" is not NUL-terminated and we use %s in the ER() */
+    String from_as_str;
+    from_as_str.copy(from, length, &my_charset_bin);
+
+    push_warning_printf(table->in_use, MYSQL_ERROR::WARN_LEVEL_ERROR,
+                        ER_TRUNCATED_WRONG_VALUE_FOR_FIELD,
+                        ER(ER_TRUNCATED_WRONG_VALUE_FOR_FIELD),
+                        "decimal", from_as_str.c_ptr(), field_name,
+                        (ulong) table->in_use->row_count);
+
+    return(err);
+  }
+
+  switch (err) {
+  case E_DEC_TRUNCATED:
+    set_warning(MYSQL_ERROR::WARN_LEVEL_NOTE, WARN_DATA_TRUNCATED, 1);
+    break;
+  case E_DEC_OVERFLOW:
+    set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
+    set_value_on_overflow(&decimal_value, decimal_value.sign());
+    break;
+  case E_DEC_BAD_NUM:
+    {
+      /* Because "from" is not NUL-terminated and we use %s in the ER() */
+      String from_as_str;
+      from_as_str.copy(from, length, &my_charset_bin);
+
+    push_warning_printf(table->in_use, MYSQL_ERROR::WARN_LEVEL_WARN,
+                        ER_TRUNCATED_WRONG_VALUE_FOR_FIELD,
+                        ER(ER_TRUNCATED_WRONG_VALUE_FOR_FIELD),
+                          "decimal", from_as_str.c_ptr(), field_name,
+                        (ulong) table->in_use->row_count);
+    my_decimal_set_zero(&decimal_value);
+
+    break;
+    }
+  }
+
+  store_value(&decimal_value);
+  return(err);
+}
+
+
+/**
+  @todo
+  Fix following when double2my_decimal when double2decimal
+  will return E_DEC_TRUNCATED always correctly
+*/
+
+int Field_new_decimal::store(double nr)
+{
+  my_decimal decimal_value;
+  int err;
+
+  err= double2my_decimal(E_DEC_FATAL_ERROR & ~E_DEC_OVERFLOW, nr,
+                         &decimal_value);
+  if (err)
+  {
+    if (check_overflow(err))
+      set_value_on_overflow(&decimal_value, decimal_value.sign());
+    /* Only issue a warning if store_value doesn't issue an warning */
+    table->in_use->got_warning= 0;
+  }
+  if (store_value(&decimal_value))
+    err= 1;
+  else if (err && !table->in_use->got_warning)
+    err= warn_if_overflow(err);
+  return(err);
+}
+
+
+int Field_new_decimal::store(int64_t nr, bool unsigned_val)
+{
+  my_decimal decimal_value;
+  int err;
+
+  if ((err= int2my_decimal(E_DEC_FATAL_ERROR & ~E_DEC_OVERFLOW,
+                           nr, unsigned_val, &decimal_value)))
+  {
+    if (check_overflow(err))
+      set_value_on_overflow(&decimal_value, decimal_value.sign());
+    /* Only issue a warning if store_value doesn't issue an warning */
+    table->in_use->got_warning= 0;
+  }
+  if (store_value(&decimal_value))
+    err= 1;
+  else if (err && !table->in_use->got_warning)
+    err= warn_if_overflow(err);
+  return err;
+}
+
+
+int Field_new_decimal::store_decimal(const my_decimal *decimal_value)
+{
+  return store_value(decimal_value);
+}
+
+
+int Field_new_decimal::store_time(MYSQL_TIME *ltime,
+                                  timestamp_type t_type __attribute__((__unused__)))
+{
+    my_decimal decimal_value;
+    return store_value(date2my_decimal(ltime, &decimal_value));
+}
+
+
+double Field_new_decimal::val_real(void)
+{
+  double dbl;
+  my_decimal decimal_value;
+  my_decimal2double(E_DEC_FATAL_ERROR, val_decimal(&decimal_value), &dbl);
+  return dbl;
+}
+
+
+int64_t Field_new_decimal::val_int(void)
+{
+  int64_t i;
+  my_decimal decimal_value;
+  my_decimal2int(E_DEC_FATAL_ERROR, val_decimal(&decimal_value),
+                 unsigned_flag, &i);
+  return i;
+}
+
+
+my_decimal* Field_new_decimal::val_decimal(my_decimal *decimal_value)
+{
+  binary2my_decimal(E_DEC_FATAL_ERROR, ptr, decimal_value,
+                    precision, dec);
+  return(decimal_value);
+}
+
+
+String *Field_new_decimal::val_str(String *val_buffer,
+                                   String *val_ptr __attribute__((unused)))
+{
+  my_decimal decimal_value;
+  uint fixed_precision= zerofill ? precision : 0;
+  my_decimal2string(E_DEC_FATAL_ERROR, val_decimal(&decimal_value),
+                    fixed_precision, dec, '0', val_buffer);
+  return val_buffer;
+}
+
+
+int Field_new_decimal::cmp(const uchar *a,const uchar*b)
+{
+  return memcmp(a, b, bin_size);
+}
+
+
+void Field_new_decimal::sort_string(uchar *buff,
+                                    uint length __attribute__((unused)))
+{
+  memcpy(buff, ptr, bin_size);
+}
+
+
+void Field_new_decimal::sql_type(String &str) const
+{
+  CHARSET_INFO *cs= str.charset();
+  str.length(cs->cset->snprintf(cs, (char*) str.ptr(), str.alloced_length(),
+                                "decimal(%d,%d)", precision, (int)dec));
+  add_zerofill_and_unsigned(str);
+}
+
+
+/**
+   Save the field metadata for new decimal fields.
+
+   Saves the precision in the first byte and decimals() in the second
+   byte of the field metadata array at index of *metadata_ptr and 
+   *(metadata_ptr + 1).
+
+   @param   metadata_ptr   First byte of field metadata
+
+   @returns number of bytes written to metadata_ptr
+*/
+int Field_new_decimal::do_save_field_metadata(uchar *metadata_ptr)
+{
+  *metadata_ptr= precision;
+  *(metadata_ptr + 1)= decimals();
+  return 2;
+}
+
+
+/**
+   Returns the number of bytes field uses in row-based replication 
+   row packed size.
+
+   This method is used in row-based replication to determine the number
+   of bytes that the field consumes in the row record format. This is
+   used to skip fields in the master that do not exist on the slave.
+
+   @param   field_metadata   Encoded size in field metadata
+
+   @returns The size of the field based on the field metadata.
+*/
+uint Field_new_decimal::pack_length_from_metadata(uint field_metadata)
+{
+  uint const source_precision= (field_metadata >> 8U) & 0x00ff;
+  uint const source_decimal= field_metadata & 0x00ff; 
+  uint const source_size= my_decimal_get_binary_size(source_precision, 
+                                                     source_decimal);
+  return (source_size);
+}
+
+
+/**
+   Check to see if field size is compatible with destination.
+
+   This method is used in row-based replication to verify that the slave's
+   field size is less than or equal to the master's field size. The 
+   encoded field metadata (from the master or source) is decoded and compared
+   to the size of this field (the slave or destination). 
+
+   @param   field_metadata   Encoded size in field metadata
+
+   @retval 0 if this field's size is < the source field's size
+   @retval 1 if this field's size is >= the source field's size
+*/
+int Field_new_decimal::compatible_field_size(uint field_metadata)
+{
+  int compatible= 0;
+  uint const source_precision= (field_metadata >> 8U) & 0x00ff;
+  uint const source_decimal= field_metadata & 0x00ff; 
+  uint const source_size= my_decimal_get_binary_size(source_precision, 
+                                                     source_decimal);
+  uint const destination_size= row_pack_length();
+  compatible= (source_size <= destination_size);
+  if (compatible)
+    compatible= (source_precision <= precision) &&
+                (source_decimal <= decimals());
+  return (compatible);
+}
+
+
+uint Field_new_decimal::is_equal(Create_field *new_field)
+{
+  return ((new_field->sql_type == real_type()) &&
+          ((new_field->flags & UNSIGNED_FLAG) == 
+           (uint) (flags & UNSIGNED_FLAG)) &&
+          ((new_field->flags & AUTO_INCREMENT_FLAG) ==
+           (uint) (flags & AUTO_INCREMENT_FLAG)) &&
+          (new_field->length == max_display_length()) &&
+          (new_field->decimals == dec));
+}
+
+
+/**
+   Unpack a decimal field from row data.
+
+   This method is used to unpack a decimal or numeric field from a master
+   whose size of the field is less than that of the slave.
+  
+   @param   to         Destination of the data
+   @param   from       Source of the data
+   @param   param_data Precision (upper) and decimal (lower) values
+
+   @return  New pointer into memory based on from + length of the data
+*/
+const uchar *
+Field_new_decimal::unpack(uchar* to,
+                          const uchar *from,
+                          uint param_data,
+                          bool low_byte_first)
+{
+  if (param_data == 0)
+    return Field::unpack(to, from, param_data, low_byte_first);
+
+  uint from_precision= (param_data & 0xff00) >> 8U;
+  uint from_decimal= param_data & 0x00ff;
+  uint length=pack_length();
+  uint from_pack_len= my_decimal_get_binary_size(from_precision, from_decimal);
+  uint len= (param_data && (from_pack_len < length)) ?
+            from_pack_len : length;
+  if ((from_pack_len && (from_pack_len < length)) ||
+      (from_precision < precision) ||
+      (from_decimal < decimals()))
+  {
+    /*
+      If the master's data is smaller than the slave, we need to convert
+      the binary to decimal then resize the decimal converting it back to
+      a decimal and write that to the raw data buffer.
+    */
+    decimal_digit_t dec_buf[DECIMAL_MAX_PRECISION];
+    decimal_t dec;
+    dec.len= from_precision;
+    dec.buf= dec_buf;
+    /*
+      Note: bin2decimal does not change the length of the field. So it is
+      just the first step the resizing operation. The second step does the
+      resizing using the precision and decimals from the slave.
+    */
+    bin2decimal((uchar *)from, &dec, from_precision, from_decimal);
+    decimal2bin(&dec, to, precision, decimals());
+  }
+  else
+    memcpy(to, from, len); // Sizes are the same, just copy the data.
+  return from+len;
+}
+

=== added file 'server/field/decimal.h'
--- server/field/decimal.h	1970-01-01 00:00:00 +0000
+++ server/field/decimal.h	2008-07-18 07:38:40 +0000
@@ -0,0 +1,78 @@
+/* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 MySQL
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLE_SERVER_FIELD_NEW_DECIMAL
+#define DRIZZLE_SERVER_FIELD_NEW_DECIMAL
+
+#include "mysql_priv.h"
+
+/* New decimal/numeric field which use fixed point arithmetic */
+class Field_new_decimal :public Field_num {
+private:
+  int do_save_field_metadata(uchar *first_byte);
+public:
+  /* The maximum number of decimal digits can be stored */
+  uint precision;
+  uint bin_size;
+  /*
+    Constructors take max_length of the field as a parameter - not the
+    precision as the number of decimal digits allowed.
+    So for example we need to count length from precision handling
+    CREATE TABLE ( DECIMAL(x,y)) 
+  */
+  Field_new_decimal(uchar *ptr_arg, uint32 len_arg, uchar *null_ptr_arg,
+                    uchar null_bit_arg,
+                    enum utype unireg_check_arg, const char *field_name_arg,
+                    uint8 dec_arg, bool zero_arg, bool unsigned_arg);
+  Field_new_decimal(uint32 len_arg, bool maybe_null_arg,
+                    const char *field_name_arg, uint8 dec_arg,
+                    bool unsigned_arg);
+  enum_field_types type() const { return MYSQL_TYPE_NEWDECIMAL;}
+  enum ha_base_keytype key_type() const { return HA_KEYTYPE_BINARY; }
+  Item_result result_type () const { return DECIMAL_RESULT; }
+  int  reset(void);
+  bool store_value(const my_decimal *decimal_value);
+  void set_value_on_overflow(my_decimal *decimal_value, bool sign);
+  int  store(const char *to, uint length, CHARSET_INFO *charset);
+  int  store(double nr);
+  int  store(int64_t nr, bool unsigned_val);
+  int store_time(MYSQL_TIME *ltime, timestamp_type t_type);
+  int  store_decimal(const my_decimal *);
+  double val_real(void);
+  int64_t val_int(void);
+  my_decimal *val_decimal(my_decimal *);
+  String *val_str(String*, String *);
+  int cmp(const uchar *, const uchar *);
+  void sort_string(uchar *buff, uint length);
+  bool zero_pack() const { return 0; }
+  void sql_type(String &str) const;
+  uint32 max_display_length() { return field_length; }
+  uint size_of() const { return sizeof(*this); } 
+  uint32 pack_length() const { return (uint32) bin_size; }
+  uint pack_length_from_metadata(uint field_metadata);
+  uint row_pack_length() { return pack_length(); }
+  int compatible_field_size(uint field_metadata);
+  uint is_equal(Create_field *new_field);
+  virtual const uchar *unpack(uchar* to, const uchar *from,
+                              uint param_data, bool low_byte_first);
+};
+
+#endif
+

=== added file 'server/field/double.cc'
--- server/field/double.cc	1970-01-01 00:00:00 +0000
+++ server/field/double.cc	2008-07-18 09:10:25 +0000
@@ -0,0 +1,302 @@
+/* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 MySQL
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifdef USE_PRAGMA_IMPLEMENTATION
+#pragma implementation				// gcc: Class implementation
+#endif
+
+#include "double.h"
+
+/****************************************************************************
+  double precision floating point numbers
+****************************************************************************/
+
+int Field_double::store(const char *from,uint len,CHARSET_INFO *cs)
+{
+  int error;
+  char *end;
+  double nr= my_strntod(cs,(char*) from, len, &end, &error);
+  if (error || (!len || (((uint) (end-from) != len) && table->in_use->count_cuted_fields)))
+  {
+    set_warning(MYSQL_ERROR::WARN_LEVEL_WARN,
+                (error ? ER_WARN_DATA_OUT_OF_RANGE : WARN_DATA_TRUNCATED), 1);
+    error= error ? 1 : 2;
+  }
+  Field_double::store(nr);
+  return error;
+}
+
+
+int Field_double::store(double nr)
+{
+  int error= truncate(&nr, DBL_MAX);
+
+#ifdef WORDS_BIGENDIAN
+  if (table->s->db_low_byte_first)
+  {
+    float8store(ptr,nr);
+  }
+  else
+#endif
+    doublestore(ptr,nr);
+  return error;
+}
+
+
+int Field_double::store(int64_t nr, bool unsigned_val)
+{
+  return Field_double::store(unsigned_val ? uint64_t2double((uint64_t) nr) :
+                             (double) nr);
+}
+
+/*
+  If a field has fixed length, truncate the double argument pointed to by 'nr'
+  appropriately.
+  Also ensure that the argument is within [-max_value; max_value] range.
+*/
+
+int Field_real::truncate(double *nr, double max_value)
+{
+  int error= 1;
+  double res= *nr;
+  
+  if (isnan(res))
+  {
+    res= 0;
+    set_null();
+    set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
+    goto end;
+  }
+  else if (unsigned_flag && res < 0)
+  {
+    res= 0;
+    set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
+    goto end;
+  }
+
+  if (!not_fixed)
+  {
+    uint order= field_length - dec;
+    uint step= array_elements(log_10) - 1;
+    max_value= 1.0;
+    for (; order > step; order-= step)
+      max_value*= log_10[step];
+    max_value*= log_10[order];
+    max_value-= 1.0 / log_10[dec];
+
+    /* Check for infinity so we don't get NaN in calculations */
+    if (!my_isinf(res))
+    {
+      double tmp= rint((res - floor(res)) * log_10[dec]) / log_10[dec];
+      res= floor(res) + tmp;
+    }
+  }
+  
+  if (res < -max_value)
+  {
+   res= -max_value;
+   set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
+  }
+  else if (res > max_value)
+  {
+    res= max_value;
+    set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
+  }
+  else
+    error= 0;
+
+end:
+  *nr= res;
+  return error;
+}
+
+
+int Field_real::store_decimal(const my_decimal *dm)
+{
+  double dbl;
+  my_decimal2double(E_DEC_FATAL_ERROR, dm, &dbl);
+  return store(dbl);
+}
+
+double Field_double::val_real(void)
+{
+  double j;
+#ifdef WORDS_BIGENDIAN
+  if (table->s->db_low_byte_first)
+  {
+    float8get(j,ptr);
+  }
+  else
+#endif
+    doubleget(j,ptr);
+  return j;
+}
+
+int64_t Field_double::val_int(void)
+{
+  double j;
+  int64_t res;
+#ifdef WORDS_BIGENDIAN
+  if (table->s->db_low_byte_first)
+  {
+    float8get(j,ptr);
+  }
+  else
+#endif
+    doubleget(j,ptr);
+  /* Check whether we fit into int64_t range */
+  if (j <= (double) INT64_MIN)
+  {
+    res= (int64_t) INT64_MIN;
+    goto warn;
+  }
+  if (j >= (double) (uint64_t) INT64_MAX)
+  {
+    res= (int64_t) INT64_MAX;
+    goto warn;
+  }
+  return (int64_t) rint(j);
+
+warn:
+  {
+    char buf[DOUBLE_TO_STRING_CONVERSION_BUFFER_SIZE];
+    String tmp(buf, sizeof(buf), &my_charset_latin1), *str;
+    str= val_str(&tmp, 0);
+    push_warning_printf(current_thd, MYSQL_ERROR::WARN_LEVEL_WARN,
+                        ER_TRUNCATED_WRONG_VALUE,
+                        ER(ER_TRUNCATED_WRONG_VALUE), "INTEGER",
+                        str->c_ptr());
+  }
+  return res;
+}
+
+
+my_decimal *Field_real::val_decimal(my_decimal *decimal_value)
+{
+  double2my_decimal(E_DEC_FATAL_ERROR, val_real(), decimal_value);
+  return decimal_value;
+}
+
+
+String *Field_double::val_str(String *val_buffer,
+			      String *val_ptr __attribute__((unused)))
+{
+  double nr;
+#ifdef WORDS_BIGENDIAN
+  if (table->s->db_low_byte_first)
+  {
+    float8get(nr,ptr);
+  }
+  else
+#endif
+    doubleget(nr,ptr);
+
+  uint to_length=max(field_length, DOUBLE_TO_STRING_CONVERSION_BUFFER_SIZE);
+  val_buffer->alloc(to_length);
+  char *to=(char*) val_buffer->ptr();
+  size_t len;
+
+  if (dec >= NOT_FIXED_DEC)
+    len= my_gcvt(nr, MY_GCVT_ARG_DOUBLE, to_length - 1, to, NULL);
+  else
+    len= my_fcvt(nr, dec, to, NULL);
+
+  val_buffer->length((uint) len);
+  if (zerofill)
+    prepend_zeros(val_buffer);
+  return val_buffer;
+}
+
+bool Field_double::send_binary(Protocol *protocol)
+{
+  return protocol->store((double) Field_double::val_real(), dec, (String*) 0);
+}
+
+
+int Field_double::cmp(const uchar *a_ptr, const uchar *b_ptr)
+{
+  double a,b;
+#ifdef WORDS_BIGENDIAN
+  if (table->s->db_low_byte_first)
+  {
+    float8get(a,a_ptr);
+    float8get(b,b_ptr);
+  }
+  else
+#endif
+  {
+    doubleget(a, a_ptr);
+    doubleget(b, b_ptr);
+  }
+  return (a < b) ? -1 : (a > b) ? 1 : 0;
+}
+
+
+#define DBL_EXP_DIG (sizeof(double)*8-DBL_MANT_DIG)
+
+/* The following should work for IEEE */
+
+void Field_double::sort_string(uchar *to,uint length __attribute__((unused)))
+{
+  double nr;
+#ifdef WORDS_BIGENDIAN
+  if (table->s->db_low_byte_first)
+  {
+    float8get(nr,ptr);
+  }
+  else
+#endif
+    doubleget(nr,ptr);
+  change_double_for_sort(nr, to);
+}
+
+
+/**
+   Save the field metadata for double fields.
+
+   Saves the pack length in the first byte of the field metadata array
+   at index of *metadata_ptr.
+
+   @param   metadata_ptr   First byte of field metadata
+
+   @returns number of bytes written to metadata_ptr
+*/
+int Field_double::do_save_field_metadata(uchar *metadata_ptr)
+{
+  *metadata_ptr= pack_length();
+  return 1;
+}
+
+
+void Field_double::sql_type(String &res) const
+{
+  CHARSET_INFO *cs=res.charset();
+  if (dec == NOT_FIXED_DEC)
+  {
+    res.set_ascii(STRING_WITH_LEN("double"));
+  }
+  else
+  {
+    res.length(cs->cset->snprintf(cs,(char*) res.ptr(),res.alloced_length(),
+			    "double(%d,%d)",(int) field_length,dec));
+  }
+  add_zerofill_and_unsigned(res);
+}
+

=== added file 'server/field/double.h'
--- server/field/double.h	1970-01-01 00:00:00 +0000
+++ server/field/double.h	2008-07-18 09:10:25 +0000
@@ -0,0 +1,66 @@
+/* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 MySQL
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLE_SERVER_FIELD_DOUBLE
+#define DRIZZLE_SERVER_FIELD_DOUBLE
+
+#include "mysql_priv.h"
+
+class Field_double :public Field_real {
+public:
+  Field_double(uchar *ptr_arg, uint32 len_arg, uchar *null_ptr_arg,
+	       uchar null_bit_arg,
+	       enum utype unireg_check_arg, const char *field_name_arg,
+	       uint8 dec_arg,bool zero_arg,bool unsigned_arg)
+    :Field_real(ptr_arg, len_arg, null_ptr_arg, null_bit_arg,
+                unireg_check_arg, field_name_arg,
+                dec_arg, zero_arg, unsigned_arg)
+    {}
+  Field_double(uint32 len_arg, bool maybe_null_arg, const char *field_name_arg,
+	       uint8 dec_arg)
+    :Field_real((uchar*) 0, len_arg, maybe_null_arg ? (uchar*) "" : 0, (uint) 0,
+                NONE, field_name_arg, dec_arg, 0, 0)
+    {}
+  Field_double(uint32 len_arg, bool maybe_null_arg, const char *field_name_arg,
+	       uint8 dec_arg, my_bool not_fixed_arg)
+    :Field_real((uchar*) 0, len_arg, maybe_null_arg ? (uchar*) "" : 0, (uint) 0,
+                NONE, field_name_arg, dec_arg, 0, 0)
+    {not_fixed= not_fixed_arg; }
+  enum_field_types type() const { return MYSQL_TYPE_DOUBLE;}
+  enum ha_base_keytype key_type() const { return HA_KEYTYPE_DOUBLE; }
+  int  store(const char *to,uint length,CHARSET_INFO *charset);
+  int  store(double nr);
+  int  store(int64_t nr, bool unsigned_val);
+  int reset(void) { bzero(ptr,sizeof(double)); return 0; }
+  double val_real(void);
+  int64_t val_int(void);
+  String *val_str(String*,String *);
+  bool send_binary(Protocol *protocol);
+  int cmp(const uchar *,const uchar *);
+  void sort_string(uchar *buff,uint length);
+  uint32 pack_length() const { return sizeof(double); }
+  uint row_pack_length() { return pack_length(); }
+  void sql_type(String &str) const;
+private:
+  int do_save_field_metadata(uchar *first_byte);
+};
+
+#endif
+

=== added file 'server/field/int64_t.cc'
--- server/field/int64_t.cc	1970-01-01 00:00:00 +0000
+++ server/field/int64_t.cc	2008-07-18 10:19:35 +0000
@@ -0,0 +1,309 @@
+/* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 MySQL
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifdef USE_PRAGMA_IMPLEMENTATION
+#pragma implementation				// gcc: Class implementation
+#endif
+
+#include "int64_t.h"
+
+/****************************************************************************
+ Field type int64_t int (8 bytes)
+****************************************************************************/
+
+int Field_int64_t::store(const char *from,uint len,CHARSET_INFO *cs)
+{
+  int error= 0;
+  char *end;
+  uint64_t tmp;
+
+  tmp= cs->cset->strntoull10rnd(cs,from,len,unsigned_flag,&end,&error);
+  if (error == MY_ERRNO_ERANGE)
+  {
+    set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
+    error= 1;
+  }
+  else if (table->in_use->count_cuted_fields && 
+           check_int(cs, from, len, end, error))
+    error= 1;
+  else
+    error= 0;
+#ifdef WORDS_BIGENDIAN
+  if (table->s->db_low_byte_first)
+  {
+    int8store(ptr,tmp);
+  }
+  else
+#endif
+    int64_tstore(ptr,tmp);
+  return error;
+}
+
+
+int Field_int64_t::store(double nr)
+{
+  int error= 0;
+  int64_t res;
+
+  nr= rint(nr);
+  if (unsigned_flag)
+  {
+    if (nr < 0)
+    {
+      res=0;
+      error= 1;
+    }
+    else if (nr >= (double) UINT64_MAX)
+    {
+      res= ~(int64_t) 0;
+      error= 1;
+    }
+    else
+      res=(int64_t) (uint64_t) nr;
+  }
+  else
+  {
+    if (nr <= (double) INT64_MIN)
+    {
+      res= INT64_MIN;
+      error= (nr < (double) INT64_MIN);
+    }
+    else if (nr >= (double) (uint64_t) INT64_MAX)
+    {
+      res= INT64_MAX;
+      error= (nr > (double) INT64_MAX);
+    }
+    else
+      res=(int64_t) nr;
+  }
+  if (error)
+    set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
+
+#ifdef WORDS_BIGENDIAN
+  if (table->s->db_low_byte_first)
+  {
+    int8store(ptr,res);
+  }
+  else
+#endif
+    int64_tstore(ptr,res);
+  return error;
+}
+
+
+int Field_int64_t::store(int64_t nr, bool unsigned_val)
+{
+  int error= 0;
+
+  if (nr < 0)                                   // Only possible error
+  {
+    /*
+      if field is unsigned and value is signed (< 0) or
+      if field is signed and value is unsigned we have an overflow
+    */
+    if (unsigned_flag != unsigned_val)
+    {
+      nr= unsigned_flag ? (uint64_t) 0 : (uint64_t) INT64_MAX;
+      set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
+      error= 1;
+    }
+  }
+
+#ifdef WORDS_BIGENDIAN
+  if (table->s->db_low_byte_first)
+  {
+    int8store(ptr,nr);
+  }
+  else
+#endif
+    int64_tstore(ptr,nr);
+  return error;
+}
+
+
+double Field_int64_t::val_real(void)
+{
+  int64_t j;
+#ifdef WORDS_BIGENDIAN
+  if (table->s->db_low_byte_first)
+  {
+    j=sint8korr(ptr);
+  }
+  else
+#endif
+    int64_tget(j,ptr);
+  /* The following is open coded to avoid a bug in gcc 3.3 */
+  if (unsigned_flag)
+  {
+    uint64_t tmp= (uint64_t) j;
+    return uint64_t2double(tmp);
+  }
+  return (double) j;
+}
+
+
+int64_t Field_int64_t::val_int(void)
+{
+  int64_t j;
+#ifdef WORDS_BIGENDIAN
+  if (table->s->db_low_byte_first)
+    j=sint8korr(ptr);
+  else
+#endif
+    int64_tget(j,ptr);
+  return j;
+}
+
+
+String *Field_int64_t::val_str(String *val_buffer,
+				String *val_ptr __attribute__((unused)))
+{
+  CHARSET_INFO *cs= &my_charset_bin;
+  uint length;
+  uint mlength=max(field_length+1,22*cs->mbmaxlen);
+  val_buffer->alloc(mlength);
+  char *to=(char*) val_buffer->ptr();
+  int64_t j;
+#ifdef WORDS_BIGENDIAN
+  if (table->s->db_low_byte_first)
+    j=sint8korr(ptr);
+  else
+#endif
+    int64_tget(j,ptr);
+
+  length=(uint) (cs->cset->int64_t10_to_str)(cs,to,mlength,
+					unsigned_flag ? 10 : -10, j);
+  val_buffer->length(length);
+  if (zerofill)
+    prepend_zeros(val_buffer);
+  return val_buffer;
+}
+
+
+bool Field_int64_t::send_binary(Protocol *protocol)
+{
+  return protocol->store_int64_t(Field_int64_t::val_int(), unsigned_flag);
+}
+
+
+int Field_int64_t::cmp(const uchar *a_ptr, const uchar *b_ptr)
+{
+  int64_t a,b;
+#ifdef WORDS_BIGENDIAN
+  if (table->s->db_low_byte_first)
+  {
+    a=sint8korr(a_ptr);
+    b=sint8korr(b_ptr);
+  }
+  else
+#endif
+  {
+    int64_tget(a,a_ptr);
+    int64_tget(b,b_ptr);
+  }
+  if (unsigned_flag)
+    return ((uint64_t) a < (uint64_t) b) ? -1 :
+    ((uint64_t) a > (uint64_t) b) ? 1 : 0;
+  return (a < b) ? -1 : (a > b) ? 1 : 0;
+}
+
+void Field_int64_t::sort_string(uchar *to,uint length __attribute__((unused)))
+{
+#ifdef WORDS_BIGENDIAN
+  if (!table->s->db_low_byte_first)
+  {
+    if (unsigned_flag)
+      to[0] = ptr[0];
+    else
+      to[0] = (char) (ptr[0] ^ 128);		/* Revers signbit */
+    to[1]   = ptr[1];
+    to[2]   = ptr[2];
+    to[3]   = ptr[3];
+    to[4]   = ptr[4];
+    to[5]   = ptr[5];
+    to[6]   = ptr[6];
+    to[7]   = ptr[7];
+  }
+  else
+#endif
+  {
+    if (unsigned_flag)
+      to[0] = ptr[7];
+    else
+      to[0] = (char) (ptr[7] ^ 128);		/* Revers signbit */
+    to[1]   = ptr[6];
+    to[2]   = ptr[5];
+    to[3]   = ptr[4];
+    to[4]   = ptr[3];
+    to[5]   = ptr[2];
+    to[6]   = ptr[1];
+    to[7]   = ptr[0];
+  }
+}
+
+
+void Field_int64_t::sql_type(String &res) const
+{
+  CHARSET_INFO *cs=res.charset();
+  res.length(cs->cset->snprintf(cs,(char*) res.ptr(),res.alloced_length(),
+			  "bigint(%d)",(int) field_length));
+  add_zerofill_and_unsigned(res);
+}
+
+
+/*
+  Floating-point numbers
+ */
+
+uchar *
+Field_real::pack(uchar *to, const uchar *from,
+                 uint max_length, bool low_byte_first)
+{
+  assert(max_length >= pack_length());
+#ifdef WORDS_BIGENDIAN
+  if (low_byte_first != table->s->db_low_byte_first)
+  {
+    const uchar *dptr= from + pack_length();
+    while (dptr-- > from)
+      *to++ = *dptr;
+    return(to);
+  }
+  else
+#endif
+    return(Field::pack(to, from, max_length, low_byte_first));
+}
+
+const uchar *
+Field_real::unpack(uchar *to, const uchar *from,
+                   uint param_data, bool low_byte_first)
+{
+#ifdef WORDS_BIGENDIAN
+  if (low_byte_first != table->s->db_low_byte_first)
+  {
+    const uchar *dptr= from + pack_length();
+    while (dptr-- > from)
+      *to++ = *dptr;
+    return(from + pack_length());
+  }
+  else
+#endif
+    return(Field::unpack(to, from, param_data, low_byte_first));
+}
+

=== added file 'server/field/int64_t.h'
--- server/field/int64_t.h	1970-01-01 00:00:00 +0000
+++ server/field/int64_t.h	2008-07-18 10:19:35 +0000
@@ -0,0 +1,107 @@
+/* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 MySQL
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLE_SERVER_FIELD_INT_64_T
+#define DRIZZLE_SERVER_FIELD_INT_64_T
+
+#include "mysql_priv.h"
+
+class Field_int64_t :public Field_num {
+public:
+  Field_int64_t(uchar *ptr_arg, uint32 len_arg, uchar *null_ptr_arg,
+	      uchar null_bit_arg,
+	      enum utype unireg_check_arg, const char *field_name_arg,
+	      bool zero_arg, bool unsigned_arg)
+    :Field_num(ptr_arg, len_arg, null_ptr_arg, null_bit_arg,
+	       unireg_check_arg, field_name_arg,
+	       0, zero_arg,unsigned_arg)
+    {}
+  Field_int64_t(uint32 len_arg,bool maybe_null_arg,
+		 const char *field_name_arg,
+		  bool unsigned_arg)
+    :Field_num((uchar*) 0, len_arg, maybe_null_arg ? (uchar*) "": 0,0,
+	       NONE, field_name_arg,0,0,unsigned_arg)
+    {}
+  enum Item_result result_type () const { return INT_RESULT; }
+  enum_field_types type() const { return MYSQL_TYPE_LONGLONG;}
+  enum ha_base_keytype key_type() const
+    { return unsigned_flag ? HA_KEYTYPE_ULONGLONG : HA_KEYTYPE_LONGLONG; }
+  int store(const char *to,uint length,CHARSET_INFO *charset);
+  int store(double nr);
+  int store(int64_t nr, bool unsigned_val);
+  int reset(void)
+  {
+    ptr[0]=ptr[1]=ptr[2]=ptr[3]=ptr[4]=ptr[5]=ptr[6]=ptr[7]=0;
+    return 0;
+  }
+  double val_real(void);
+  int64_t val_int(void);
+  String *val_str(String*,String *);
+  bool send_binary(Protocol *protocol);
+  int cmp(const uchar *,const uchar *);
+  void sort_string(uchar *buff,uint length);
+  uint32 pack_length() const { return 8; }
+  void sql_type(String &str) const;
+  bool can_be_compared_as_int64_t() const { return true; }
+  uint32 max_display_length() { return 20; }
+  virtual uchar *pack(uchar* to, const uchar *from,
+                      uint max_length __attribute__((__unused__)),
+                      bool low_byte_first __attribute__((__unused__)))
+  {
+    int64_t val;
+#ifdef WORDS_BIGENDIAN
+    if (table->s->db_low_byte_first)
+      val = sint8korr(from);
+    else
+#endif
+      int64_tget(val, from);
+
+#ifdef WORDS_BIGENDIAN
+    if (low_byte_first)
+      int8store(to, val);
+    else
+#endif
+      int64_tstore(to, val);
+    return to + sizeof(val);
+  }
+
+  virtual const uchar *unpack(uchar* to, const uchar *from,
+                              uint param_data __attribute__((__unused__)),
+                              bool low_byte_first __attribute__((__unused__)))
+  {
+    int64_t val;
+#ifdef WORDS_BIGENDIAN
+    if (low_byte_first)
+      val = sint8korr(from);
+    else
+#endif
+      int64_tget(val, from);
+
+#ifdef WORDS_BIGENDIAN
+    if (table->s->db_low_byte_first)
+      int8store(to, val);
+    else
+#endif
+      int64_tstore(to, val);
+    return from + sizeof(val);
+  }
+};
+
+#endif

=== added file 'server/field/long.cc'
--- server/field/long.cc	1970-01-01 00:00:00 +0000
+++ server/field/long.cc	2008-07-18 10:19:35 +0000
@@ -0,0 +1,266 @@
+/* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 MySQL
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifdef USE_PRAGMA_IMPLEMENTATION
+#pragma implementation				// gcc: Class implementation
+#endif
+
+#include "long.h"
+
+/****************************************************************************
+** long int
+****************************************************************************/
+
+int Field_long::store(const char *from,uint len,CHARSET_INFO *cs)
+{
+  long store_tmp;
+  int error;
+  int64_t rnd;
+  
+  error= get_int(cs, from, len, &rnd, UINT32_MAX, INT32_MIN, INT32_MAX);
+  store_tmp= unsigned_flag ? (long) (uint64_t) rnd : (long) rnd;
+#ifdef WORDS_BIGENDIAN
+  if (table->s->db_low_byte_first)
+  {
+    int4store(ptr, store_tmp);
+  }
+  else
+#endif
+    longstore(ptr, store_tmp);
+  return error;
+}
+
+
+int Field_long::store(double nr)
+{
+  int error= 0;
+  int32 res;
+  nr=rint(nr);
+  if (unsigned_flag)
+  {
+    if (nr < 0)
+    {
+      res=0;
+      error= 1;
+    }
+    else if (nr > (double) UINT32_MAX)
+    {
+      res= INT32_MAX;
+      set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
+      error= 1;
+    }
+    else
+      res=(int32) (ulong) nr;
+  }
+  else
+  {
+    if (nr < (double) INT32_MIN)
+    {
+      res=(int32) INT32_MIN;
+      error= 1;
+    }
+    else if (nr > (double) INT32_MAX)
+    {
+      res=(int32) INT32_MAX;
+      error= 1;
+    }
+    else
+      res=(int32) (int64_t) nr;
+  }
+  if (error)
+    set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
+
+#ifdef WORDS_BIGENDIAN
+  if (table->s->db_low_byte_first)
+  {
+    int4store(ptr,res);
+  }
+  else
+#endif
+    longstore(ptr,res);
+  return error;
+}
+
+
+int Field_long::store(int64_t nr, bool unsigned_val)
+{
+  int error= 0;
+  int32 res;
+
+  if (unsigned_flag)
+  {
+    if (nr < 0 && !unsigned_val)
+    {
+      res=0;
+      error= 1;
+    }
+    else if ((uint64_t) nr >= (1LL << 32))
+    {
+      res=(int32) (uint32) ~0L;
+      error= 1;
+    }
+    else
+      res=(int32) (uint32) nr;
+  }
+  else
+  {
+    if (nr < 0 && unsigned_val)
+      nr= ((int64_t) INT32_MAX) + 1;           // Generate overflow
+    if (nr < (int64_t) INT32_MIN) 
+    {
+      res=(int32) INT32_MIN;
+      error= 1;
+    }
+    else if (nr > (int64_t) INT32_MAX)
+    {
+      res=(int32) INT32_MAX;
+      error= 1;
+    }
+    else
+      res=(int32) nr;
+  }
+  if (error)
+    set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
+
+#ifdef WORDS_BIGENDIAN
+  if (table->s->db_low_byte_first)
+  {
+    int4store(ptr,res);
+  }
+  else
+#endif
+    longstore(ptr,res);
+  return error;
+}
+
+
+double Field_long::val_real(void)
+{
+  int32 j;
+#ifdef WORDS_BIGENDIAN
+  if (table->s->db_low_byte_first)
+    j=sint4korr(ptr);
+  else
+#endif
+    longget(j,ptr);
+  return unsigned_flag ? (double) (uint32) j : (double) j;
+}
+
+int64_t Field_long::val_int(void)
+{
+  int32 j;
+  /* See the comment in Field_long::store(long long) */
+  assert(table->in_use == current_thd);
+#ifdef WORDS_BIGENDIAN
+  if (table->s->db_low_byte_first)
+    j=sint4korr(ptr);
+  else
+#endif
+    longget(j,ptr);
+  return unsigned_flag ? (int64_t) (uint32) j : (int64_t) j;
+}
+
+String *Field_long::val_str(String *val_buffer,
+			    String *val_ptr __attribute__((unused)))
+{
+  CHARSET_INFO *cs= &my_charset_bin;
+  uint length;
+  uint mlength=max(field_length+1,12*cs->mbmaxlen);
+  val_buffer->alloc(mlength);
+  char *to=(char*) val_buffer->ptr();
+  int32 j;
+#ifdef WORDS_BIGENDIAN
+  if (table->s->db_low_byte_first)
+    j=sint4korr(ptr);
+  else
+#endif
+    longget(j,ptr);
+
+  if (unsigned_flag)
+    length=cs->cset->long10_to_str(cs,to,mlength, 10,(long) (uint32)j);
+  else
+    length=cs->cset->long10_to_str(cs,to,mlength,-10,(long) j);
+  val_buffer->length(length);
+  if (zerofill)
+    prepend_zeros(val_buffer);
+  return val_buffer;
+}
+
+
+bool Field_long::send_binary(Protocol *protocol)
+{
+  return protocol->store_long(Field_long::val_int());
+}
+
+int Field_long::cmp(const uchar *a_ptr, const uchar *b_ptr)
+{
+  int32 a,b;
+#ifdef WORDS_BIGENDIAN
+  if (table->s->db_low_byte_first)
+  {
+    a=sint4korr(a_ptr);
+    b=sint4korr(b_ptr);
+  }
+  else
+#endif
+  {
+    longget(a,a_ptr);
+    longget(b,b_ptr);
+  }
+  if (unsigned_flag)
+    return ((uint32) a < (uint32) b) ? -1 : ((uint32) a > (uint32) b) ? 1 : 0;
+  return (a < b) ? -1 : (a > b) ? 1 : 0;
+}
+
+void Field_long::sort_string(uchar *to,uint length __attribute__((unused)))
+{
+#ifdef WORDS_BIGENDIAN
+  if (!table->s->db_low_byte_first)
+  {
+    if (unsigned_flag)
+      to[0] = ptr[0];
+    else
+      to[0] = (char) (ptr[0] ^ 128);		/* Revers signbit */
+    to[1]   = ptr[1];
+    to[2]   = ptr[2];
+    to[3]   = ptr[3];
+  }
+  else
+#endif
+  {
+    if (unsigned_flag)
+      to[0] = ptr[3];
+    else
+      to[0] = (char) (ptr[3] ^ 128);		/* Revers signbit */
+    to[1]   = ptr[2];
+    to[2]   = ptr[1];
+    to[3]   = ptr[0];
+  }
+}
+
+
+void Field_long::sql_type(String &res) const
+{
+  CHARSET_INFO *cs=res.charset();
+  res.length(cs->cset->snprintf(cs,(char*) res.ptr(),res.alloced_length(),
+			  "int(%d)",(int) field_length));
+  add_zerofill_and_unsigned(res);
+}
+

=== added file 'server/field/long.h'
--- server/field/long.h	1970-01-01 00:00:00 +0000
+++ server/field/long.h	2008-07-18 10:19:35 +0000
@@ -0,0 +1,102 @@
+/* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 MySQL
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLE_SERVER_FIELD_LONG
+#define DRIZZLE_SERVER_FIELD_LONG
+
+#include "mysql_priv.h"
+
+class Field_long :public Field_num {
+public:
+  Field_long(uchar *ptr_arg, uint32 len_arg, uchar *null_ptr_arg,
+	     uchar null_bit_arg,
+	     enum utype unireg_check_arg, const char *field_name_arg,
+	     bool zero_arg, bool unsigned_arg)
+    :Field_num(ptr_arg, len_arg, null_ptr_arg, null_bit_arg,
+	       unireg_check_arg, field_name_arg,
+	       0, zero_arg,unsigned_arg)
+    {}
+  Field_long(uint32 len_arg,bool maybe_null_arg, const char *field_name_arg,
+	     bool unsigned_arg)
+    :Field_num((uchar*) 0, len_arg, maybe_null_arg ? (uchar*) "": 0,0,
+	       NONE, field_name_arg,0,0,unsigned_arg)
+    {}
+  enum Item_result result_type () const { return INT_RESULT; }
+  enum_field_types type() const { return MYSQL_TYPE_LONG;}
+  enum ha_base_keytype key_type() const
+    { return unsigned_flag ? HA_KEYTYPE_ULONG_INT : HA_KEYTYPE_LONG_INT; }
+  int store(const char *to,uint length,CHARSET_INFO *charset);
+  int store(double nr);
+  int store(int64_t nr, bool unsigned_val);
+  int reset(void) { ptr[0]=ptr[1]=ptr[2]=ptr[3]=0; return 0; }
+  double val_real(void);
+  int64_t val_int(void);
+  bool send_binary(Protocol *protocol);
+  String *val_str(String*,String *);
+  int cmp(const uchar *,const uchar *);
+  void sort_string(uchar *buff,uint length);
+  uint32 pack_length() const { return 4; }
+  void sql_type(String &str) const;
+  uint32 max_display_length() { return MY_INT32_NUM_DECIMAL_DIGITS; }
+  virtual uchar *pack(uchar* to, const uchar *from,
+                      uint max_length __attribute__((__unused__)),
+                      bool low_byte_first __attribute__((__unused__)))
+  {
+    int32 val;
+#ifdef WORDS_BIGENDIAN
+    if (table->s->db_low_byte_first)
+      val = sint4korr(from);
+    else
+#endif
+      longget(val, from);
+
+#ifdef WORDS_BIGENDIAN
+    if (low_byte_first)
+      int4store(to, val);
+    else
+#endif
+      longstore(to, val);
+    return to + sizeof(val);
+  }
+
+  virtual const uchar *unpack(uchar* to, const uchar *from,
+                              uint param_data __attribute__((__unused__)),
+                              bool low_byte_first __attribute__((__unused__)))
+  {
+    int32 val;
+#ifdef WORDS_BIGENDIAN
+    if (low_byte_first)
+      val = sint4korr(from);
+    else
+#endif
+      longget(val, from);
+
+#ifdef WORDS_BIGENDIAN
+    if (table->s->db_low_byte_first)
+      int4store(to, val);
+    else
+#endif
+      longstore(to, val);
+    return from + sizeof(val);
+  }
+};
+
+#endif
+

=== added file 'server/field/null.cc'
--- server/field/null.cc	1970-01-01 00:00:00 +0000
+++ server/field/null.cc	2008-07-18 03:07:08 +0000
@@ -0,0 +1,37 @@
+/* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 MySQL
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifdef USE_PRAGMA_IMPLEMENTATION
+#pragma implementation				// gcc: Class implementation
+#endif
+
+#include "null.h"
+
+uchar Field_null::null[1]={1};
+
+/****************************************************************************
+  Field_null, a field that always return NULL
+****************************************************************************/
+
+void Field_null::sql_type(String &res) const
+{
+  res.set_ascii(STRING_WITH_LEN("null"));
+}
+

=== added file 'server/field/null.h'
--- server/field/null.h	1970-01-01 00:00:00 +0000
+++ server/field/null.h	2008-07-18 03:07:08 +0000
@@ -0,0 +1,72 @@
+/* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 MySQL
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLE_SERVER_FIELD_NULL
+#define DRIZZLE_SERVER_FIELD_NULL
+
+#include "mysql_priv.h"
+
+/* 
+  Everything saved in this will disappear. It will always return NULL 
+ */
+
+class Field_null :public Field_str {
+  static uchar null[1];
+public:
+  Field_null(uchar *ptr_arg, uint32 len_arg,
+	     enum utype unireg_check_arg, const char *field_name_arg,
+	     CHARSET_INFO *cs)
+    :Field_str(ptr_arg, len_arg, null, 1,
+	       unireg_check_arg, field_name_arg, cs)
+    {}
+  enum_field_types type() const { return MYSQL_TYPE_NULL;}
+  int  store(const char *to __attribute__((__unused__)),
+             uint length __attribute__((__unused__)),
+             CHARSET_INFO *cs __attribute__((__unused__)))
+  { null[0]=1; return 0; }
+  int store(double nr __attribute__((__unused__)))
+  { null[0]=1; return 0; }
+  int store(int64_t nr __attribute__((__unused__)),
+            bool unsigned_val __attribute__((__unused__)))
+  { null[0]=1; return 0; }
+  int store_decimal(const my_decimal *d __attribute__((__unused__)))
+  { null[0]=1; return 0; }
+  int reset(void)
+  { return 0; }
+  double val_real(void)
+  { return 0.0;}
+  int64_t val_int(void)
+  { return 0;}
+  my_decimal *val_decimal(my_decimal *) { return 0; }
+  String *val_str(String *value __attribute__((__unused__)),
+                  String *value2)
+  { value2->length(0); return value2;}
+  int cmp(const uchar *a __attribute__((__unused__)),
+          const uchar *b __attribute__((__unused__))) { return 0;}
+  void sort_string(uchar *buff __attribute__((__unused__)),
+                   uint length __attribute__((__unused__)))  {}
+  uint32 pack_length() const { return 0; }
+  void sql_type(String &str) const;
+  uint size_of() const { return sizeof(*this); }
+  uint32 max_display_length() { return 4; }
+};
+
+#endif
+

=== added file 'server/field/set.cc'
--- server/field/set.cc	1970-01-01 00:00:00 +0000
+++ server/field/set.cc	2008-07-22 05:25:22 +0000
@@ -0,0 +1,141 @@
+/* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 MySQL
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifdef USE_PRAGMA_IMPLEMENTATION
+#pragma implementation				// gcc: Class implementation
+#endif
+
+#include "set.h"
+
+/*
+   set type.
+   This is a string which can have a collection of different values.
+   Each string value is separated with a ','.
+   For example "One,two,five"
+   If one uses this string in a number context one gets the bits as a int64_t
+   number.
+*/
+
+const char field_separator=',';
+
+int Field_set::store(const char *from,uint length,CHARSET_INFO *cs)
+{
+  bool got_warning= 0;
+  int err= 0;
+  char *not_used;
+  uint not_used2;
+  uint32 not_used_offset;
+  char buff[STRING_BUFFER_USUAL_SIZE];
+  String tmpstr(buff,sizeof(buff), &my_charset_bin);
+
+  /* Convert character set if necessary */
+  if (String::needs_conversion(length, cs, field_charset, &not_used_offset))
+  { 
+    uint dummy_errors;
+    tmpstr.copy(from, length, cs, field_charset, &dummy_errors);
+    from= tmpstr.ptr();
+    length=  tmpstr.length();
+  }
+  uint64_t tmp= find_set(typelib, from, length, field_charset,
+                          &not_used, &not_used2, &got_warning);
+  if (!tmp && length && length < 22)
+  {
+    /* This is for reading numbers with LOAD DATA INFILE */
+    char *end;
+    tmp=my_strntoull(cs,from,length,10,&end,&err);
+    if (err || end != from+length ||
+	tmp > (uint64_t) (((int64_t) 1 << typelib->count) - (int64_t) 1))
+    {
+      tmp=0;      
+      set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, WARN_DATA_TRUNCATED, 1);
+    }
+  }
+  else if (got_warning)
+    set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, WARN_DATA_TRUNCATED, 1);
+  store_type(tmp);
+  return err;
+}
+
+
+int Field_set::store(int64_t nr,
+                     bool unsigned_val __attribute__((__unused__)))
+{
+  int error= 0;
+  uint64_t max_nr= set_bits(uint64_t, typelib->count);
+  if ((uint64_t) nr > max_nr)
+  {
+    nr&= max_nr;
+    set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, WARN_DATA_TRUNCATED, 1);
+    error=1;
+  }
+  store_type((uint64_t) nr);
+  return error;
+}
+
+
+String *Field_set::val_str(String *val_buffer,
+			   String *val_ptr __attribute__((unused)))
+{
+  uint64_t tmp=(uint64_t) Field_enum::val_int();
+  uint bitnr=0;
+
+  val_buffer->length(0);
+  val_buffer->set_charset(field_charset);
+  while (tmp && bitnr < (uint) typelib->count)
+  {
+    if (tmp & 1)
+    {
+      if (val_buffer->length())
+        val_buffer->append(&field_separator, 1, &my_charset_latin1);
+      String str(typelib->type_names[bitnr],
+		 typelib->type_lengths[bitnr],
+		 field_charset);
+      val_buffer->append(str);
+    }
+    tmp>>=1;
+    bitnr++;
+  }
+  return val_buffer;
+}
+
+
+void Field_set::sql_type(String &res) const
+{
+  char buffer[255];
+  String set_item(buffer, sizeof(buffer), res.charset());
+
+  res.length(0);
+  res.append(STRING_WITH_LEN("set("));
+
+  bool flag=0;
+  uint *len= typelib->type_lengths;
+  for (const char **pos= typelib->type_names; *pos; pos++, len++)
+  {
+    uint dummy_errors;
+    if (flag)
+      res.append(',');
+    /* convert to res.charset() == utf8, then quote */
+    set_item.copy(*pos, *len, charset(), res.charset(), &dummy_errors);
+    append_unescaped(&res, set_item.ptr(), set_item.length());
+    flag= 1;
+  }
+  res.append(')');
+}
+

=== added file 'server/field/set.h'
--- server/field/set.h	1970-01-01 00:00:00 +0000
+++ server/field/set.h	2008-07-22 05:25:22 +0000
@@ -0,0 +1,52 @@
+/* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 MySQL
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLE_SERVER_FIELD_SET
+#define DRIZZLE_SERVER_FIELD_SET
+
+#include "mysql_priv.h"
+
+class Field_set :public Field_enum {
+public:
+  Field_set(uchar *ptr_arg, uint32 len_arg, uchar *null_ptr_arg,
+	    uchar null_bit_arg,
+	    enum utype unireg_check_arg, const char *field_name_arg,
+	    uint32 packlength_arg,
+	    TYPELIB *typelib_arg, CHARSET_INFO *charset_arg)
+    :Field_enum(ptr_arg, len_arg, null_ptr_arg, null_bit_arg,
+		    unireg_check_arg, field_name_arg,
+                packlength_arg,
+                typelib_arg,charset_arg)
+    {
+      flags=(flags & ~ENUM_FLAG) | SET_FLAG;
+    }
+  int  store(const char *to,uint length,CHARSET_INFO *charset);
+  int  store(double nr) { return Field_set::store((int64_t) nr, false); }
+  int  store(int64_t nr, bool unsigned_val);
+
+  virtual bool zero_pack() const { return 1; }
+  String *val_str(String*,String *);
+  void sql_type(String &str) const;
+  enum_field_types real_type() const { return MYSQL_TYPE_SET; }
+  bool has_charset(void) const { return true; }
+};
+
+#endif
+

=== added file 'server/field/short.cc'
--- server/field/short.cc	1970-01-01 00:00:00 +0000
+++ server/field/short.cc	2008-07-18 10:19:35 +0000
@@ -0,0 +1,266 @@
+/* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 MySQL
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifdef USE_PRAGMA_IMPLEMENTATION
+#pragma implementation				// gcc: Class implementation
+#endif
+
+#include "short.h"
+
+/****************************************************************************
+ Field type short int (2 byte)
+****************************************************************************/
+
+int Field_short::store(const char *from,uint len,CHARSET_INFO *cs)
+{
+  int store_tmp;
+  int error;
+  int64_t rnd;
+  
+  error= get_int(cs, from, len, &rnd, UINT16_MAX, INT16_MIN, INT16_MAX);
+  store_tmp= unsigned_flag ? (int) (uint64_t) rnd : (int) rnd;
+#ifdef WORDS_BIGENDIAN
+  if (table->s->db_low_byte_first)
+  {
+    int2store(ptr, store_tmp);
+  }
+  else
+#endif
+    shortstore(ptr, (short) store_tmp);
+  return error;
+}
+
+
+int Field_short::store(double nr)
+{
+  int error= 0;
+  int16 res;
+  nr=rint(nr);
+  if (unsigned_flag)
+  {
+    if (nr < 0)
+    {
+      res=0;
+      set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
+      error= 1;
+    }
+    else if (nr > (double) UINT16_MAX)
+    {
+      res=(int16) UINT16_MAX;
+      set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
+      error= 1;
+    }
+    else
+      res=(int16) (uint16) nr;
+  }
+  else
+  {
+    if (nr < (double) INT16_MIN)
+    {
+      res=INT16_MIN;
+      set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
+      error= 1;
+    }
+    else if (nr > (double) INT16_MAX)
+    {
+      res=INT16_MAX;
+      set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
+      error= 1;
+    }
+    else
+      res=(int16) (int) nr;
+  }
+#ifdef WORDS_BIGENDIAN
+  if (table->s->db_low_byte_first)
+  {
+    int2store(ptr,res);
+  }
+  else
+#endif
+    shortstore(ptr,res);
+  return error;
+}
+
+
+int Field_short::store(int64_t nr, bool unsigned_val)
+{
+  int error= 0;
+  int16 res;
+
+  if (unsigned_flag)
+  {
+    if (nr < 0L && !unsigned_val)
+    {
+      res=0;
+      set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
+      error= 1;
+    }
+    else if ((uint64_t) nr > (uint64_t) UINT16_MAX)
+    {
+      res=(int16) UINT16_MAX;
+      set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
+      error= 1;
+    }
+    else
+      res=(int16) (uint16) nr;
+  }
+  else
+  {
+    if (nr < 0 && unsigned_val)
+      nr= UINT16_MAX+1;                         // Generate overflow
+
+    if (nr < INT16_MIN)
+    {
+      res=INT16_MIN;
+      set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
+      error= 1;
+    }
+    else if (nr > (int64_t) INT16_MAX)
+    {
+      res=INT16_MAX;
+      set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
+      error= 1;
+    }
+    else
+      res=(int16) nr;
+  }
+#ifdef WORDS_BIGENDIAN
+  if (table->s->db_low_byte_first)
+  {
+    int2store(ptr,res);
+  }
+  else
+#endif
+    shortstore(ptr,res);
+  return error;
+}
+
+
+double Field_short::val_real(void)
+{
+  short j;
+#ifdef WORDS_BIGENDIAN
+  if (table->s->db_low_byte_first)
+    j=sint2korr(ptr);
+  else
+#endif
+    shortget(j,ptr);
+  return unsigned_flag ? (double) (unsigned short) j : (double) j;
+}
+
+int64_t Field_short::val_int(void)
+{
+  short j;
+#ifdef WORDS_BIGENDIAN
+  if (table->s->db_low_byte_first)
+    j=sint2korr(ptr);
+  else
+#endif
+    shortget(j,ptr);
+  return unsigned_flag ? (int64_t) (unsigned short) j : (int64_t) j;
+}
+
+
+String *Field_short::val_str(String *val_buffer,
+			     String *val_ptr __attribute__((unused)))
+{
+  CHARSET_INFO *cs= &my_charset_bin;
+  uint length;
+  uint mlength=max(field_length+1,7*cs->mbmaxlen);
+  val_buffer->alloc(mlength);
+  char *to=(char*) val_buffer->ptr();
+  short j;
+#ifdef WORDS_BIGENDIAN
+  if (table->s->db_low_byte_first)
+    j=sint2korr(ptr);
+  else
+#endif
+    shortget(j,ptr);
+
+  if (unsigned_flag)
+    length=(uint) cs->cset->long10_to_str(cs, to, mlength, 10, 
+					  (long) (uint16) j);
+  else
+    length=(uint) cs->cset->long10_to_str(cs, to, mlength,-10, (long) j);
+  val_buffer->length(length);
+  if (zerofill)
+    prepend_zeros(val_buffer);
+  return val_buffer;
+}
+
+
+bool Field_short::send_binary(Protocol *protocol)
+{
+  return protocol->store_short(Field_short::val_int());
+}
+
+
+int Field_short::cmp(const uchar *a_ptr, const uchar *b_ptr)
+{
+  short a,b;
+#ifdef WORDS_BIGENDIAN
+  if (table->s->db_low_byte_first)
+  {
+    a=sint2korr(a_ptr);
+    b=sint2korr(b_ptr);
+  }
+  else
+#endif
+  {
+    shortget(a,a_ptr);
+    shortget(b,b_ptr);
+  }
+
+  if (unsigned_flag)
+    return ((unsigned short) a < (unsigned short) b) ? -1 :
+    ((unsigned short) a > (unsigned short) b) ? 1 : 0;
+  return (a < b) ? -1 : (a > b) ? 1 : 0;
+}
+
+void Field_short::sort_string(uchar *to,uint length __attribute__((unused)))
+{
+#ifdef WORDS_BIGENDIAN
+  if (!table->s->db_low_byte_first)
+  {
+    if (unsigned_flag)
+      to[0] = ptr[0];
+    else
+      to[0] = (char) (ptr[0] ^ 128);		/* Revers signbit */
+    to[1]   = ptr[1];
+  }
+  else
+#endif
+  {
+    if (unsigned_flag)
+      to[0] = ptr[1];
+    else
+      to[0] = (char) (ptr[1] ^ 128);		/* Revers signbit */
+    to[1]   = ptr[0];
+  }
+}
+
+void Field_short::sql_type(String &res) const
+{
+  CHARSET_INFO *cs=res.charset();
+  res.length(cs->cset->snprintf(cs,(char*) res.ptr(),res.alloced_length(),
+			  "smallint(%d)",(int) field_length));
+  add_zerofill_and_unsigned(res);
+}
+

=== added file 'server/field/short.h'
--- server/field/short.h	1970-01-01 00:00:00 +0000
+++ server/field/short.h	2008-07-18 10:19:35 +0000
@@ -0,0 +1,102 @@
+/* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 MySQL
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLE_SERVER_FIELD_SHORT
+#define DRIZZLE_SERVER_FIELD_SHORT
+
+#include "mysql_priv.h"
+
+class Field_short :public Field_num {
+public:
+  Field_short(uchar *ptr_arg, uint32 len_arg, uchar *null_ptr_arg,
+	      uchar null_bit_arg,
+	      enum utype unireg_check_arg, const char *field_name_arg,
+	      bool zero_arg, bool unsigned_arg)
+    :Field_num(ptr_arg, len_arg, null_ptr_arg, null_bit_arg,
+	       unireg_check_arg, field_name_arg,
+	       0, zero_arg,unsigned_arg)
+    {}
+  Field_short(uint32 len_arg,bool maybe_null_arg, const char *field_name_arg,
+	      bool unsigned_arg)
+    :Field_num((uchar*) 0, len_arg, maybe_null_arg ? (uchar*) "": 0,0,
+	       NONE, field_name_arg, 0, 0, unsigned_arg)
+    {}
+  enum Item_result result_type () const { return INT_RESULT; }
+  enum_field_types type() const { return MYSQL_TYPE_SHORT;}
+  enum ha_base_keytype key_type() const
+    { return unsigned_flag ? HA_KEYTYPE_USHORT_INT : HA_KEYTYPE_SHORT_INT;}
+  int store(const char *to,uint length,CHARSET_INFO *charset);
+  int store(double nr);
+  int store(int64_t nr, bool unsigned_val);
+  int reset(void) { ptr[0]=ptr[1]=0; return 0; }
+  double val_real(void);
+  int64_t val_int(void);
+  String *val_str(String*,String *);
+  bool send_binary(Protocol *protocol);
+  int cmp(const uchar *,const uchar *);
+  void sort_string(uchar *buff,uint length);
+  uint32 pack_length() const { return 2; }
+  void sql_type(String &str) const;
+  uint32 max_display_length() { return 6; }
+
+  virtual uchar *pack(uchar* to, const uchar *from,
+                      uint max_length __attribute__((__unused__)),
+                      bool low_byte_first __attribute__((__unused__)))
+  {
+    int16 val;
+#ifdef WORDS_BIGENDIAN
+    if (table->s->db_low_byte_first)
+      val = sint2korr(from);
+    else
+#endif
+      shortget(val, from);
+
+#ifdef WORDS_BIGENDIAN
+    if (low_byte_first)
+      int2store(to, val);
+    else
+#endif
+      shortstore(to, val);
+    return to + sizeof(val);
+  }
+
+  virtual const uchar *unpack(uchar* to, const uchar *from,
+                              uint param_data __attribute__((__unused__)),
+                              bool low_byte_first __attribute__((__unused__)))
+  {
+    int16 val;
+#ifdef WORDS_BIGENDIAN
+    if (low_byte_first)
+      val = sint2korr(from);
+    else
+#endif
+      shortget(val, from);
+
+#ifdef WORDS_BIGENDIAN
+    if (table->s->db_low_byte_first)
+      int2store(to, val);
+    else
+#endif
+      shortstore(to, val);
+    return from + sizeof(val);
+  }
+};
+
+#endif

=== added file 'server/field/string.cc'
--- server/field/string.cc	1970-01-01 00:00:00 +0000
+++ server/field/string.cc	2008-07-18 10:19:35 +0000
@@ -0,0 +1,437 @@
+/* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 MySQL
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifdef USE_PRAGMA_IMPLEMENTATION
+#pragma implementation				// gcc: Class implementation
+#endif
+
+#include "string.h"
+
+#define LONGLONG_TO_STRING_CONVERSION_BUFFER_SIZE 128
+#define DECIMAL_TO_STRING_CONVERSION_BUFFER_SIZE 128
+
+/****************************************************************************
+** string type
+** A string may be varchar or binary
+****************************************************************************/
+
+/* Copy a string and fill with space */
+int Field_string::store(const char *from,uint length,CHARSET_INFO *cs)
+{
+  uint copy_length;
+  const char *well_formed_error_pos;
+  const char *cannot_convert_error_pos;
+  const char *from_end_pos;
+
+  /* See the comment for Field_long::store(long long) */
+  assert(table->in_use == current_thd);
+
+  copy_length= well_formed_copy_nchars(field_charset,
+                                       (char*) ptr, field_length,
+                                       cs, from, length,
+                                       field_length / field_charset->mbmaxlen,
+                                       &well_formed_error_pos,
+                                       &cannot_convert_error_pos,
+                                       &from_end_pos);
+
+  /* Append spaces if the string was shorter than the field. */
+  if (copy_length < field_length)
+    field_charset->cset->fill(field_charset,(char*) ptr+copy_length,
+                              field_length-copy_length,
+                              field_charset->pad_char);
+
+  if (check_string_copy_error(this, well_formed_error_pos,
+                              cannot_convert_error_pos, from + length, cs))
+    return 2;
+
+  return report_if_important_data(from_end_pos, from + length);
+}
+
+
+int Field_string::store(int64_t nr, bool unsigned_val)
+{
+  char buff[64];
+  int  l;
+  CHARSET_INFO *cs=charset();
+  l= (cs->cset->int64_t10_to_str)(cs,buff,sizeof(buff),
+                                   unsigned_val ? 10 : -10, nr);
+  return Field_string::store(buff,(uint)l,cs);
+}
+
+
+double Field_string::val_real(void)
+{
+  int error;
+  char *end;
+  CHARSET_INFO *cs= charset();
+  double result;
+  
+  result=  my_strntod(cs,(char*) ptr,field_length,&end,&error);
+  if (!table->in_use->no_errors &&
+      (error || (field_length != (uint32)(end - (char*) ptr) && 
+                 !check_if_only_end_space(cs, end,
+                                          (char*) ptr + field_length))))
+  {
+    char buf[DOUBLE_TO_STRING_CONVERSION_BUFFER_SIZE];
+    String tmp(buf, sizeof(buf), cs);
+    tmp.copy((char*) ptr, field_length, cs);
+    push_warning_printf(current_thd, MYSQL_ERROR::WARN_LEVEL_WARN,
+                        ER_TRUNCATED_WRONG_VALUE, 
+                        ER(ER_TRUNCATED_WRONG_VALUE),
+                        "DOUBLE", tmp.c_ptr());
+  }
+  return result;
+}
+
+
+int64_t Field_string::val_int(void)
+{
+  int error;
+  char *end;
+  CHARSET_INFO *cs= charset();
+  int64_t result;
+
+  result= my_strntoll(cs, (char*) ptr,field_length,10,&end,&error);
+  if (!table->in_use->no_errors &&
+      (error || (field_length != (uint32)(end - (char*) ptr) && 
+                 !check_if_only_end_space(cs, end,
+                                          (char*) ptr + field_length))))
+  {
+    char buf[LONGLONG_TO_STRING_CONVERSION_BUFFER_SIZE];
+    String tmp(buf, sizeof(buf), cs);
+    tmp.copy((char*) ptr, field_length, cs);
+    push_warning_printf(current_thd, MYSQL_ERROR::WARN_LEVEL_WARN,
+                        ER_TRUNCATED_WRONG_VALUE, 
+                        ER(ER_TRUNCATED_WRONG_VALUE),
+                        "INTEGER", tmp.c_ptr());
+  }
+  return result;
+}
+
+
+String *Field_string::val_str(String *val_buffer __attribute__((unused)),
+			      String *val_ptr)
+{
+  /* See the comment for Field_long::store(long long) */
+  assert(table->in_use == current_thd);
+  uint length;
+  if (table->in_use->variables.sql_mode &
+      MODE_PAD_CHAR_TO_FULL_LENGTH)
+    length= my_charpos(field_charset, ptr, ptr + field_length, field_length);
+  else
+    length= field_charset->cset->lengthsp(field_charset, (const char*) ptr,
+                                          field_length);
+  val_ptr->set((const char*) ptr, length, field_charset);
+  return val_ptr;
+}
+
+
+my_decimal *Field_string::val_decimal(my_decimal *decimal_value)
+{
+  int err= str2my_decimal(E_DEC_FATAL_ERROR, (char*) ptr, field_length,
+                          charset(), decimal_value);
+  if (!table->in_use->no_errors && err)
+  {
+    char buf[DECIMAL_TO_STRING_CONVERSION_BUFFER_SIZE];
+    CHARSET_INFO *cs= charset();
+    String tmp(buf, sizeof(buf), cs);
+    tmp.copy((char*) ptr, field_length, cs);
+    push_warning_printf(current_thd, MYSQL_ERROR::WARN_LEVEL_WARN,
+                        ER_TRUNCATED_WRONG_VALUE, 
+                        ER(ER_TRUNCATED_WRONG_VALUE),
+                        "DECIMAL", tmp.c_ptr());
+  }
+
+  return decimal_value;
+}
+
+
+int Field_string::cmp(const uchar *a_ptr, const uchar *b_ptr)
+{
+  uint a_len, b_len;
+
+  if (field_charset->mbmaxlen != 1)
+  {
+    uint char_len= field_length/field_charset->mbmaxlen;
+    a_len= my_charpos(field_charset, a_ptr, a_ptr + field_length, char_len);
+    b_len= my_charpos(field_charset, b_ptr, b_ptr + field_length, char_len);
+  }
+  else
+    a_len= b_len= field_length;
+  /*
+    We have to remove end space to be able to compare multi-byte-characters
+    like in latin_de 'ae' and 0xe4
+  */
+  return field_charset->coll->strnncollsp(field_charset,
+                                          a_ptr, a_len,
+                                          b_ptr, b_len,
+                                          0);
+}
+
+
+void Field_string::sort_string(uchar *to,uint length)
+{
+  uint tmp= my_strnxfrm(field_charset,
+                                 to, length,
+                                 ptr, field_length);
+  assert(tmp == length);
+}
+
+
+void Field_string::sql_type(String &res) const
+{
+  THD *thd= table->in_use;
+  CHARSET_INFO *cs=res.charset();
+  ulong length;
+
+  length= cs->cset->snprintf(cs,(char*) res.ptr(),
+                             res.alloced_length(), "%s(%d)",
+                             ((type() == MYSQL_TYPE_VAR_STRING &&
+                               !thd->variables.new_mode) ?
+                              (has_charset() ? "varchar" : "varbinary") :
+			      (has_charset() ? "char" : "binary")),
+                             (int) field_length / charset()->mbmaxlen);
+  res.length(length);
+  if ((thd->variables.sql_mode & (MODE_MYSQL323 | MODE_MYSQL40)) &&
+      has_charset() && (charset()->state & MY_CS_BINSORT))
+    res.append(STRING_WITH_LEN(" binary"));
+}
+
+
+uchar *Field_string::pack(uchar *to, const uchar *from,
+                          uint max_length,
+                          bool low_byte_first __attribute__((unused)))
+{
+  uint length=      min(field_length,max_length);
+  uint local_char_length= max_length/field_charset->mbmaxlen;
+  if (length > local_char_length)
+    local_char_length= my_charpos(field_charset, from, from+length,
+                                  local_char_length);
+  set_if_smaller(length, local_char_length);
+  while (length && from[length-1] == field_charset->pad_char)
+    length--;
+
+  // Length always stored little-endian
+  *to++= (uchar) length;
+  if (field_length > 255)
+    *to++= (uchar) (length >> 8);
+
+  // Store the actual bytes of the string
+  memcpy(to, from, length);
+  return to+length;
+}
+
+
+/**
+   Unpack a string field from row data.
+
+   This method is used to unpack a string field from a master whose size 
+   of the field is less than that of the slave. Note that there can be a
+   variety of field types represented with this class. Certain types like
+   ENUM or SET are processed differently. Hence, the upper byte of the 
+   @c param_data argument contains the result of field->real_type() from
+   the master.
+
+   @param   to         Destination of the data
+   @param   from       Source of the data
+   @param   param_data Real type (upper) and length (lower) values
+
+   @return  New pointer into memory based on from + length of the data
+*/
+const uchar *
+Field_string::unpack(uchar *to,
+                     const uchar *from,
+                     uint param_data,
+                     bool low_byte_first __attribute__((unused)))
+{
+  uint from_length=
+    param_data ? min(param_data & 0x00ff, field_length) : field_length;
+  uint length;
+
+  if (from_length > 255)
+  {
+    length= uint2korr(from);
+    from+= 2;
+  }
+  else
+    length= (uint) *from++;
+
+  memcpy(to, from, length);
+  // Pad the string with the pad character of the fields charset
+  bfill(to + length, field_length - length, field_charset->pad_char);
+  return from+length;
+}
+
+
+/**
+   Save the field metadata for string fields.
+
+   Saves the real type in the first byte and the field length in the 
+   second byte of the field metadata array at index of *metadata_ptr and
+   *(metadata_ptr + 1).
+
+   @param   metadata_ptr   First byte of field metadata
+
+   @returns number of bytes written to metadata_ptr
+*/
+int Field_string::do_save_field_metadata(uchar *metadata_ptr)
+{
+  *metadata_ptr= real_type();
+  *(metadata_ptr + 1)= field_length;
+  return 2;
+}
+
+
+/*
+  Compare two packed keys
+
+  SYNOPSIS
+    pack_cmp()
+     a			New key
+     b			Original key
+     length		Key length
+     insert_or_update	1 if this is an insert or update
+
+  RETURN
+    < 0	  a < b
+    0	  a = b
+    > 0   a > b
+*/
+
+int Field_string::pack_cmp(const uchar *a, const uchar *b, uint length,
+                           my_bool insert_or_update)
+{
+  uint a_length, b_length;
+  if (length > 255)
+  {
+    a_length= uint2korr(a);
+    b_length= uint2korr(b);
+    a+= 2;
+    b+= 2;
+  }
+  else
+  {
+    a_length= (uint) *a++;
+    b_length= (uint) *b++;
+  }
+  return field_charset->coll->strnncollsp(field_charset,
+                                          a, a_length,
+                                          b, b_length,
+                                          insert_or_update);
+}
+
+
+/**
+  Compare a packed key against row.
+
+  @param key		        Original key
+  @param length		Key length. (May be less than field length)
+  @param insert_or_update	1 if this is an insert or update
+
+  @return
+    < 0	  row < key
+  @return
+    0	  row = key
+  @return
+    > 0   row > key
+*/
+
+int Field_string::pack_cmp(const uchar *key, uint length,
+                           my_bool insert_or_update)
+{
+  uint row_length, local_key_length;
+  uchar *end;
+  if (length > 255)
+  {
+    local_key_length= uint2korr(key);
+    key+= 2;
+  }
+  else
+    local_key_length= (uint) *key++;
+  
+  /* Only use 'length' of key, not field_length */
+  end= ptr + length;
+  while (end > ptr && end[-1] == ' ')
+    end--;
+  row_length= (uint) (end - ptr);
+
+  return field_charset->coll->strnncollsp(field_charset,
+                                          ptr, row_length,
+                                          key, local_key_length,
+                                          insert_or_update);
+}
+
+
+uint Field_string::packed_col_length(const uchar *data_ptr, uint length)
+{
+  if (length > 255)
+    return uint2korr(data_ptr)+2;
+  return (uint) *data_ptr + 1;
+}
+
+
+uint Field_string::max_packed_col_length(uint max_length)
+{
+  return (max_length > 255 ? 2 : 1)+max_length;
+}
+
+
+uint Field_string::get_key_image(uchar *buff,
+                                 uint length,
+                                 imagetype type_arg __attribute__((__unused__)))
+{
+  uint bytes = my_charpos(field_charset, (char*) ptr,
+                          (char*) ptr + field_length,
+                          length / field_charset->mbmaxlen);
+  memcpy(buff, ptr, bytes);
+  if (bytes < length)
+    field_charset->cset->fill(field_charset, (char*) buff + bytes,
+                              length - bytes, field_charset->pad_char);
+  return bytes;
+}
+
+
+Field *Field_string::new_field(MEM_ROOT *root, struct st_table *new_table,
+                               bool keep_type)
+{
+  Field *field;
+  if (type() != MYSQL_TYPE_VAR_STRING || keep_type)
+    field= Field::new_field(root, new_table, keep_type);
+  else if ((field= new Field_varstring(field_length, maybe_null(), field_name,
+                                       new_table->s, charset())))
+  {
+    /*
+      Old VARCHAR field which should be modified to a VARCHAR on copy
+      This is done to ensure that ALTER TABLE will convert old VARCHAR fields
+      to now VARCHAR fields.
+    */
+    field->init(new_table);
+    /*
+      Normally orig_table is different from table only if field was created
+      via ::new_field.  Here we alter the type of field, so ::new_field is
+      not applicable. But we still need to preserve the original field
+      metadata for the client-server protocol.
+    */
+    field->orig_table= orig_table;
+  }
+  return field;
+}
+
+

=== added file 'server/field/string.h'
--- server/field/string.h	1970-01-01 00:00:00 +0000
+++ server/field/string.h	2008-07-18 07:38:40 +0000
@@ -0,0 +1,87 @@
+/* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 MySQL
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLE_SERVER_FIELD_STRING
+#define DRIZZLE_SERVER_FIELD_STRING
+
+#include "mysql_priv.h"
+
+class Field_string :public Field_longstr {
+public:
+  bool can_alter_field_type;
+  Field_string(uchar *ptr_arg, uint32 len_arg,uchar *null_ptr_arg,
+	       uchar null_bit_arg,
+	       enum utype unireg_check_arg, const char *field_name_arg,
+	       CHARSET_INFO *cs)
+    :Field_longstr(ptr_arg, len_arg, null_ptr_arg, null_bit_arg,
+                   unireg_check_arg, field_name_arg, cs),
+     can_alter_field_type(1) {};
+  Field_string(uint32 len_arg,bool maybe_null_arg, const char *field_name_arg,
+               CHARSET_INFO *cs)
+    :Field_longstr((uchar*) 0, len_arg, maybe_null_arg ? (uchar*) "": 0, 0,
+                   NONE, field_name_arg, cs),
+     can_alter_field_type(1) {};
+
+  enum_field_types type() const
+  {
+    return  MYSQL_TYPE_STRING;
+  }
+  enum ha_base_keytype key_type() const
+    { return binary() ? HA_KEYTYPE_BINARY : HA_KEYTYPE_TEXT; }
+  bool zero_pack() const { return 0; }
+  int reset(void)
+  {
+    charset()->cset->fill(charset(),(char*) ptr, field_length,
+                          (has_charset() ? ' ' : 0));
+    return 0;
+  }
+  int store(const char *to,uint length,CHARSET_INFO *charset);
+  int store(int64_t nr, bool unsigned_val);
+  int store(double nr) { return Field_str::store(nr); } /* QQ: To be deleted */
+  double val_real(void);
+  int64_t val_int(void);
+  String *val_str(String*,String *);
+  my_decimal *val_decimal(my_decimal *);
+  int cmp(const uchar *,const uchar *);
+  void sort_string(uchar *buff,uint length);
+  void sql_type(String &str) const;
+  virtual uchar *pack(uchar *to, const uchar *from,
+                      uint max_length, bool low_byte_first);
+  virtual const uchar *unpack(uchar* to, const uchar *from,
+                              uint param_data, bool low_byte_first);
+  uint pack_length_from_metadata(uint field_metadata)
+  { return (field_metadata & 0x00ff); }
+  uint row_pack_length() { return (field_length + 1); }
+  int pack_cmp(const uchar *a,const uchar *b,uint key_length,
+               my_bool insert_or_update);
+  int pack_cmp(const uchar *b,uint key_length,my_bool insert_or_update);
+  uint packed_col_length(const uchar *to, uint length);
+  uint max_packed_col_length(uint max_length);
+  uint size_of() const { return sizeof(*this); }
+  enum_field_types real_type() const { return MYSQL_TYPE_STRING; }
+  bool has_charset(void) const
+  { return charset() == &my_charset_bin ? false : true; }
+  Field *new_field(MEM_ROOT *root, struct st_table *new_table, bool keep_type);
+  virtual uint get_key_image(uchar *buff,uint length, imagetype type);
+private:
+  int do_save_field_metadata(uchar *first_byte);
+};
+
+#endif

=== added file 'server/field/timestamp.cc'
--- server/field/timestamp.cc	1970-01-01 00:00:00 +0000
+++ server/field/timestamp.cc	2008-07-18 06:35:18 +0000
@@ -0,0 +1,440 @@
+/* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 MySQL
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifdef USE_PRAGMA_IMPLEMENTATION
+#pragma implementation				// gcc: Class implementation
+#endif
+
+#include "timestamp.h"
+
+/**
+  TIMESTAMP type holds datetime values in range from 1970-01-01 00:00:01 UTC to 
+  2038-01-01 00:00:00 UTC stored as number of seconds since Unix 
+  Epoch in UTC.
+  
+  Up to one of timestamps columns in the table can be automatically 
+  set on row update and/or have NOW() as default value.
+  TABLE::timestamp_field points to Field object for such timestamp with 
+  auto-set-on-update. TABLE::time_stamp holds offset in record + 1 for this
+  field, and is used by handler code which performs updates required.
+  
+  Actually SQL-99 says that we should allow niladic functions (like NOW())
+  as defaults for any field. Current limitations (only NOW() and only 
+  for one TIMESTAMP field) are because of restricted binary .frm format 
+  and should go away in the future.
+  
+  Also because of this limitation of binary .frm format we use 5 different
+  unireg_check values with TIMESTAMP field to distinguish various cases of
+  DEFAULT or ON UPDATE values. These values are:
+  
+  TIMESTAMP_OLD_FIELD - old timestamp, if there was not any fields with
+    auto-set-on-update (or now() as default) in this table before, then this 
+    field has NOW() as default and is updated when row changes, else it is 
+    field which has 0 as default value and is not automatically updated.
+  TIMESTAMP_DN_FIELD - field with NOW() as default but not set on update
+    automatically (TIMESTAMP DEFAULT NOW())
+  TIMESTAMP_UN_FIELD - field which is set on update automatically but has not 
+    NOW() as default (but it may has 0 or some other const timestamp as 
+    default) (TIMESTAMP ON UPDATE NOW()).
+  TIMESTAMP_DNUN_FIELD - field which has now() as default and is auto-set on 
+    update. (TIMESTAMP DEFAULT NOW() ON UPDATE NOW())
+  NONE - field which is not auto-set on update with some other than NOW() 
+    default value (TIMESTAMP DEFAULT 0).
+
+  Note that TIMESTAMP_OLD_FIELDs are never created explicitly now, they are 
+  left only for preserving ability to read old tables. Such fields replaced 
+  with their newer analogs in CREATE TABLE and in SHOW CREATE TABLE. This is 
+  because we want to prefer NONE unireg_check before TIMESTAMP_OLD_FIELD for 
+  "TIMESTAMP DEFAULT 'Const'" field. (Old timestamps allowed such 
+  specification too but ignored default value for first timestamp, which of 
+  course is non-standard.) In most cases user won't notice any change, only
+  exception is different behavior of old/new timestamps during ALTER TABLE.
+ */
+
+Field_timestamp::Field_timestamp(uchar *ptr_arg,
+                                 uint32 len_arg __attribute__((__unused__)),
+                                 uchar *null_ptr_arg, uchar null_bit_arg,
+                                 enum utype unireg_check_arg,
+                                 const char *field_name_arg,
+                                 TABLE_SHARE *share,
+                                 CHARSET_INFO *cs)
+  :Field_str(ptr_arg, MAX_DATETIME_WIDTH, null_ptr_arg, null_bit_arg,
+	     unireg_check_arg, field_name_arg, cs)
+{
+  /* For 4.0 MYD and 4.0 InnoDB compatibility */
+  flags|= ZEROFILL_FLAG | UNSIGNED_FLAG;
+  if (!share->timestamp_field && unireg_check != NONE)
+  {
+    /* This timestamp has auto-update */
+    share->timestamp_field= this;
+    flags|= TIMESTAMP_FLAG;
+    if (unireg_check != TIMESTAMP_DN_FIELD)
+      flags|= ON_UPDATE_NOW_FLAG;
+  }
+}
+
+
+Field_timestamp::Field_timestamp(bool maybe_null_arg,
+                                 const char *field_name_arg,
+                                 CHARSET_INFO *cs)
+  :Field_str((uchar*) 0, MAX_DATETIME_WIDTH,
+             maybe_null_arg ? (uchar*) "": 0, 0,
+	     NONE, field_name_arg, cs)
+{
+  /* For 4.0 MYD and 4.0 InnoDB compatibility */
+  flags|= ZEROFILL_FLAG | UNSIGNED_FLAG;
+    if (unireg_check != TIMESTAMP_DN_FIELD)
+      flags|= ON_UPDATE_NOW_FLAG;
+}
+
+
+/**
+  Get auto-set type for TIMESTAMP field.
+
+  Returns value indicating during which operations this TIMESTAMP field
+  should be auto-set to current timestamp.
+*/
+timestamp_auto_set_type Field_timestamp::get_auto_set_type() const
+{
+  switch (unireg_check)
+  {
+  case TIMESTAMP_DN_FIELD:
+    return TIMESTAMP_AUTO_SET_ON_INSERT;
+  case TIMESTAMP_UN_FIELD:
+    return TIMESTAMP_AUTO_SET_ON_UPDATE;
+  case TIMESTAMP_OLD_FIELD:
+    /*
+      Although we can have several such columns in legacy tables this
+      function should be called only for first of them (i.e. the one
+      having auto-set property).
+    */
+    assert(table->timestamp_field == this);
+    /* Fall-through */
+  case TIMESTAMP_DNUN_FIELD:
+    return TIMESTAMP_AUTO_SET_ON_BOTH;
+  default:
+    /*
+      Normally this function should not be called for TIMESTAMPs without
+      auto-set property.
+    */
+    assert(0);
+    return TIMESTAMP_NO_AUTO_SET;
+  }
+}
+
+
+int Field_timestamp::store(const char *from,
+                           uint len,
+                           CHARSET_INFO *cs __attribute__((__unused__)))
+{
+  MYSQL_TIME l_time;
+  my_time_t tmp= 0;
+  int error;
+  bool have_smth_to_conv;
+  bool in_dst_time_gap;
+  THD *thd= table ? table->in_use : current_thd;
+
+  /* We don't want to store invalid or fuzzy datetime values in TIMESTAMP */
+  have_smth_to_conv= (str_to_datetime(from, len, &l_time, 1, &error) >
+                      MYSQL_TIMESTAMP_ERROR);
+
+  if (error || !have_smth_to_conv)
+  {
+    error= 1;
+    set_datetime_warning(MYSQL_ERROR::WARN_LEVEL_WARN, WARN_DATA_TRUNCATED,
+                         from, len, MYSQL_TIMESTAMP_DATETIME, 1);
+  }
+
+  /* Only convert a correct date (not a zero date) */
+  if (have_smth_to_conv && l_time.month)
+  {
+    if (!(tmp= TIME_to_timestamp(thd, &l_time, &in_dst_time_gap)))
+    {
+      set_datetime_warning(MYSQL_ERROR::WARN_LEVEL_WARN,
+                           ER_WARN_DATA_OUT_OF_RANGE,
+                           from, len, MYSQL_TIMESTAMP_DATETIME, !error);
+      error= 1;
+    }
+    else if (in_dst_time_gap)
+    {
+      set_datetime_warning(MYSQL_ERROR::WARN_LEVEL_WARN,
+                           ER_WARN_INVALID_TIMESTAMP,
+                           from, len, MYSQL_TIMESTAMP_DATETIME, !error);
+      error= 1;
+    }
+  }
+  store_timestamp(tmp);
+  return error;
+}
+
+
+int Field_timestamp::store(double nr)
+{
+  int error= 0;
+  if (nr < 0 || nr > 99991231235959.0)
+  {
+    set_datetime_warning(MYSQL_ERROR::WARN_LEVEL_WARN,
+                         ER_WARN_DATA_OUT_OF_RANGE,
+                         nr, MYSQL_TIMESTAMP_DATETIME);
+    nr= 0;					// Avoid overflow on buff
+    error= 1;
+  }
+  error|= Field_timestamp::store((int64_t) rint(nr), false);
+  return error;
+}
+
+
+int Field_timestamp::store(int64_t nr,
+                           bool unsigned_val __attribute__((__unused__)))
+{
+  MYSQL_TIME l_time;
+  my_time_t timestamp= 0;
+  int error;
+  bool in_dst_time_gap;
+  THD *thd= table ? table->in_use : current_thd;
+
+  /* We don't want to store invalid or fuzzy datetime values in TIMESTAMP */
+  int64_t tmp= number_to_datetime(nr, &l_time, (thd->variables.sql_mode &
+                                                 MODE_NO_ZERO_DATE) |
+                                   MODE_NO_ZERO_IN_DATE, &error);
+  if (tmp == -1LL)
+  {
+    error= 2;
+  }
+
+  if (!error && tmp)
+  {
+    if (!(timestamp= TIME_to_timestamp(thd, &l_time, &in_dst_time_gap)))
+    {
+      set_datetime_warning(MYSQL_ERROR::WARN_LEVEL_WARN,
+                           ER_WARN_DATA_OUT_OF_RANGE,
+                           nr, MYSQL_TIMESTAMP_DATETIME, 1);
+      error= 1;
+    }
+    if (in_dst_time_gap)
+    {
+      set_datetime_warning(MYSQL_ERROR::WARN_LEVEL_WARN,
+                           ER_WARN_INVALID_TIMESTAMP,
+                           nr, MYSQL_TIMESTAMP_DATETIME, 1);
+      error= 1;
+    }
+  } else if (error)
+    set_datetime_warning(MYSQL_ERROR::WARN_LEVEL_WARN,
+                         WARN_DATA_TRUNCATED,
+                         nr, MYSQL_TIMESTAMP_DATETIME, 1);
+
+  store_timestamp(timestamp);
+  return error;
+}
+
+double Field_timestamp::val_real(void)
+{
+  return (double) Field_timestamp::val_int();
+}
+
+int64_t Field_timestamp::val_int(void)
+{
+  uint32 temp;
+  MYSQL_TIME time_tmp;
+  THD  *thd= table ? table->in_use : current_thd;
+
+  thd->time_zone_used= 1;
+#ifdef WORDS_BIGENDIAN
+  if (table && table->s->db_low_byte_first)
+    temp=uint4korr(ptr);
+  else
+#endif
+    longget(temp,ptr);
+
+  if (temp == 0L)				// No time
+    return(0);					/* purecov: inspected */
+  
+  thd->variables.time_zone->gmt_sec_to_TIME(&time_tmp, (my_time_t)temp);
+  
+  return time_tmp.year * 10000000000LL + time_tmp.month * 100000000LL +
+         time_tmp.day * 1000000L + time_tmp.hour * 10000L +
+         time_tmp.minute * 100 + time_tmp.second;
+}
+
+
+String *Field_timestamp::val_str(String *val_buffer, String *val_ptr)
+{
+  uint32 temp, temp2;
+  MYSQL_TIME time_tmp;
+  THD *thd= table ? table->in_use : current_thd;
+  char *to;
+
+  val_buffer->alloc(field_length+1);
+  to= (char*) val_buffer->ptr();
+  val_buffer->length(field_length);
+
+  thd->time_zone_used= 1;
+#ifdef WORDS_BIGENDIAN
+  if (table && table->s->db_low_byte_first)
+    temp=uint4korr(ptr);
+  else
+#endif
+    longget(temp,ptr);
+
+  if (temp == 0L)
+  {				      /* Zero time is "000000" */
+    val_ptr->set(STRING_WITH_LEN("0000-00-00 00:00:00"), &my_charset_bin);
+    return val_ptr;
+  }
+  val_buffer->set_charset(&my_charset_bin);	// Safety
+  
+  thd->variables.time_zone->gmt_sec_to_TIME(&time_tmp,(my_time_t)temp);
+
+  temp= time_tmp.year % 100;
+  if (temp < YY_PART_YEAR - 1)
+  {
+    *to++= '2';
+    *to++= '0';
+  }
+  else
+  {
+    *to++= '1';
+    *to++= '9';
+  }
+  temp2=temp/10; temp=temp-temp2*10;
+  *to++= (char) ('0'+(char) (temp2));
+  *to++= (char) ('0'+(char) (temp));
+  *to++= '-';
+  temp=time_tmp.month;
+  temp2=temp/10; temp=temp-temp2*10;
+  *to++= (char) ('0'+(char) (temp2));
+  *to++= (char) ('0'+(char) (temp));
+  *to++= '-';
+  temp=time_tmp.day;
+  temp2=temp/10; temp=temp-temp2*10;
+  *to++= (char) ('0'+(char) (temp2));
+  *to++= (char) ('0'+(char) (temp));
+  *to++= ' ';
+  temp=time_tmp.hour;
+  temp2=temp/10; temp=temp-temp2*10;
+  *to++= (char) ('0'+(char) (temp2));
+  *to++= (char) ('0'+(char) (temp));
+  *to++= ':';
+  temp=time_tmp.minute;
+  temp2=temp/10; temp=temp-temp2*10;
+  *to++= (char) ('0'+(char) (temp2));
+  *to++= (char) ('0'+(char) (temp));
+  *to++= ':';
+  temp=time_tmp.second;
+  temp2=temp/10; temp=temp-temp2*10;
+  *to++= (char) ('0'+(char) (temp2));
+  *to++= (char) ('0'+(char) (temp));
+  *to= 0;
+  return val_buffer;
+}
+
+
+bool Field_timestamp::get_date(MYSQL_TIME *ltime, uint fuzzydate)
+{
+  long temp;
+  THD *thd= table ? table->in_use : current_thd;
+  thd->time_zone_used= 1;
+#ifdef WORDS_BIGENDIAN
+  if (table && table->s->db_low_byte_first)
+    temp=uint4korr(ptr);
+  else
+#endif
+    longget(temp,ptr);
+  if (temp == 0L)
+  {				      /* Zero time is "000000" */
+    if (fuzzydate & TIME_NO_ZERO_DATE)
+      return 1;
+    bzero((char*) ltime,sizeof(*ltime));
+  }
+  else
+  {
+    thd->variables.time_zone->gmt_sec_to_TIME(ltime, (my_time_t)temp);
+  }
+  return 0;
+}
+
+bool Field_timestamp::get_time(MYSQL_TIME *ltime)
+{
+  return Field_timestamp::get_date(ltime,0);
+}
+
+
+bool Field_timestamp::send_binary(Protocol *protocol)
+{
+  MYSQL_TIME tm;
+  Field_timestamp::get_date(&tm, 0);
+  return protocol->store(&tm);
+}
+
+
+int Field_timestamp::cmp(const uchar *a_ptr, const uchar *b_ptr)
+{
+  int32 a,b;
+#ifdef WORDS_BIGENDIAN
+  if (table && table->s->db_low_byte_first)
+  {
+    a=sint4korr(a_ptr);
+    b=sint4korr(b_ptr);
+  }
+  else
+#endif
+  {
+  longget(a,a_ptr);
+  longget(b,b_ptr);
+  }
+  return ((uint32) a < (uint32) b) ? -1 : ((uint32) a > (uint32) b) ? 1 : 0;
+}
+
+
+void Field_timestamp::sort_string(uchar *to,uint length __attribute__((unused)))
+{
+#ifdef WORDS_BIGENDIAN
+  if (!table || !table->s->db_low_byte_first)
+  {
+    to[0] = ptr[0];
+    to[1] = ptr[1];
+    to[2] = ptr[2];
+    to[3] = ptr[3];
+  }
+  else
+#endif
+  {
+    to[0] = ptr[3];
+    to[1] = ptr[2];
+    to[2] = ptr[1];
+    to[3] = ptr[0];
+  }
+}
+
+
+void Field_timestamp::sql_type(String &res) const
+{
+  res.set_ascii(STRING_WITH_LEN("timestamp"));
+}
+
+
+void Field_timestamp::set_time()
+{
+  THD *thd= table ? table->in_use : current_thd;
+  long tmp= (long) thd->query_start();
+  set_notnull();
+  store_timestamp(tmp);
+}
+

=== added file 'server/field/timestamp.h'
--- server/field/timestamp.h	1970-01-01 00:00:00 +0000
+++ server/field/timestamp.h	2008-07-18 06:35:18 +0000
@@ -0,0 +1,90 @@
+/* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 MySQL
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLE_SERVER_FIELD_TIMESTAMP
+#define DRIZZLE_SERVER_FIELD_TIMESTAMP
+
+#include "mysql_priv.h"
+
+class Field_timestamp :public Field_str {
+public:
+  Field_timestamp(uchar *ptr_arg, uint32 len_arg,
+                  uchar *null_ptr_arg, uchar null_bit_arg,
+		  enum utype unireg_check_arg, const char *field_name_arg,
+		  TABLE_SHARE *share, CHARSET_INFO *cs);
+  Field_timestamp(bool maybe_null_arg, const char *field_name_arg,
+		  CHARSET_INFO *cs);
+  enum_field_types type() const { return MYSQL_TYPE_TIMESTAMP;}
+  enum ha_base_keytype key_type() const { return HA_KEYTYPE_ULONG_INT; }
+  enum Item_result cmp_type () const { return INT_RESULT; }
+  int  store(const char *to,uint length,CHARSET_INFO *charset);
+  int  store(double nr);
+  int  store(int64_t nr, bool unsigned_val);
+  int  reset(void) { ptr[0]=ptr[1]=ptr[2]=ptr[3]=0; return 0; }
+  double val_real(void);
+  int64_t val_int(void);
+  String *val_str(String*,String *);
+  bool send_binary(Protocol *protocol);
+  int cmp(const uchar *,const uchar *);
+  void sort_string(uchar *buff,uint length);
+  uint32 pack_length() const { return 4; }
+  void sql_type(String &str) const;
+  bool can_be_compared_as_int64_t() const { return true; }
+  bool zero_pack() const { return 0; }
+  void set_time();
+  virtual void set_default()
+  {
+    if (table->timestamp_field == this &&
+        unireg_check != TIMESTAMP_UN_FIELD)
+      set_time();
+    else
+      Field::set_default();
+  }
+  /* Get TIMESTAMP field value as seconds since begging of Unix Epoch */
+  inline long get_timestamp(my_bool *null_value)
+  {
+    if ((*null_value= is_null()))
+      return 0;
+#ifdef WORDS_BIGENDIAN
+    if (table && table->s->db_low_byte_first)
+      return sint4korr(ptr);
+#endif
+    long tmp;
+    longget(tmp,ptr);
+    return tmp;
+  }
+  inline void store_timestamp(my_time_t timestamp)
+  {
+#ifdef WORDS_BIGENDIAN
+    if (table && table->s->db_low_byte_first)
+    {
+      int4store(ptr,timestamp);
+    }
+    else
+#endif
+      longstore(ptr,(uint32) timestamp);
+  }
+  bool get_date(MYSQL_TIME *ltime,uint fuzzydate);
+  bool get_time(MYSQL_TIME *ltime);
+  timestamp_auto_set_type get_auto_set_type() const;
+};
+
+#endif
+

=== added file 'server/field/timetype.cc'
--- server/field/timetype.cc	1970-01-01 00:00:00 +0000
+++ server/field/timetype.cc	2008-07-18 07:06:52 +0000
@@ -0,0 +1,290 @@
+/* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 MySQL
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifdef USE_PRAGMA_IMPLEMENTATION
+#pragma implementation				// gcc: Class implementation
+#endif
+
+#include "timetype.h"
+
+/****************************************************************************
+** time type
+** In string context: HH:MM:SS
+** In number context: HHMMSS
+** Stored as a 3 byte unsigned int
+****************************************************************************/
+
+int Field_time::store(const char *from,
+                      uint len,
+                      CHARSET_INFO *cs __attribute__((__unused__)))
+{
+  MYSQL_TIME ltime;
+  long tmp;
+  int error= 0;
+  int warning;
+
+  if (str_to_time(from, len, &ltime, &warning))
+  {
+    tmp=0L;
+    error= 2;
+    set_datetime_warning(MYSQL_ERROR::WARN_LEVEL_WARN, WARN_DATA_TRUNCATED,
+                         from, len, MYSQL_TIMESTAMP_TIME, 1);
+  }
+  else
+  {
+    if (warning & MYSQL_TIME_WARN_TRUNCATED)
+    {
+      set_datetime_warning(MYSQL_ERROR::WARN_LEVEL_WARN,
+                           WARN_DATA_TRUNCATED,
+                           from, len, MYSQL_TIMESTAMP_TIME, 1);
+      error= 1;
+    }
+    if (warning & MYSQL_TIME_WARN_OUT_OF_RANGE)
+    {
+      set_datetime_warning(MYSQL_ERROR::WARN_LEVEL_WARN, 
+                           ER_WARN_DATA_OUT_OF_RANGE,
+                           from, len, MYSQL_TIMESTAMP_TIME, !error);
+      error= 1;
+    }
+    if (ltime.month)
+      ltime.day=0;
+    tmp=(ltime.day*24L+ltime.hour)*10000L+(ltime.minute*100+ltime.second);
+  }
+  
+  if (ltime.neg)
+    tmp= -tmp;
+  int3store(ptr,tmp);
+  return error;
+}
+
+
+int Field_time::store_time(MYSQL_TIME *ltime,
+                           timestamp_type time_type __attribute__((__unused__)))
+{
+  long tmp= ((ltime->month ? 0 : ltime->day * 24L) + ltime->hour) * 10000L +
+            (ltime->minute * 100 + ltime->second);
+  if (ltime->neg)
+    tmp= -tmp;
+  return Field_time::store((int64_t) tmp, false);
+}
+
+
+int Field_time::store(double nr)
+{
+  long tmp;
+  int error= 0;
+  if (nr > (double)TIME_MAX_VALUE)
+  {
+    tmp= TIME_MAX_VALUE;
+    set_datetime_warning(MYSQL_ERROR::WARN_LEVEL_WARN,
+                         ER_WARN_DATA_OUT_OF_RANGE, nr, MYSQL_TIMESTAMP_TIME);
+    error= 1;
+  }
+  else if (nr < (double)-TIME_MAX_VALUE)
+  {
+    tmp= -TIME_MAX_VALUE;
+    set_datetime_warning(MYSQL_ERROR::WARN_LEVEL_WARN, 
+                         ER_WARN_DATA_OUT_OF_RANGE, nr, MYSQL_TIMESTAMP_TIME);
+    error= 1;
+  }
+  else
+  {
+    tmp=(long) floor(fabs(nr));			// Remove fractions
+    if (nr < 0)
+      tmp= -tmp;
+    if (tmp % 100 > 59 || tmp/100 % 100 > 59)
+    {
+      tmp=0;
+      set_datetime_warning(MYSQL_ERROR::WARN_LEVEL_WARN, 
+                           ER_WARN_DATA_OUT_OF_RANGE, nr,
+                           MYSQL_TIMESTAMP_TIME);
+      error= 1;
+    }
+  }
+  int3store(ptr,tmp);
+  return error;
+}
+
+
+int Field_time::store(int64_t nr, bool unsigned_val)
+{
+  long tmp;
+  int error= 0;
+  if (nr < (int64_t) -TIME_MAX_VALUE && !unsigned_val)
+  {
+    tmp= -TIME_MAX_VALUE;
+    set_datetime_warning(MYSQL_ERROR::WARN_LEVEL_WARN, 
+                         ER_WARN_DATA_OUT_OF_RANGE, nr,
+                         MYSQL_TIMESTAMP_TIME, 1);
+    error= 1;
+  }
+  else if (nr > (int64_t) TIME_MAX_VALUE || (nr < 0 && unsigned_val))
+  {
+    tmp= TIME_MAX_VALUE;
+    set_datetime_warning(MYSQL_ERROR::WARN_LEVEL_WARN, 
+                         ER_WARN_DATA_OUT_OF_RANGE, nr,
+                         MYSQL_TIMESTAMP_TIME, 1);
+    error= 1;
+  }
+  else
+  {
+    tmp=(long) nr;
+    if (tmp % 100 > 59 || tmp/100 % 100 > 59)
+    {
+      tmp=0;
+      set_datetime_warning(MYSQL_ERROR::WARN_LEVEL_WARN, 
+                           ER_WARN_DATA_OUT_OF_RANGE, nr,
+                           MYSQL_TIMESTAMP_TIME, 1);
+      error= 1;
+    }
+  }
+  int3store(ptr,tmp);
+  return error;
+}
+
+
+double Field_time::val_real(void)
+{
+  uint32 j= (uint32) uint3korr(ptr);
+  return (double) j;
+}
+
+int64_t Field_time::val_int(void)
+{
+  return (int64_t) sint3korr(ptr);
+}
+
+
+/**
+  @note
+  This function is multi-byte safe as the result string is always of type
+  my_charset_bin
+*/
+
+String *Field_time::val_str(String *val_buffer,
+			    String *val_ptr __attribute__((unused)))
+{
+  MYSQL_TIME ltime;
+  val_buffer->alloc(MAX_DATE_STRING_REP_LENGTH);
+  long tmp=(long) sint3korr(ptr);
+  ltime.neg= 0;
+  if (tmp < 0)
+  {
+    tmp= -tmp;
+    ltime.neg= 1;
+  }
+  ltime.day= (uint) 0;
+  ltime.hour= (uint) (tmp/10000);
+  ltime.minute= (uint) (tmp/100 % 100);
+  ltime.second= (uint) (tmp % 100);
+  make_time((DATE_TIME_FORMAT*) 0, &ltime, val_buffer);
+  return val_buffer;
+}
+
+
+/**
+  @note
+  Normally we would not consider 'time' as a valid date, but we allow
+  get_date() here to be able to do things like
+  DATE_FORMAT(time, "%l.%i %p")
+*/
+ 
+bool Field_time::get_date(MYSQL_TIME *ltime, uint fuzzydate)
+{
+  long tmp;
+  THD *thd= table ? table->in_use : current_thd;
+  if (!(fuzzydate & TIME_FUZZY_DATE))
+  {
+    push_warning_printf(thd, MYSQL_ERROR::WARN_LEVEL_WARN,
+                        ER_WARN_DATA_OUT_OF_RANGE,
+                        ER(ER_WARN_DATA_OUT_OF_RANGE), field_name,
+                        thd->row_count);
+    return 1;
+  }
+  tmp=(long) sint3korr(ptr);
+  ltime->neg=0;
+  if (tmp < 0)
+  {
+    ltime->neg= 1;
+    tmp=-tmp;
+  }
+  ltime->hour=tmp/10000;
+  tmp-=ltime->hour*10000;
+  ltime->minute=   tmp/100;
+  ltime->second= tmp % 100;
+  ltime->year= ltime->month= ltime->day= ltime->second_part= 0;
+  return 0;
+}
+
+
+bool Field_time::get_time(MYSQL_TIME *ltime)
+{
+  long tmp=(long) sint3korr(ptr);
+  ltime->neg=0;
+  if (tmp < 0)
+  {
+    ltime->neg= 1;
+    tmp=-tmp;
+  }
+  ltime->day= 0;
+  ltime->hour=   (int) (tmp/10000);
+  tmp-=ltime->hour*10000;
+  ltime->minute= (int) tmp/100;
+  ltime->second= (int) tmp % 100;
+  ltime->second_part=0;
+  ltime->time_type= MYSQL_TIMESTAMP_TIME;
+  return 0;
+}
+
+
+bool Field_time::send_binary(Protocol *protocol)
+{
+  MYSQL_TIME tm;
+  Field_time::get_time(&tm);
+  tm.day= tm.hour/24;				// Move hours to days
+  tm.hour-= tm.day*24;
+  return protocol->store_time(&tm);
+}
+
+
+int Field_time::cmp(const uchar *a_ptr, const uchar *b_ptr)
+{
+  int32 a,b;
+  a=(int32) sint3korr(a_ptr);
+  b=(int32) sint3korr(b_ptr);
+  return (a < b) ? -1 : (a > b) ? 1 : 0;
+}
+
+void Field_time::sort_string(uchar *to,uint length __attribute__((unused)))
+{
+  to[0] = (uchar) (ptr[2] ^ 128);
+  to[1] = ptr[1];
+  to[2] = ptr[0];
+}
+
+void Field_time::sql_type(String &res) const
+{
+  res.set_ascii(STRING_WITH_LEN("time"));
+}
+
+
+
+
+

=== added file 'server/field/timetype.h'
--- server/field/timetype.h	1970-01-01 00:00:00 +0000
+++ server/field/timetype.h	2008-07-18 07:06:52 +0000
@@ -0,0 +1,61 @@
+/* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 MySQL
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLE_SERVER_FIELD_TIME
+#define DRIZZLE_SERVER_FIELD_TIME
+
+#include "mysql_priv.h"
+
+class Field_time :public Field_str {
+public:
+  Field_time(uchar *ptr_arg, uchar *null_ptr_arg, uchar null_bit_arg,
+	     enum utype unireg_check_arg, const char *field_name_arg,
+	     CHARSET_INFO *cs)
+    :Field_str(ptr_arg, 8, null_ptr_arg, null_bit_arg,
+	       unireg_check_arg, field_name_arg, cs)
+    {}
+  Field_time(bool maybe_null_arg, const char *field_name_arg,
+             CHARSET_INFO *cs)
+    :Field_str((uchar*) 0,8, maybe_null_arg ? (uchar*) "": 0,0,
+	       NONE, field_name_arg, cs) {}
+  enum_field_types type() const { return MYSQL_TYPE_TIME;}
+  enum ha_base_keytype key_type() const { return HA_KEYTYPE_INT24; }
+  enum Item_result cmp_type () const { return INT_RESULT; }
+  int store_time(MYSQL_TIME *ltime, timestamp_type type);
+  int store(const char *to,uint length,CHARSET_INFO *charset);
+  int store(double nr);
+  int store(int64_t nr, bool unsigned_val);
+  int reset(void) { ptr[0]=ptr[1]=ptr[2]=0; return 0; }
+  double val_real(void);
+  int64_t val_int(void);
+  String *val_str(String*,String *);
+  bool get_date(MYSQL_TIME *ltime, uint fuzzydate);
+  bool send_binary(Protocol *protocol);
+  bool get_time(MYSQL_TIME *ltime);
+  int cmp(const uchar *,const uchar *);
+  void sort_string(uchar *buff,uint length);
+  uint32 pack_length() const { return 3; }
+  void sql_type(String &str) const;
+  bool can_be_compared_as_int64_t() const { return true; }
+  bool zero_pack() const { return 1; }
+};
+
+#endif
+

=== added file 'server/field/varstring.cc'
--- server/field/varstring.cc	1970-01-01 00:00:00 +0000
+++ server/field/varstring.cc	2008-07-18 07:06:52 +0000
@@ -0,0 +1,609 @@
+/* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 MySQL
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifdef USE_PRAGMA_IMPLEMENTATION
+#pragma implementation				// gcc: Class implementation
+#endif
+
+#include "varstring.h"
+
+/****************************************************************************
+  VARCHAR type
+  Data in field->ptr is stored as:
+    1 or 2 bytes length-prefix-header  (from Field_varstring::length_bytes)
+    data
+
+  NOTE:
+  When VARCHAR is stored in a key (for handler::index_read() etc) it's always
+  stored with a 2 byte prefix. (Just like blob keys).
+
+  Normally length_bytes is calculated as (field_length < 256 : 1 ? 2)
+  The exception is if there is a prefix key field that is part of a long
+  VARCHAR, in which case field_length for this may be 1 but the length_bytes
+  is 2.
+****************************************************************************/
+
+const uint Field_varstring::MAX_SIZE= UINT16_MAX;
+
+/**
+   Save the field metadata for varstring fields.
+
+   Saves the field length in the first byte. Note: may consume
+   2 bytes. Caller must ensure second byte is contiguous with
+   first byte (e.g. array index 0,1).
+
+   @param   metadata_ptr   First byte of field metadata
+
+   @returns number of bytes written to metadata_ptr
+*/
+int Field_varstring::do_save_field_metadata(uchar *metadata_ptr)
+{
+  char *ptr= (char *)metadata_ptr;
+  assert(field_length <= 65535);
+  int2store(ptr, field_length);
+  return 2;
+}
+
+int Field_varstring::store(const char *from,uint length,CHARSET_INFO *cs)
+{
+  uint copy_length;
+  const char *well_formed_error_pos;
+  const char *cannot_convert_error_pos;
+  const char *from_end_pos;
+
+  copy_length= well_formed_copy_nchars(field_charset,
+                                       (char*) ptr + length_bytes,
+                                       field_length,
+                                       cs, from, length,
+                                       field_length / field_charset->mbmaxlen,
+                                       &well_formed_error_pos,
+                                       &cannot_convert_error_pos,
+                                       &from_end_pos);
+
+  if (length_bytes == 1)
+    *ptr= (uchar) copy_length;
+  else
+    int2store(ptr, copy_length);
+
+  if (check_string_copy_error(this, well_formed_error_pos,
+                              cannot_convert_error_pos, from + length, cs))
+    return 2;
+
+  return report_if_important_data(from_end_pos, from + length);
+}
+
+
+int Field_varstring::store(int64_t nr, bool unsigned_val)
+{
+  char buff[64];
+  uint  length;
+  length= (uint) (field_charset->cset->int64_t10_to_str)(field_charset,
+                                                          buff,
+                                                          sizeof(buff),
+                                                          (unsigned_val ? 10:
+                                                           -10),
+                                                           nr);
+  return Field_varstring::store(buff, length, field_charset);
+}
+
+
+double Field_varstring::val_real(void)
+{
+  int not_used;
+  char *end_not_used;
+  uint length= length_bytes == 1 ? (uint) *ptr : uint2korr(ptr);
+  return my_strntod(field_charset, (char*) ptr+length_bytes, length,
+                    &end_not_used, &not_used);
+}
+
+
+int64_t Field_varstring::val_int(void)
+{
+  int not_used;
+  char *end_not_used;
+  uint length= length_bytes == 1 ? (uint) *ptr : uint2korr(ptr);
+  return my_strntoll(field_charset, (char*) ptr+length_bytes, length, 10,
+                     &end_not_used, &not_used);
+}
+
+String *Field_varstring::val_str(String *val_buffer __attribute__((unused)),
+				 String *val_ptr)
+{
+  uint length=  length_bytes == 1 ? (uint) *ptr : uint2korr(ptr);
+  val_ptr->set((const char*) ptr+length_bytes, length, field_charset);
+  return val_ptr;
+}
+
+
+my_decimal *Field_varstring::val_decimal(my_decimal *decimal_value)
+{
+  uint length= length_bytes == 1 ? (uint) *ptr : uint2korr(ptr);
+  str2my_decimal(E_DEC_FATAL_ERROR, (char*) ptr+length_bytes, length,
+                 charset(), decimal_value);
+  return decimal_value;
+}
+
+
+int Field_varstring::cmp_max(const uchar *a_ptr, const uchar *b_ptr,
+                             uint max_len)
+{
+  uint a_length, b_length;
+  int diff;
+
+  if (length_bytes == 1)
+  {
+    a_length= (uint) *a_ptr;
+    b_length= (uint) *b_ptr;
+  }
+  else
+  {
+    a_length= uint2korr(a_ptr);
+    b_length= uint2korr(b_ptr);
+  }
+  set_if_smaller(a_length, max_len);
+  set_if_smaller(b_length, max_len);
+  diff= field_charset->coll->strnncollsp(field_charset,
+                                         a_ptr+
+                                         length_bytes,
+                                         a_length,
+                                         b_ptr+
+                                         length_bytes,
+                                         b_length,0);
+  return diff;
+}
+
+
+/**
+  @note
+    varstring and blob keys are ALWAYS stored with a 2 byte length prefix
+*/
+
+int Field_varstring::key_cmp(const uchar *key_ptr, uint max_key_length)
+{
+  uint length=  length_bytes == 1 ? (uint) *ptr : uint2korr(ptr);
+  uint local_char_length= max_key_length / field_charset->mbmaxlen;
+
+  local_char_length= my_charpos(field_charset, ptr + length_bytes,
+                          ptr + length_bytes + length, local_char_length);
+  set_if_smaller(length, local_char_length);
+  return field_charset->coll->strnncollsp(field_charset, 
+                                          ptr + length_bytes,
+                                          length,
+                                          key_ptr+
+                                          HA_KEY_BLOB_LENGTH,
+                                          uint2korr(key_ptr), 0);
+}
+
+
+/**
+  Compare to key segments (always 2 byte length prefix).
+
+  @note
+    This is used only to compare key segments created for index_read().
+    (keys are created and compared in key.cc)
+*/
+
+int Field_varstring::key_cmp(const uchar *a,const uchar *b)
+{
+  return field_charset->coll->strnncollsp(field_charset,
+                                          a + HA_KEY_BLOB_LENGTH,
+                                          uint2korr(a),
+                                          b + HA_KEY_BLOB_LENGTH,
+                                          uint2korr(b),
+                                          0);
+}
+
+
+void Field_varstring::sort_string(uchar *to,uint length)
+{
+  uint tot_length=  length_bytes == 1 ? (uint) *ptr : uint2korr(ptr);
+
+  if (field_charset == &my_charset_bin)
+  {
+    /* Store length last in high-byte order to sort longer strings first */
+    if (length_bytes == 1)
+      to[length-1]= tot_length;
+    else
+      mi_int2store(to+length-2, tot_length);
+    length-= length_bytes;
+  }
+ 
+  tot_length= my_strnxfrm(field_charset,
+			  to, length, ptr + length_bytes,
+			  tot_length);
+  assert(tot_length == length);
+}
+
+
+enum ha_base_keytype Field_varstring::key_type() const
+{
+  enum ha_base_keytype res;
+
+  if (binary())
+    res= length_bytes == 1 ? HA_KEYTYPE_VARBINARY1 : HA_KEYTYPE_VARBINARY2;
+  else
+    res= length_bytes == 1 ? HA_KEYTYPE_VARTEXT1 : HA_KEYTYPE_VARTEXT2;
+  return res;
+}
+
+
+void Field_varstring::sql_type(String &res) const
+{
+  THD *thd= table->in_use;
+  CHARSET_INFO *cs=res.charset();
+  ulong length;
+
+  length= cs->cset->snprintf(cs,(char*) res.ptr(),
+                             res.alloced_length(), "%s(%d)",
+                              (has_charset() ? "varchar" : "varbinary"),
+                             (int) field_length / charset()->mbmaxlen);
+  res.length(length);
+  if ((thd->variables.sql_mode & (MODE_MYSQL323 | MODE_MYSQL40)) &&
+      has_charset() && (charset()->state & MY_CS_BINSORT))
+    res.append(STRING_WITH_LEN(" binary"));
+}
+
+
+uint32 Field_varstring::data_length()
+{
+  return length_bytes == 1 ? (uint32) *ptr : uint2korr(ptr);
+}
+
+uint32 Field_varstring::used_length()
+{
+  return length_bytes == 1 ? 1 + (uint32) (uchar) *ptr : 2 + uint2korr(ptr);
+}
+
+/*
+  Functions to create a packed row.
+  Here the number of length bytes are depending on the given max_length
+*/
+
+uchar *Field_varstring::pack(uchar *to, const uchar *from,
+                             uint max_length,
+                             bool low_byte_first __attribute__((unused)))
+{
+  uint length= length_bytes == 1 ? (uint) *from : uint2korr(from);
+  set_if_smaller(max_length, field_length);
+  if (length > max_length)
+    length=max_length;
+
+  /* Length always stored little-endian */
+  *to++= length & 0xFF;
+  if (max_length > 255)
+    *to++= (length >> 8) & 0xFF;
+
+  /* Store bytes of string */
+  if (length > 0)
+    memcpy(to, from+length_bytes, length);
+  return to+length;
+}
+
+
+uchar *
+Field_varstring::pack_key(uchar *to, const uchar *key, uint max_length,
+                          bool low_byte_first __attribute__((unused)))
+{
+  uint length=  length_bytes == 1 ? (uint) *key : uint2korr(key);
+  uint local_char_length= ((field_charset->mbmaxlen > 1) ?
+                     max_length/field_charset->mbmaxlen : max_length);
+  key+= length_bytes;
+  if (length > local_char_length)
+  {
+    local_char_length= my_charpos(field_charset, key, key+length,
+                                  local_char_length);
+    set_if_smaller(length, local_char_length);
+  }
+  *to++= (char) (length & 255);
+  if (max_length > 255)
+    *to++= (char) (length >> 8);
+  if (length)
+    memcpy(to, key, length);
+  return to+length;
+}
+
+
+/**
+  Unpack a key into a record buffer.
+
+  A VARCHAR key has a maximum size of 64K-1.
+  In its packed form, the length field is one or two bytes long,
+  depending on 'max_length'.
+
+  @param to                          Pointer into the record buffer.
+  @param key                         Pointer to the packed key.
+  @param max_length                  Key length limit from key description.
+
+  @return
+    Pointer to end of 'key' (To the next key part if multi-segment key)
+*/
+
+const uchar *
+Field_varstring::unpack_key(uchar *to __attribute__((__unused__)),
+                            const uchar *key, uint max_length,
+                            bool low_byte_first __attribute__((unused)))
+{
+  /* get length of the blob key */
+  uint32 length= *key++;
+  if (max_length > 255)
+    length+= (*key++) << 8;
+
+  /* put the length into the record buffer */
+  if (length_bytes == 1)
+    *ptr= (uchar) length;
+  else
+    int2store(ptr, length);
+  memcpy(ptr + length_bytes, key, length);
+  return key + length;
+}
+
+/**
+  Create a packed key that will be used for storage in the index tree.
+
+  @param to		Store packed key segment here
+  @param from		Key segment (as given to index_read())
+  @param max_length  	Max length of key
+
+  @return
+    end of key storage
+*/
+
+uchar *
+Field_varstring::pack_key_from_key_image(uchar *to, const uchar *from, uint max_length,
+                                         bool low_byte_first __attribute__((unused)))
+{
+  /* Key length is always stored as 2 bytes */
+  uint length= uint2korr(from);
+  if (length > max_length)
+    length= max_length;
+  *to++= (char) (length & 255);
+  if (max_length > 255)
+    *to++= (char) (length >> 8);
+  if (length)
+    memcpy(to, from+HA_KEY_BLOB_LENGTH, length);
+  return to+length;
+}
+
+
+/**
+   Unpack a varstring field from row data.
+
+   This method is used to unpack a varstring field from a master
+   whose size of the field is less than that of the slave.
+
+   @note
+   The string length is always packed little-endian.
+  
+   @param   to         Destination of the data
+   @param   from       Source of the data
+   @param   param_data Length bytes from the master's field data
+
+   @return  New pointer into memory based on from + length of the data
+*/
+const uchar *
+Field_varstring::unpack(uchar *to, const uchar *from,
+                        uint param_data,
+                        bool low_byte_first __attribute__((unused)))
+{
+  uint length;
+  uint l_bytes= (param_data && (param_data < field_length)) ? 
+                (param_data <= 255) ? 1 : 2 : length_bytes;
+  if (l_bytes == 1)
+  {
+    to[0]= *from++;
+    length= to[0];
+    if (length_bytes == 2)
+      to[1]= 0;
+  }
+  else /* l_bytes == 2 */
+  {
+    length= uint2korr(from);
+    to[0]= *from++;
+    to[1]= *from++;
+  }
+  if (length)
+    memcpy(to+ length_bytes, from, length);
+  return from+length;
+}
+
+
+int Field_varstring::pack_cmp(const uchar *a, const uchar *b,
+                              uint key_length_arg,
+                              my_bool insert_or_update)
+{
+  uint a_length, b_length;
+  if (key_length_arg > 255)
+  {
+    a_length=uint2korr(a); a+= 2;
+    b_length=uint2korr(b); b+= 2;
+  }
+  else
+  {
+    a_length= (uint) *a++;
+    b_length= (uint) *b++;
+  }
+  return field_charset->coll->strnncollsp(field_charset,
+                                          a, a_length,
+                                          b, b_length,
+                                          insert_or_update);
+}
+
+
+int Field_varstring::pack_cmp(const uchar *b, uint key_length_arg,
+                              my_bool insert_or_update)
+{
+  uchar *a= ptr+ length_bytes;
+  uint a_length=  length_bytes == 1 ? (uint) *ptr : uint2korr(ptr);
+  uint b_length;
+  uint local_char_length= ((field_charset->mbmaxlen > 1) ?
+                           key_length_arg / field_charset->mbmaxlen :
+                           key_length_arg);
+
+  if (key_length_arg > 255)
+  {
+    b_length=uint2korr(b); b+= HA_KEY_BLOB_LENGTH;
+  }
+  else
+    b_length= (uint) *b++;
+
+  if (a_length > local_char_length)
+  {
+    local_char_length= my_charpos(field_charset, a, a+a_length,
+                                  local_char_length);
+    set_if_smaller(a_length, local_char_length);
+  }
+
+  return field_charset->coll->strnncollsp(field_charset,
+                                          a, a_length,
+                                          b, b_length,
+                                          insert_or_update);
+}
+
+
+uint Field_varstring::packed_col_length(const uchar *data_ptr, uint length)
+{
+  if (length > 255)
+    return uint2korr(data_ptr)+2;
+  return (uint) *data_ptr + 1;
+}
+
+
+uint Field_varstring::max_packed_col_length(uint max_length)
+{
+  return (max_length > 255 ? 2 : 1)+max_length;
+}
+
+uint Field_varstring::get_key_image(uchar *buff,
+                                    uint length,
+                                    imagetype type __attribute__((__unused__)))
+{
+  uint f_length=  length_bytes == 1 ? (uint) *ptr : uint2korr(ptr);
+  uint local_char_length= length / field_charset->mbmaxlen;
+  uchar *pos= ptr+length_bytes;
+  local_char_length= my_charpos(field_charset, pos, pos + f_length,
+                                local_char_length);
+  set_if_smaller(f_length, local_char_length);
+  /* Key is always stored with 2 bytes */
+  int2store(buff,f_length);
+  memcpy(buff+HA_KEY_BLOB_LENGTH, pos, f_length);
+  if (f_length < length)
+  {
+    /*
+      Must clear this as we do a memcmp in opt_range.cc to detect
+      identical keys
+    */
+    bzero(buff+HA_KEY_BLOB_LENGTH+f_length, (length-f_length));
+  }
+  return HA_KEY_BLOB_LENGTH+f_length;
+}
+
+
+void Field_varstring::set_key_image(const uchar *buff,uint length)
+{
+  length= uint2korr(buff);			// Real length is here
+  (void) Field_varstring::store((const char*) buff+HA_KEY_BLOB_LENGTH, length,
+                                field_charset);
+}
+
+
+int Field_varstring::cmp_binary(const uchar *a_ptr, const uchar *b_ptr,
+                                uint32 max_length)
+{
+  uint32 a_length,b_length;
+
+  if (length_bytes == 1)
+  {
+    a_length= (uint) *a_ptr;
+    b_length= (uint) *b_ptr;
+  }
+  else
+  {
+    a_length= uint2korr(a_ptr);
+    b_length= uint2korr(b_ptr);
+  }
+  set_if_smaller(a_length, max_length);
+  set_if_smaller(b_length, max_length);
+  if (a_length != b_length)
+    return 1;
+  return memcmp(a_ptr+length_bytes, b_ptr+length_bytes, a_length);
+}
+
+
+Field *Field_varstring::new_field(MEM_ROOT *root, struct st_table *new_table,
+                                  bool keep_type)
+{
+  Field_varstring *res= (Field_varstring*) Field::new_field(root, new_table,
+                                                            keep_type);
+  if (res)
+    res->length_bytes= length_bytes;
+  return res;
+}
+
+
+Field *Field_varstring::new_key_field(MEM_ROOT *root,
+                                      struct st_table *new_table,
+                                      uchar *new_ptr, uchar *new_null_ptr,
+                                      uint new_null_bit)
+{
+  Field_varstring *res;
+  if ((res= (Field_varstring*) Field::new_key_field(root,
+                                                    new_table,
+                                                    new_ptr,
+                                                    new_null_ptr,
+                                                    new_null_bit)))
+  {
+    /* Keys length prefixes are always packed with 2 bytes */
+    res->length_bytes= 2;
+  }
+  return res;
+}
+
+
+uint Field_varstring::is_equal(Create_field *new_field)
+{
+  if (new_field->sql_type == real_type() &&
+      new_field->charset == field_charset)
+  {
+    if (new_field->length == max_display_length())
+      return IS_EQUAL_YES;
+    if (new_field->length > max_display_length() &&
+	((new_field->length <= 255 && max_display_length() <= 255) ||
+	 (new_field->length > 255 && max_display_length() > 255)))
+      return IS_EQUAL_PACK_LENGTH; // VARCHAR, longer variable length
+  }
+  return IS_EQUAL_NO;
+}
+
+
+void Field_varstring::hash(ulong *nr, ulong *nr2)
+{
+  if (is_null())
+  {
+    *nr^= (*nr << 1) | 1;
+  }
+  else
+  {
+    uint len=  length_bytes == 1 ? (uint) *ptr : uint2korr(ptr);
+    CHARSET_INFO *cs= charset();
+    cs->coll->hash_sort(cs, ptr + length_bytes, len, nr, nr2);
+  }
+}
+
+

=== added file 'server/field/varstring.h'
--- server/field/varstring.h	1970-01-01 00:00:00 +0000
+++ server/field/varstring.h	2008-07-18 07:06:52 +0000
@@ -0,0 +1,118 @@
+/* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 MySQL
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLE_SERVER_FIELD_VARSTRING
+#define DRIZZLE_SERVER_FIELD_VARSTRING
+
+#include "mysql_priv.h"
+
+class Field_varstring :public Field_longstr {
+public:
+  /*
+    The maximum space available in a Field_varstring, in bytes. See
+    length_bytes.
+  */
+  static const uint MAX_SIZE;
+  /* Store number of bytes used to store length (1 or 2) */
+  uint32 length_bytes;
+  Field_varstring(uchar *ptr_arg,
+                  uint32 len_arg, uint length_bytes_arg,
+                  uchar *null_ptr_arg, uchar null_bit_arg,
+		  enum utype unireg_check_arg, const char *field_name_arg,
+		  TABLE_SHARE *share, CHARSET_INFO *cs)
+    :Field_longstr(ptr_arg, len_arg, null_ptr_arg, null_bit_arg,
+                   unireg_check_arg, field_name_arg, cs),
+     length_bytes(length_bytes_arg)
+  {
+    share->varchar_fields++;
+  }
+  Field_varstring(uint32 len_arg,bool maybe_null_arg,
+                  const char *field_name_arg,
+                  TABLE_SHARE *share, CHARSET_INFO *cs)
+    :Field_longstr((uchar*) 0,len_arg, maybe_null_arg ? (uchar*) "": 0, 0,
+                   NONE, field_name_arg, cs),
+     length_bytes(len_arg < 256 ? 1 :2)
+  {
+    share->varchar_fields++;
+  }
+
+  enum_field_types type() const { return MYSQL_TYPE_VARCHAR; }
+  enum ha_base_keytype key_type() const;
+  uint row_pack_length() { return field_length; }
+  bool zero_pack() const { return 0; }
+  int  reset(void) { bzero(ptr,field_length+length_bytes); return 0; }
+  uint32 pack_length() const { return (uint32) field_length+length_bytes; }
+  uint32 key_length() const { return (uint32) field_length; }
+  uint32 sort_length() const
+  {
+    return (uint32) field_length + (field_charset == &my_charset_bin ?
+                                    length_bytes : 0);
+  }
+  int  store(const char *to,uint length,CHARSET_INFO *charset);
+  int  store(int64_t nr, bool unsigned_val);
+  int  store(double nr) { return Field_str::store(nr); } /* QQ: To be deleted */
+  double val_real(void);
+  int64_t val_int(void);
+  String *val_str(String*,String *);
+  my_decimal *val_decimal(my_decimal *);
+  int cmp_max(const uchar *, const uchar *, uint max_length);
+  int cmp(const uchar *a,const uchar *b)
+  {
+    return cmp_max(a, b, ~0L);
+  }
+  void sort_string(uchar *buff,uint length);
+  uint get_key_image(uchar *buff,uint length, imagetype type);
+  void set_key_image(const uchar *buff,uint length);
+  void sql_type(String &str) const;
+  virtual uchar *pack(uchar *to, const uchar *from,
+                      uint max_length, bool low_byte_first);
+  uchar *pack_key(uchar *to, const uchar *from, uint max_length, bool low_byte_first);
+  uchar *pack_key_from_key_image(uchar* to, const uchar *from,
+                                 uint max_length, bool low_byte_first);
+  virtual const uchar *unpack(uchar* to, const uchar *from,
+                              uint param_data, bool low_byte_first);
+  const uchar *unpack_key(uchar* to, const uchar *from,
+                          uint max_length, bool low_byte_first);
+  int pack_cmp(const uchar *a, const uchar *b, uint key_length,
+               my_bool insert_or_update);
+  int pack_cmp(const uchar *b, uint key_length,my_bool insert_or_update);
+  int cmp_binary(const uchar *a,const uchar *b, uint32 max_length=~0L);
+  int key_cmp(const uchar *,const uchar*);
+  int key_cmp(const uchar *str, uint length);
+  uint packed_col_length(const uchar *to, uint length);
+  uint max_packed_col_length(uint max_length);
+  uint32 data_length();
+  uint32 used_length();
+  uint size_of() const { return sizeof(*this); }
+  enum_field_types real_type() const { return MYSQL_TYPE_VARCHAR; }
+  bool has_charset(void) const
+  { return charset() == &my_charset_bin ? false : true; }
+  Field *new_field(MEM_ROOT *root, struct st_table *new_table, bool keep_type);
+  Field *new_key_field(MEM_ROOT *root, struct st_table *new_table,
+                       uchar *new_ptr, uchar *new_null_ptr,
+                       uint new_null_bit);
+  uint is_equal(Create_field *new_field);
+  void hash(ulong *nr, ulong *nr2);
+private:
+  int do_save_field_metadata(uchar *first_byte);
+};
+
+#endif
+

=== added file 'server/field/year.cc'
--- server/field/year.cc	1970-01-01 00:00:00 +0000
+++ server/field/year.cc	2008-07-18 03:07:08 +0000
@@ -0,0 +1,142 @@
+/* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 MySQL
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifdef USE_PRAGMA_IMPLEMENTATION
+#pragma implementation				// gcc: Class implementation
+#endif
+
+#include "year.h"
+
+/****************************************************************************
+** year type
+** Save in a byte the year 0, 1901->2155
+** Can handle 2 byte or 4 byte years!
+****************************************************************************/
+
+int Field_year::store(const char *from, uint len,CHARSET_INFO *cs)
+{
+  char *end;
+  int error;
+  int64_t nr= cs->cset->strntoull10rnd(cs, from, len, 0, &end, &error);
+
+  if (nr < 0 || (nr >= 100 && nr <= 1900) || nr > 2155 || 
+      error == MY_ERRNO_ERANGE)
+  {
+    *ptr=0;
+    set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
+    return 1;
+  }
+  if (table->in_use->count_cuted_fields && 
+      (error= check_int(cs, from, len, end, error)))
+  {
+    if (error == 1)  /* empty or incorrect string */
+    {
+      *ptr= 0;
+      return 1;
+    }
+    error= 1;
+  }
+
+  if (nr != 0 || len != 4)
+  {
+    if (nr < YY_PART_YEAR)
+      nr+=100;					// 2000 - 2069
+    else if (nr > 1900)
+      nr-= 1900;
+  }
+  *ptr= (char) (uchar) nr;
+  return error;
+}
+
+
+int Field_year::store(double nr)
+{
+  if (nr < 0.0 || nr >= 2155.0)
+  {
+    (void) Field_year::store((int64_t) -1, false);
+    return 1;
+  }
+  return Field_year::store((int64_t) nr, false);
+}
+
+
+int Field_year::store(int64_t nr,
+                      bool unsigned_val __attribute__((__unused__)))
+{
+  if (nr < 0 || (nr >= 100 && nr <= 1900) || nr > 2155)
+  {
+    *ptr= 0;
+    set_warning(MYSQL_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_OUT_OF_RANGE, 1);
+    return 1;
+  }
+  if (nr != 0 || field_length != 4)		// 0000 -> 0; 00 -> 2000
+  {
+    if (nr < YY_PART_YEAR)
+      nr+=100;					// 2000 - 2069
+    else if (nr > 1900)
+      nr-= 1900;
+  }
+  *ptr= (char) (uchar) nr;
+  return 0;
+}
+
+
+bool Field_year::send_binary(Protocol *protocol)
+{
+  uint64_t tmp= Field_year::val_int();
+  return protocol->store_short(tmp);
+}
+
+
+double Field_year::val_real(void)
+{
+  return (double) Field_year::val_int();
+}
+
+
+int64_t Field_year::val_int(void)
+{
+  int tmp= (int) ptr[0];
+  if (field_length != 4)
+    tmp%=100;					// Return last 2 char
+  else if (tmp)
+    tmp+=1900;
+  return (int64_t) tmp;
+}
+
+
+String *Field_year::val_str(String *val_buffer,
+			    String *val_ptr __attribute__((unused)))
+{
+  val_buffer->alloc(5);
+  val_buffer->length(field_length);
+  char *to=(char*) val_buffer->ptr();
+  sprintf(to,field_length == 2 ? "%02d" : "%04d",(int) Field_year::val_int());
+  return val_buffer;
+}
+
+
+void Field_year::sql_type(String &res) const
+{
+  CHARSET_INFO *cs=res.charset();
+  res.length(cs->cset->snprintf(cs,(char*)res.ptr(),res.alloced_length(),
+			  "year(%d)",(int) field_length));
+}
+

=== added file 'server/field/year.h'
--- server/field/year.h	1970-01-01 00:00:00 +0000
+++ server/field/year.h	2008-07-18 03:07:08 +0000
@@ -0,0 +1,47 @@
+/* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 MySQL
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLE_SERVER_FIELD_YEAR
+#define DRIZZLE_SERVER_FIELD_YEAR
+
+#include "mysql_priv.h"
+
+class Field_year :public Field_tiny {
+public:
+  Field_year(uchar *ptr_arg, uint32 len_arg, uchar *null_ptr_arg,
+	     uchar null_bit_arg,
+	     enum utype unireg_check_arg, const char *field_name_arg)
+    :Field_tiny(ptr_arg, len_arg, null_ptr_arg, null_bit_arg,
+		unireg_check_arg, field_name_arg, 1, 1)
+    {}
+  enum_field_types type() const { return MYSQL_TYPE_YEAR;}
+  int  store(const char *to,uint length,CHARSET_INFO *charset);
+  int  store(double nr);
+  int  store(int64_t nr, bool unsigned_val);
+  double val_real(void);
+  int64_t val_int(void);
+  String *val_str(String*,String *);
+  bool send_binary(Protocol *protocol);
+  void sql_type(String &str) const;
+  bool can_be_compared_as_int64_t() const { return true; }
+};
+
+#endif
+

=== modified file 'server/mysql_priv.h'
--- server/mysql_priv.h	2008-07-20 07:25:05 +0000
+++ server/mysql_priv.h	2008-07-22 05:25:22 +0000
@@ -667,7 +667,10 @@
 #include "handler.h"
 #include "table.h"
 #include "sql_error.h"
-#include "field.h"				/* Field definitions */
+
+/* Field definitions */
+#include "field.h"
+
 #include "protocol.h"
 #include "sql_udf.h"
 

=== modified file 'tests/stress-test.pl' (properties changed: +x to -x)
